* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
*                                                      Version: 2005
*
*  DISCA-C/05 
*
*
* Itranuclear cascade evaporation model with clusters
*
*
*
*
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      CHARACTER NAMRD*8, IDPA*1, NAMPAR(3)*1, C80*80
      REAL*8 INFGEN                                         
      COMMON/DATINI/RA,T0,W0 /NPROL/NPROL/KHIST/KHIST 
      COMMON/CSABS/CSABS,FIALP2 /INFGEN/INFGEN(9) /IWRI/IWRI 
      COMMON/EOUT/SPE(19,5,3),PI(19),EOUT1(5,3),EOUT2(5,3),MSPE
      COMMON/SPEFUL/ANGLIM(9,2,3),ANGSUM(21,9,3),ANGCEN(9,3),DCEN,MANG
      COMMON/TEMP2/BONNE /XPARAM/XPARAM,FIALPH /NREJ/REFR,NREJ
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/EVA/PARALP,PARPRO /INFDIS/INFDIS,INFOUP(3)
      COMMON/MAIIPR/IPR /AN/AN  /INF/INFBIG,INFS0 
      COMMON/IDOPCS/IDOPCS /MPARIN/MPARIN /MAX/MAXNEU,MAXPRO                                       
      COMMON/INF001/INFKAL /INF002/INFDOS 
      COMMON/INF003/INFDEN /INF004/KHIST0 /INFBON/IBOND 
      COMMON/INF005/INFDM /INFSEP/KSEP(100,4),INFSEP,JSEPM                         
      COMMON/LIB91/WINLIB(100,250),INFLIB                                  
      COMMON/K1996/K1996 /FICAP/FICAP,MZONA
      DATA NAMPAR/1HN,1HP,1HA/
C
C Input data file
C
      Open(5,file='disca.dat')
C
C  INPUT CARD 1
C**************
C------------------------------------------------------------------------ 
C
C   NAMRD: Name of output files Namrd.XXX
C------------------------------------------------------------------------ 
             Read(5,111)Namrd
111          Format(a8)
C
      CALL OPEN_OUTPUT_FILES(NAMRD)
C
C
C Define general options for calculations
C
      CALL OPTIONS(IPR,BONNE,IWRI,INFKAL)
C
C  INPUT CARD 2
C**************
C------------------------------------------------------------------------ 
C
C   INFGEN(): Text from 72 symbols will be printed in output file
C------------------------------------------------------------------------ 
          READ(5,1900)(INFGEN(I),I=1,9)                                 
C
C
C  INPUT CARD 3
C**************                                                                       
C------------------------------------------------------------------------ 
C                                                                       
C     INFBIG       : defines the bulk of the printed results of 
C                    calculation
C             = 0  : most appropriate information will printed; the
C                    arrays of COMMON Block MASOUT are not used in
C                    counting of events
C             = 1  : additional information about options and parameters
C                    of calculation
C             = 2  : printing of the lumped cross-sections and displa-
C                    cement cross-sections for reactions (1988)
C             = 3  : the same as =2, but detail information for
C                    reactions (1988)
C Recommended: INFBIG=0
C                                                                       
C     INFS0        : defines the type of nonelastic cross-section
C                    used for normalization of the cross-sections 
C                    and particle spectra obtained
C             = 1  : data taken from Barashenkov, JINR, R2-89-770, 
C                    1989 (Subr BARASH) 
C             = 2  : nonelastic cross-section is calculated by the code
C                    using the INC model 
C             = 3  : data taken from input file (unit=5) is used
C             = 4  : nonelastic cross-section is calculated according
C                    to Chatterjee A. et al, IAEA,INDC(IND)- 27/GJ, 1980
C                    Valid only for incident particle energies below
C                    50 MeV. For primary alpha-particles INFS0 is turned
C                    to 1.
C Recommended: INFS0=1
C                                                                       
C     INFSCR       : screen printing option for each Monte Carlo event 
C                    proceeded, = 1  yes,  = 0 no.
C Recommended: INSCR=1
C                                                                       
C     INFDOS       : defines the Coulomb potential calculations for inve-
C                    rse reaction cross-sections (not used since 1996)     
C             = 0  : Coulomb potential is taken according to M.Blann
C             = 1  : Coulomb potential is calculated according to 
C                    V.M.Bychkov et al, 1982
C Recommended: INFDOS=0
C
C     INFDEN       : level density parameter calculation
C             = 0  : a=A/XPARDE,  ( XPARDE defined below )                     
C             = 1-4: not used since 1996
C If INFDEN increased by 10, the non-equilibrium component of the triton,
C and He-3 production cross-section is calculated according to the 
C "nuclear bond breakdown" model of  F.P.Denisov, V.N. Mekhedov, 
C "Nuclear Reactions at High Energies", Atomizdat, Moscow 1972, p.112
C Recommended: INFDOS=10
C
C     INFSEP       : option for printing of cross-sections for separate
C                    reactions
C             = 0  : no printing
C             = 1  : print cross-sections for reactions identified by
C                    the number of neutrons, protons and alphas escaped.
C                    For example for reactions (n,6np2a),(n,2n10p) one
C                    should insert two lines with
C                     6 1 2
C                    -2 10 0
C                    (minus means the end of reaction list ( < 100 )                    more than 100)
C             = 2  : as =1, but reaction is identified by Z and A for 
C                    residual nucleus. For example, for reactions
C                    resulting to nuclides 26. 55. and 25. 54. one should
C                    insert
C                     26. 55.
C                    -25. 54.
C If INFSEP increased by 10, the alpha particle production cross-section
C and its non-equilibrium component will printed in file NAMRD.ALP
C Recommended: INFSEP=10, 11 or 12
C
C------------------------------------------------------------------------
          READ(5,*)INFBIG,INFS0,INFSCR,INFDOS,INFDEN,INFSEP
C
          INFLIB=0
          IF(INFSEP.GE.10) INFLIB=1
          IF(INFSEP.GE.10) INFSEP=INFSEP-10
      IF(INFSEP.EQ.1) CALL INSEP
      IF(INFSEP.EQ.2) CALL INSEP2
      INFDM=0
      IF(INFDEN.GE.10)INFDM=1
      IF(INFDEN.GE.10)INFDEN=INFDEN-10
C
C INPUT CARD GROUP 4 (or depends from number of reactions by INFSEP)
C*******************
C------------------------------------------------------------------------
C
C Read angles and energies to store characteristics of secondary particles
C
C    The double differential cross-sections are calculated for selected
C angles +/- DCEN (DCEN defined in Subr INIDAT) and selected energy ranges.
C    The first symbol in each line identifies an outgoing particle. Use 
C N,P and/or A only.
C    Nine angles (degrees) are read for each secondary particle by format 
C (1X,9F6.1) for the double differential cross-section d^2S/dOdE calcula-
C tion depending from particle emission energy (mb/MeV/sr) and five energy
C intervals (MeV) by format (1X, 5(F6.1,1X,F5.1)) for the double differen-
C tial cross-section calculation depending from emission angle (mb/MeV/sr)
C Example
CN   5.0  20.0  40.0  60.0  80.0 100.0 120.0 140.0 160.0  
C   40.0- 50.0  80.0- 90.0 100.0-120.0 110.0-140.0 200.0-300.0
CP   5.0  20.0  40.0  60.0  80.0 100.0 120.0 140.0 160.0  
C   40.0- 50.0  80.0- 90.0 100.0-120.0 110.0-140.0 200.0-300.0                        
C
C Note. Angles and energies relate to LCS system. Data can be introduced 
C for different particles in arbitrary order. Any particle types can be 
C omitted.
C------------------------------------------------------------------------ 
C
          INFDIS   =0
          INFOUP(1)=0
          INFOUP(2)=0
          INFOUP(3)=0
                    MANG=9
                    MSPE=5
2900   READ(5,3001)IDPA
3001   FORMAT(A1)
       DO 3100 MP=1,3
       IF(IDPA.EQ.NAMPAR(MP) ) GOTO 3300
3100   CONTINUE
       GOTO 4500
3300       BACKSPACE 5
           INFOUP(MP)=1
           READ(5,5000)(ANGCEN(ICEN,MP),ICEN=1,9)
5000       FORMAT(1X,9F6.1)
           READ(5,5001)(EOUT1(LL,MP),EOUT2(LL,MP),LL=1,5)
5001       FORMAT(1X, 5(F6.1,1X,F5.1) )
           GOTO 2900
4500   BACKSPACE 5   
       IF(INFOUP(1).EQ.1.OR.INFOUP(2).EQ.1.OR.INFOUP(3).EQ.1)INFDIS=1
       IF(INFDIS.EQ.0)PRINT 3200
C
C
C INPUT CARD 5
C*************
C------------------------------------------------------------------------
C
C     FIALPH       : the relative number of alpha-clusters in nucleus.
C                    Typical FIALPH values are from 0.05 to 0.1                                                   
C                                                                       
C     XPARDE       : defines level density parameter for equilibrium
C                    states, a = A/XPARDE. (XPARDE =8...10)
C
C     FICAP        : defines the pick-up probability for t ar He-3 
C                    cluster resulting to alpha-particle formation.
C                    FICAP is about 14.
C                                                                       
C     MZONA        : number of nuclear zone, beginning with which the 
C                    non-equilibrium effects with alpha clusters are 
C                    considered. The zones are counted from center of
C                    the nucleus. (MZONA depends from KZONESC value)
C                    Typical value is 1...5 for ten nuclear zones 
C                    (KZONESC=0)
C  
C     KZONESC      : defines number of zones with constant density in
C                    the nucleus approximating Wood-Saxon density distri-
C                    bution 
C         = 0 or 1 : 10 zones. The division of the density distribution 
C                    is defined by A1( ) array in Subr INIDAT. The most
C                    remote zone corresponds to the nuclear density 0.01 
C                    of the density at the center.
C         = 2      : 33 zones. The division is defined by A2( ) array 
C                    in Subr INIDAT. The most remote zone corresponds to 
C                    the nuclear density 1.E-05 of the density at the
C                    center.
C Recommended: KZONESC=0 
C                                                                       
C------------------------------------------------------------------------
           READ(5,*)FIALPH,XPARDE,FICAP,MZONA,KZONESC
C
       XPARAM=1./XPARDE                                                 
                                      FI=FIALPH  
C
C
C IBOND defines the method of the particle binding energy calculation
C        = 3 : the separation energy for neutrons, protons, deuterons
C              and alpha-particles is calculated using the table of 
C              experimental masses and MSL-formula (M.Blann, Report 
C              LLL(USA), UCID19614(1982)) for nuclei with 
C              Z - Z(compound) < 9 and N - N(COMPOUND) < 22. For other
C              cases the Cameron formula is used.
C        = 2 : use the Cameron formula
C        = 1 : not used since 1993
C If IBOND  < 0   : test printing for selected ABS(IBOND) option
C
      IBOND=3                                                 
      IBONDS=IABS(IBOND)
C                                                                       
C PARALP and PARPRO are normalization coefficients for "old"
C Dostrovsky et al formulas for iverse cross-sections
C (See also Barashenkov, Toneev, "Interaction...",1972, p.413)
          PARALP=1.                                                     
          PARPRO=1.                                                     
C
C
C INPUT CARD 6
C*************
C------------------------------------------------------------------------
C                                                                       
C     KHIST  :  the number of Monte Carlo events
C                                                                       
C------------------------------------------------------------------------
          READ(5,*)KHIST                                                  
C
      KHIST0=KHIST
C                                                                       
C
C INPUT CARD 7
C*************
C------------------------------------------------------------------------
C                                                                       
C     MPARIN defines projectile
C            = 1   : incident particle is neutron
C            = 2   : proton
C            = 3   : alpha-particle
C                                                                       
C     Z and AN  are atomic number and atomic mass number for target 
C               nucleus
C
C------------------------------------------------------------------------
          READ(5,*)MPARIN,Z,AN
C
      IF(MPARIN.eq.3) INFS0=1
      IF(INFSEP.EQ.2) CALL INSEP3(MPARIN,Z,AN)
1811      IF(AN.GT.219..AND.INFDEN.EQ.2) STOP
C                                                                       
                                      FIALPH=FI
C                                                                       
C
C INPUT CARD 8
C*************
C------------------------------------------------------------------------
C                                                                       
C     T0 is the energy of projectile (MeV)
C                                                                       
C------------------------------------------------------------------------
          READ(5,*)T0                                                     
C                                                                       
C
C INPUT CARD 9
C*************
C------------------------------------------------------------------------
C                                                                        
C The use of this and following cards relates as to old input of the
C code, as to new one.
C
C Simply, put new energy on this CARD in real format to continue 
C calculations or put nothing to stop calculations after the finish 
C of simulations with T0 energy.
C
C If no real value is found on this CARD, the variable is interpreted
C as IDOPCS value from old input (1987-1995) of the DISCA code. 
C    IDOPCS defines the reading of the nonelastic cross-section used
C            for normalization from input file (unit=5)
C            = 1   : yes                                  
C            = 0   : no                                               
C                                                                       
C------------------------------------------------------------------------
C Try to find new energy 
                                        IDOPCS=0
                                        ICONT=0
          READ(5,'(a80)',END=1819)C80
          DO IC80=1,80
          IF(C80(IC80:IC80).eq.'.')THEN
                                   BACKSPACE 5
                                   READ(5,*)TMP
                                   IF(TMP.ne.0.0) ICONT=1
                                   BACKSPACE 5
                                   GOTO 1819
                                   ENDIF 
          ENDDO
          BACKSPACE 5
          READ(5,*)IDOPCS                                                 

C
        IF(IDOPCS.NE.1)GOTO 1818                                        
C
C
C INPUT CARD 9A  (Old DISCA format. Read comment to CARD 9)
C**************
C------------------------------------------------------------------------
C                                                                       
C     CSABS is the nonelastic reaction cross-section (barn)
C           (only for IDOPCS=1)
C------------------------------------------------------------------------
          READ(5,*)CSABS                                                  
C
1818  continue
C                                                                       
C                                                                       
C
C INPUT CARD 9B  (Old DISCA format. Read comment to CARD 9)
C**************
C------------------------------------------------------------------------
C                                                                       
C     ICONT defines the continuation of the calculations for new incident
C           energy and new IDOPCS value
C                                                                       
C            = 1   : new energy              
C            = 0   : end of calculations 
C                                                                       
C------------------------------------------------------------------------
          READ(5,*)ICONT                                                  
C
1819  IF(INFLIB.EQ.1)  CALL ZERLIB
      PRINT 1987,T0,BONNE,KHIST,XPARAM                                  
         IF(IBONDS.LT.1.OR.IBONDS.GT.3)GOTO 97                          
         IF(INFBIG.GT.1.AND.INFS0.EQ.0)INFS0=1                          
         IF(INFS0.EQ.3.AND.IDOPCS.EQ.0)INFS0=1                          
         IF(INFKAL.NE.1.OR.T0.LE.60.)GOTO 100                           
           IF(IWRI.NE.0)WRITE(IWRI,1830)T0                              
           WRITE(IPR,1830)T0
           PRINT 1830,T0
           STOP
97                 IF(IWRI.NE.0)WRITE(IWRI,1840)IBOND                   
                   WRITE(IPR,1840)IBOND
                   PRINT 1840,IBOND
                   STOP
100   GOTO(101,102,103),IBONDS                                          
101          MAXNEU=13                                                  
             MAXPRO=9                                                   
             STOP
102     CALL PRECAM                                                     
           GOTO 104                                                     
103     CALL PRECAM                                                     
        CALL PRELYM                                                     
104   CONTINUE                                                          
           CALL ZERO1                                                        
           CALL INIDAT(KZONESC)
           CALL MASDAT                                                       
           CALL DENS
            IIII=-1                                                     
      KHIST=KHIST0
      DO 10 I=1,KHIST                                                   
            ISTOR=I
            IF(INFSCR.NE.1)GOTO 6                                       
            ICCC=I/500                                                  
            IF(ICCC.NE.IIII)PRINT 2000,I                                
            IF(ICCC.NE.IIII)IIII=ICCC                                   
C
C Label 10 is for normal end of MC history, Label 8 means too many reflec-
C tions (more than REFR), Label 40 means the dimension of arrays in not
C sufficient to proceed KHIST events
C
    6  CALL MODEL(IXX)                                                  
       GOTO(8,10,40),IXX
    8 NREJ=NREJ+1                                                       
   10 CONTINUE                                                          
   20 CALL OUTPUT                                                       
*           PRINT *,'K1996 = ',K1996
           IF(ICONT.EQ.1)GOTO 1811                                      
      STOP                                                              
   40 KHIST=ISTOR
      GOTO 20
C                                                                       
 1830 FORMAT(1X,'Old Kalbach,Mann parametrization is not valid for '
     +' T0 =',G12.5)                   
 1840 FORMAT(1X,'Incorrect IBOND number  ',I6)                       
 1987 FORMAT(1X,' T0=',F7.1,' BONNE=',F5.3,' KHIST=',I6/1X,' XPARAM=',  
     +F7.3)                                                             
 1900 FORMAT(9A8)                                                       
 2000 FORMAT(1X,'******* EVENT ',I6)                                    
 3200 FORMAT(1X,60('*')/1x,10x,'Characteritics of secondary particl',
     +'es are not stored'/1x,60('*'))
      END                                                               
************************************************************************
*                 SUBROUTINE A1B1B2                                    *
************************************************************************
      SUBROUTINE A1B1B2                                                 
      COMMON/FIGA1B/T1(16),BA1(16),BB1(16),BB2(9),BB3(8)                
      COMMON/ACTA1B/TREST /A1BNPD/S(4),PAR1 /AUXIL/ICOU1,ICOU2
        ICOU1=ICOU1+1
      I=1                                                               
   10 I=I+1                                                             
      IF(I.LE.16)GOTO 12                                                
        I=16
        ICOU2=ICOU2+1
        GOTO 20
   12 IF(TREST-T1(I))20,20,10                                           
   20 IF(I-9)40,40,30                                                   
   30 BBB=BB3(I-8)                                                      
      AAA=BB3(I-9)                                                      
      PAR1=0.14285714                                                   
      GOTO 50                                                           
   40 BBB=BB2(I)                                                        
      AAA=BB2(I-1)                                                      
      PAR1=0.2                                                          
   50 D2=T1(I)                                                          
      D1=T1(I-1)                                                        
      DT=D2-D1                                                          
      A1=TREST*(BA1(I)-BA1(I-1))/DT+(D2*BA1(I-1)-D1*BA1(I))/DT          
      B1=TREST*(BB1(I)-BB1(I-1))/DT+(D2*BB1(I-1)-D1*BB1(I))/DT          
      BB=TREST*(BBB-AAA)/DT+(D2*AAA-D1*BBB)/DT                          
      SUM=2.*A1+0.25*B1+PAR1*BB                                         
      S(1)=A1/SUM                                                       
      S(2)=S(1)+0.25*B1/SUM                                             
      S(3)=S(2)+S(1)                                                    
      S(4)=S(3)+PAR1*BB/SUM                                             
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE ACTIN                                     *
************************************************************************
      SUBROUTINE ACTIN(IKS)                                             
      COMMON/FIGA1B/T1(16),BA1(16),BB1(16),BB2(9),BB3(8)                
      COMMON/K/K /JACT/JACT                                                  
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/NDIM/NPAR  /PARTNR/PPX,PPY,PPZ,PP,MX                                   
      COMMON/TYPACT/L,L7 /ACTA1B/TREST                                               
      COMMON/ACTSCI/PINX1,PINY1,PINZ1,WPX,RK3,RK4,GAMMA,SK2,VC2,VCX,    
     *VCY,VCZ,MPX                                                       
      COMMON/URAND1/IYG                                                 
      IF(L.NE.6) GOTO 1
      CALL PICKUP(IKS)
      RETURN
    1 MPX=MX                                                            
      WPX=WM(MX)                                                        
      WPX2=WPX*WPX                                                      
      EP=SQRT(PP*PP+WPX2)                                               
      E1=E+EP                                                           
      VCX=(PX+PPX)/E1                                                   
      VCY=(PY+PPY)/E1                                                   
      VCZ=(PZ+PPZ)/E1                                                   
      SK1=PX*VCX+PY*VCY+PZ*VCZ                                          
      VC2=VCX*VCX+VCY*VCY+VCZ*VCZ                                       
      GAMMA=1./SQRT(1.-VC2)                                             
      EE=((GAMMA-1.)*SK1/VC2)-E*GAMMA                                   
      PINX=PX+EE*VCX                                                    
      PINY=PY+EE*VCY                                                    
      PINZ=PZ+EE*VCZ                                                    
      EIN=GAMMA*(E-SK1)                                                 
      TREST=(E*EP-PX*PPX-PY*PPY-PZ*PPZ)/WPX-WP                          
      CALL ANGLE(QSIN,QCOS,FISIN,FICOS)                                 
      IF(ABS(PINZ)-1.E-06)10,20,20                                      
   10 BX=0.                                                             
      BY=0.                                                             
      BZ=400.                                                           
      GOTO 30                                                           
   20 BX=400.                                                           
      BY=400.                                                           
      BZ=-400.*(PINX+PINY)/PINZ                                         
   30 B=SQRT(BX*BX+BY*BY+BZ*BZ)                                         
      PO2=PINX*PINX+PINY*PINY+PINZ*PINZ                                 
      EPIN=SQRT(PO2+WPX2)                                               
      RK0=QSIN/B                                                        
      RK1=RK0*FICOS*SQRT(PO2)                                           
      RK2=RK0*FISIN                                                     
      PINX1=RK1*BX+RK2*(PINY*BZ-PINZ*BY)+QCOS*PINX                      
      PINY1=RK1*BY+RK2*(PINZ*BX-PINX*BZ)+QCOS*PINY                      
      PINZ1=RK1*BZ+RK2*(PINX*BY-PINY*BX)+QCOS*PINZ                      
      SK2=PINX1*VCX+PINY1*VCY+PINZ1*VCZ                                 
      RK3=GAMMA*EIN                                                     
      RK4=GAMMA*EPIN                                                    
      TB1=RK3+GAMMA*SK2-WP                                              
      TP1=RK4-GAMMA*SK2-WPX                                             
      CALL PAULI(TB1,TP1,IKS)                                           
      RETURN                                                            
      END                                                               
************************************************************************
*                FUNCTION ANGKAL                                       *
************************************************************************
      FUNCTION ANGKAL(QCOS,E1)
C QCOS is cos required
      DIMENSION P(30)                                                
C P(1) value corresp to polynomial P(0)
      LMAX=9
      CALL LEGEN(QCOS,P)
C M=1 --- BKAL(0,E1)=1 ,P(1) -polynomial of (0) = 1
      S=1.
      DO 10 M=2,LMAX
10    S=S+BKAL((M-1),E1)*P(M)
      ANGKAL=S
      RETURN
      END
************************************************************************
*                 SUBROUTINE ANGLE                                     *
************************************************************************
      SUBROUTINE ANGLE(QSIN,QCOS,FISIN,FICOS)                           
      COMMON/FIGA1B/T1(16),BA1(16),BB1(16),BB2(9),BB3(8)                
      COMMON/TYPACT/L,L7
      COMMON/ACTA1B/TREST                                               
      COMMON/URAND1/IYG                                                 
      GOTO(10,20,30,40,40),L                                                     
   10 CALL NPDRAW(QCOS,FI)                                              
      QSIN=SQRT(ABS(1.-QCOS*QCOS))                                      
      FISIN=SIN(FI)                                                     
      FICOS=COS(FI)                                                     
      RETURN                                                            
   20 CALL PPDRAW(QCOS,FI)                                              
      QSIN=SQRT(ABS(1.-QCOS*QCOS))                                      
      FISIN=SIN(FI)                                                     
      FICOS=COS(FI)                                                     
      RETURN                                                            
* N-A interaction  
   30 T = TREST
      CALL NADRAW(T,QCOS,FI)                                              
      QSIN=SQRT(ABS(1.-QCOS*QCOS))                                      
      FISIN=SIN(FI)                                                     
      FICOS=COS(FI)                                                     
      RETURN                                                            
* A-N interaction   
   40 T = TREST/4.
      CALL NADRAW(T,QCOS,FI)                                              
      QSIN=SQRT(ABS(1.-QCOS*QCOS))                                      
      FISIN=SIN(FI)                                                     
      FICOS=COS(FI)                                                     
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE AUXANG                                    *
************************************************************************
      SUBROUTINE AUXANG                                                 
C Angular distributions acording to Kalbach, Mann phenomenology
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/MAIIPR/IPR /URAND1/IYG                                                 
          R=1.
          EKAL=TW
          RMAX=ANGKAL(R,EKAL)
       DO 100 I=1,100
C   Argument  QCOS=2.*X-1.
       C1=2.*RANDOMG(0)-1.
C   Function
       C2=RMAX*RANDOMG(0)
       RF=ANGKAL(C1,EKAL)
       IF(RF.GE.C2) GOTO 200
100    CONTINUE
       WRITE(IPR,150)RMAX,RF,C1,C2
150    FORMAT(1X,'Error: COS can not be obtained in Subr AUXANG'/
     * 1X,'RMAX=',G12.5,' RF=',G12.5/' C1=',G12.5,' C2=',G12.5)
       STOP
200    QCOS=C1
       QSIN=SQRT(1.-QCOS*QCOS)
       FI=6.283*RANDOMG(0)
          P=SQRT(TW*(TW+938.92635))
          PWZ=P*QCOS
          PWX=P*QSIN*COS(FI)
          PWY=P*QSIN*SIN(FI)
       RETURN
       END
************************************************************************
*               SUBROUTINE BARASH                                      *
************************************************************************
      SUBROUTINE BARASH(TEST,MPAR9,A9,T9,CSNON)
*
* Evaluated nonelastic cross-sections (mb) 
* Data taken from Barashenkov,JINR, R2-89-770,1989
* MPAR=1 : neutron incident; = 2 : proton
* IF TEST .ne. 0 : test printing
* A : Atomic mass number of target nucleus
* CSP(ENERGY,ATOMIC MASS) : proton cross-sections
* CSN(ENERGY,ATOMIC MASS) : neutron cross-sections
*
      DIMENSION CSP(46,12),CSN(46,12),ENERGY(46)
      DIMENSION CSPAL(46),CSPSI(46),CSPCA(46),CSPFE(46),CSPCU(46),
     1          CSPMO(46),CSPCD(46),CSPSN(46),CSPW(46),CSPPB(46),
     2          CSPU(46),CSPNA(46)
      DIMENSION CSNAL(46),CSNSI(46),CSNCA(46),CSNFE(46),CSNCU(46),
     3          CSNMO(46),CSNCD(46),CSNSN(46),CSNW(46),CSNPB(46),
     4          CSNU(46),CSNNA(46)
      DIMENSION RIDENT(12)
      DIMENSION AELEM(12)
      DIMENSION PPN(6),PPP(6)
      EQUIVALENCE (CSP(1),CSPNA(1)
     +),    (CSP(47),CSPAL(1)),(CSP(93),CSPSI(1)),(CSP(139),CSPCA(1)
     +),    (CSP(185),CSPFE(1)),(CSP(231),CSPCU(1)),(CSP(277),CSPMO(1)
     +),    (CSP(323),CSPCD(1)),(CSP(369),CSPSN(1)),(CSP(415),CSPW(1)
     +),    (CSP(461),CSPPB(1)),(CSP(507),CSPU(1))
      EQUIVALENCE (CSN(1),CSNNA(1)
     +),    (CSN(47),CSNAL(1)),(CSN(93),CSNSI(1)),(CSN(139),CSNCA(1)
     +),    (CSN(185),CSNFE(1)),(CSN(231),CSNCU(1)),(CSN(277),CSNMO(1)
     +),    (CSN(323),CSNCD(1)),(CSN(369),CSNSN(1)),(CSN(415),CSNW(1)
     +),    (CSN(461),CSNPB(1)),(CSN(507),CSNU(1))
C PROTON INDUCED REACTION
      DATA AELEM/ 23., 27.,  28., 40.,  55.9, 63.6,  96.,  112.6, 118.8,
     #           183.9, 207.3, 238./
      DATA ENERGY/14.,  15.,  16.,  17.,  18., 19.,  20.,  22.,
     $       25.,  27.,  30.,  33.,  35.,  37.,  40.,  45.,
     $       50.,  55.,  60.,  65.,  70.,  80.,  90., 100., 120.,
     $      140., 150., 160., 180., 200., 250., 300., 350., 400.,
     $      500., 600., 700., 800., 900.,1000., 1500., 2000., 3000.,
     $      5000., 7000., 10000./
      DATA RIDENT/'NA','AL','SI','CA','FE','CU','MO',
     +     'CD','SN',' W','PB',' U'/
      DATA CSPNA/600.,  617.,  638.5, 660., 665., 670.,   675.,  680.,
     $           680.,  670.,
     $           650.,  605.,  575.,  565.,  550.,  525.,  490.,  470.,
     $           450.,  435.,  420.,  385.,  367.,  360.,  350.,  350.,
     $           350.,  345.,  347.,  350.,  350.,  350.,  356.,  364.,
     $           384.,  392.,  400.,  408.,  410.,  420.,  408.,  412.,
     $           420.,  411.,  409.,  407./
      DATA CSNNA/960.,  930.,  910.,  890.,  867.3, 844.67,  822.,
     $           790.,  750.,  725.,
     $           686.,  646.4, 620.,  612.,  600.,  575.,  540.,  518.5,
     $           497.,  473.5, 450.,  414.,  390.,  380.,  372.,  364.,
     $           360.,  355.,  354.,  350.,  350.,  350.,  356.,  364.,
     $           384.,  392.,  400.,  408.,  410.,  420.,  408.,  412.,
     $           420.,  411.,  409.,  407./
      DATA CSPAL/650.,  682.,  690.,  715.,  726.67, 738.33,
     $           750.,  762.,  750.,  740.,
     $           720.,  681.,  655.,  640.,  617.,  575.,  540.,  505.,
     $           470.,  462.5, 455.,  432.,  420.,
     $           408.,  400.,  403.,  403.,  408.,  406.,  404.,  400.,
     $           402.,  404.,  408.,  424.,  438.,  448.,  450.,  454.,
     $           456.,  472.,  480.,  466.,  456.,  452.,  448./
      DATA CSNAL/1000., 990.,  975.,  950.,  935.,  920.,
     $           905.,  875.,  825.,  800.,
     $           762.,  718.8, 690.,  674.8, 652.,  610.,  570.,  532.5,
     $           495.,  487.5, 480.,  456.,  444.,
     $           432.,  420.,  420.,  420.,  420.,  410.,  410.,  400.,
     $           402.,  404.,  408.,  424.,  438.,  448.,  450.,  454.,
     $           456.,  472.,  480.,  466.,  456.,  452.,  448./
      DATA CSPSI/670.,  700.,  725.,  750.,  760.,  770.,
     $           780.,  780.,  770.,  757.,
     $           735.,  708.,  690.,  668.,  635.,  585.,  570.,  530.,
     $           490.,  482.5,
     $           475.,  460.,  446.,  431.,  423.,  425.,  425.,
     $           425.,  425.,  422.,  422.,  412.,  416.,  422.,  440.,
     $           460.,  472.,  476.,  479.,  480.,  492.,  496.,  488.,
     $           472.,  472.,  464./
      DATA CSNSI/1060., 1035., 1015., 990., 971.67, 953.33,
     $           935.,  900.,  860.,  830.,
     $           790.,  751.,  725.,  701.,  665.,  630.,  600.,  560.,
     $           520.,  512.,
     $           504.,  486.,  470.,  456.,  444.,  432.,  432.,
     $           432.,  418.,  418.,  415.,  412.,  416.,  422.,  440.,
     $           460.,  472.,  476.,  479.,  480.,  492.,  496.,  488.,
     $           472.,  472.,  464./
      DATA CSPCA/770., 800., 823., 850., 866.67, 883.3,
     $           900., 925., 935., 920., 895.,
     $           859., 835., 821., 800., 750., 715., 678., 640., 622.5,
     $           605., 590., 588., 573.,
     $           555., 543., 540., 540., 540., 535., 530., 530., 540.,
     $           550., 570., 595., 610., 615., 620., 622., 629., 630.,
     $           620.,  612.,  607.,  592./
      DATA CSNCA/1240.,1225.,1200.,1180.,1161.67, 1143.3,
     $           1125.,1090.,1045.,1020.,980.,
     $           947., 925., 907., 880., 825., 770., 725., 680., 660.,
     $           640., 620., 615., 600.,
     $           580., 565., 560., 560., 560., 550., 535., 530., 540.,
     $           550., 570., 595., 610., 615., 620., 622., 629., 630.,
     $           620.,  612.,  607.,  592./
      DATA CSPFE/900., 960.,1015.,1070.,1076.67,1083.3,
     $          1090.,1115.,1120.,1115.,1080.,
     $          1045.,1025.,1000., 960., 900., 885., 865., 790., 777.5,
     $           765.,
     $           740., 720., 700., 697., 697., 697., 697., 695., 690.,
     $           688., 690., 712., 705., 735., 750., 765., 775., 780.,
     $           795., 810., 813., 810., 784., 757., 743./
      DATA CSNFE/1440.,1433.,1411.5,1390.,1368.3, 1346.67,
     $          1325.,1280.,1260.,1215.,1180.,
     $          1140.,1110.,1080.,1040., 990., 955., 920., 885.,860.,
     $           835.,
     $           800., 780., 765., 750., 725., 720., 720., 710., 700.,
     $           700., 700., 712., 705., 735., 750., 765., 775., 780.,
     $           795., 810., 813., 810., 784., 757., 743./
      DATA CSPCU/935.,1000.,1030.,1060.,1103.3,1146.67,
     $          1190.,1220.,1250.,1240.,1210.,
     $          1150.,1130.,1115.,1050., 985., 950., 890., 870., 845.,
     $           820.,
     $           800., 785., 780., 770., 750., 745., 740., 735., 735.,
     $           745., 760., 762., 770., 795., 810., 825., 830., 840.,
     $           848., 870., 870., 868., 840., 825., 810./
      DATA CSNCU/1540.,1535.,1517.5,1500.,1481.67,1463.3,
     $          1445.,1407.,1380.,1330.,1300.,
     $          1285.,1270.,1240.,1190.,1090.,1010., 940., 920., 890.,
     $           860.,
     $           835., 820., 810., 800., 780., 775., 770., 760., 760.,
     $           758., 765., 765., 770., 795., 810., 825., 830., 840.,
     $           848., 870., 870., 868., 840., 825., 810./
      DATA CSPMO/1025.,1080.,1135.,1190.,1253.3,1316.67,
     $           1380.,1440.,1495.,1475.,1420.,
     $           1350.,
     $           1310.,1300.,1290.,1250.,1200.,1170.,1130.,1112.5,
     $           1095.,1060.,
     $           1040.,1022.,1020.,1016.,1016.,1016.,1016.,1012.,1005.,
     $           1005.,1005.,1010.,1060.,1085.,1100.,1110.,1120.,1127.,
     $           1150.,1160.,1140.,1100.,1085.,1080./
      DATA CSNMO/1790.,1775.,1757.5,1740.,1720.,1700.,
     $           1680.,1640.,1580.,1550.,1510.,
     $           1460.,
     $           1440.,1418.,1380.,1330.,1280.,1240.,1200.,1177.5,
     $           1155.,1140.,
     $           1110.,1110.,1080.,1065.,1050.,1050.,1025.,1020.,1015.,
     $           1020.,1022.,1026.,1060.,1085.,1100.,1110.,1120.,1127.,
     $           1150.,1160.,1140.,1100.,1085.,1080./
      DATA CSPCD/1020., 1100., 1162.5,1225.,1290.,1365.,1440.,1520.,
     $           1575.,1560.,1518.,1460.,1420.,1412.,1400.,1365.,1340.,
     $           1300.,1280.,1260.,1200.,1190.,1160.,6*1125., 3*1120.,
     $           1118.,1146.,1180.,1220.,1240.,1250.,1260.,1265.,1270.,
     $           1275.,1250.,2*1222.,1220./
      DATA CSNCD/1920.,1910.,1895.,1880.,1860.,1850.,1840.,1800.,1760.,
     $           1720.,1675.,1630.,1600.,1568.,1520.,1465.,1420.,1390.,
     $           1340.,1310.,1280.,1275.,1235.,1225.,1200.,3*1170.,
     $           1165.,1145.,1140.,1140.,1135.,1160.,1180.,
     $                            1220.,1240.,1250.,1260.,1265.,1270.,
     $           1275.,1250.,2*1222.,1220./
      DATA CSPSN/1020.,1080.,1175.,1270.,1335.,1400.,1465.,1505.,1610.,
     $           1610.,1550.,1535.,1500.,1476.,1440.,1407.,1370.,1340.,
     $           1300.,1285.,1260.,1230.,1215.,1200.,1180.,1170.,1170.,
     $           1165.,1165.,
     $           1170.,1165.,1165.,1183.,1195.,1240.,1270.,1285.,
     $           1300.,1300.,1310.,1320.,1320.,1290.,3*1240./
      DATA CSNSN/1945.,1940.,1922.5,1905.,1890.,1875.,1860.,1830.,1780.
     $          ,1755.,1717.,1680.,1645.,1615.,1570.,1500.,1455.,1410.,
     $           1370.,1340.,
     $           1320.,1290.,1285.,1260.,1240.,1235.,1212.,1200.,
     $           2*1200.,2*1190.,1200.,1210.,1240.,1270.,1285.,1300.,
     $                 1300.,1310.,1320.,1320.,1290.,3*1240./
      DATA CSPW / 950.,1020.,1130.,1240.,1400.,1480.,1560.,1670.,1760.,
     $           1830.,1850.,1855.,1870.,1858.,1840.,1800.,1770.,1740.,
     $           1715.,1680.,1670.,1650.,1620.,1610.,6*1600.,1595.,
     $           1585.,1595.,1615.,1640.,1700.,1720.,1730.,1740.,1750.,
     $           1780.,1780.,1750.,1740.,1735.,1710./
      DATA CSNW /2440.,2400.,2385.,2370.,2350.,2330.,2310.,2270.,2220.,
     $           2195.,2150.,2100.,2070.,2046.,2010.,1945.,1900.,1850.,
     $           1820.,1780.,1760.,1730.,1720.,1680.,1680.,1660.,1660.,
     $           1650.,1650.,1640.,1640.,1612.,1615.,1625.,1640.,
     $                                   1700.,1720.,1730.,1740.,1750.,
     $           1780.,1780.,1750.,1740.,1735.,1710./
      DATA CSPPB/ 900.,1060.,1130.,1200.,1310.,1420.,1515.,1620.,1750.,
     $           1800.,1915.,1984.,2030.,2002.,1960.,1940.,1910.,1860.,
     $           1840.,1810.,1780.,1770.,1760.,1740.,1720.,1725.,1740.,
     $           1740.,1730.,1720.,1700.,1710.,1720.,1730.,1740.,1815.,
     $           1835.,1860.,1890.,1895.,1920.,1920.,1890.,1850.,1835.,
     $           1830./
      DATA CSNPB/2580.,2550.,2527.5,2505.,2483.5,2462.,2460.,2435.,2380.
     $          ,2355.,2280.,2220.,2180.,2176.,2170.,2130.,2080.,2035.,
     $           1980.,1960.,1940.,1900.,1870.,1840.,1800.,1800.,1800.,
     $           1780.,1760.,1760.,1740.,1730.,1725.,1740.,
     $           1785.,1815.,1835.,1860.,1890.,
     $           1895.,1920.,1920.,1890.,1850.,1835.,1830./
      DATA CSPU / 800., 900.,1000.,1100.,1200.,1300.,1410.,1510.,1680.,
     $           1800.,2000.,2120.,2200.,2152.,2080.,2060.,2025.,2100.,
     $           2030.,2030.,2030.,2000.,3*1960.,1940.,1925.,1920.,
     $           1905.,1890.,1860.,1880.,1910.,1930.,1945.,1985.,2010.,
     $           2040.,2070.,2080.,2090.,2095.,2080.,2063.,2060.,2050./
      DATA CSNU /2820.,2770.,2735.,2700.,2680.,2660.,2645.,2620.,2580.,
     $           2550.,2515.,2476.,2450.,2426.,2390.,2320.,2260.,2225.,
     $           2200.,2170.,2140.,2080.,2060.,2040.,2000.,1980.,1965.,
     $           1960.,1930.,1920.,1890.,1905.,1920.,1945.,1970.,
     $                                                     1985.,2010.,
     $           2040.,2070.,2080.,2090.,2095.,2080.,2063.,2060.,2050./
      DATA PPN,PPP/6*1HN,6*1HP/
      IF(TEST.NE.0.) GOTO 5000
        A=A9
        T0=T9
        MPARIN=MPAR9
                          ISMALL = 0
C
        IF(A.GT.AELEM(12).OR.A.LE.0.)               GOTO 10000
        IF(A.GE.AELEM(1) ) GOTO 44
        PRINT 3000
        ISMALL = 1
        A = AELEM(1)
        ASM = A9
44          IF(T0.LT.ENERGY(1)  )                   GOTO 20000
            IF(T0.GT.ENERGY(46)) PRINT 4000,ENERGY(46)
            IF(T0.GT.ENERGY(46)) T0 = ENERGY(46)
C
        DO  50 I=1,12
        IF(A.LE.AELEM(I)) GOTO 100
50      CONTINUE
        GOTO 10000
C
100     IA1=I-1
        IF(I.EQ.1)IA1=1
        IA2=I
C
        DO  150 I=1,46
        IF(T0.LE.ENERGY(I)) GOTO 200
150     CONTINUE
        GOTO 20000
C
200     IE1=I-1
        IF(I.EQ.1)IE1=1
        IE2=I
           IF(MPARIN.EQ.2)GOTO 201
              CS11=CSN(IE1,IA1)
              CS12=CSN(IE1,IA2)
              CS21=CSN(IE2,IA1)
              CS22=CSN(IE2,IA2)
              GOTO 202
201                CS11=CSP(IE1,IA1)
                   CS12=CSP(IE1,IA2)
                   CS21=CSP(IE2,IA1)
                   CS22=CSP(IE2,IA2)
C
202          IF(IE1.EQ.IE2) CSMIN=CS11
             IF(IE1.EQ.IE2) CSMAX=CS12
             IF(IE1.EQ.IE2) GOTO 400
C
                  E1=ENERGY(IE1)                                        
                  E2=ENERGY(IE2)                                        
        CS1=CS11
        CS2=CS21
              RR=E2-E1                                                  
              AAA=(CS2-CS1)/RR                                          
              BBB=(CS1*E2-E1*CS2)/RR                                    
        CSMIN = AAA * T0 + BBB
C
        CS1=CS12
        CS2=CS22
              RR=E2-E1                                                  
              AAA=(CS2-CS1)/RR                                          
              BBB=(CS1*E2-E1*CS2)/RR                                    
        CSMAX = AAA * T0 + BBB
C
400         IF(IA1.EQ.IA2) CSNON=CSMIN
            IF(IA1.EQ.IA2) GOTO 555
               A1=AELEM(IA1)                                            
               A2=AELEM(IA2)                                            
              RR=A2-A1                                                  
              AAA=(CSMAX-CSMIN)/RR                                      
              BBB=(CSMIN*A2-A1*CSMAX)/RR                                
        CSNON = AAA * A  + BBB
555     IF(ISMALL.EQ.0) RETURN
        CSNON = CSNON * ( (ASM/A)**0.66666666 )
        RETURN
C
C TEST PRINTING
5000     PRINT 5010,(RIDENT(I),I=1,6)
5010     FORMAT(/1X,'  E,MEV ',4X,6(8X,A2,7X))
         PRINT 5011,(AELEM(I),I=1,6)
5011     FORMAT(1X,   8X,     4X,6(6X,F6.2,5X))
         PRINT 5014,(PPN(II),PPP(II),II=1,6)
5014     FORMAT(1X,   8X,     4X,6(3X,A1,3X, 3X,A1,3X, 3X))
         PRINT 5012
5012     FORMAT(120('-'))
         DO 8000 II=1,46
8000     PRINT 5020,ENERGY(II),(CSN(II,JJ),CSP(II,JJ),JJ=1,6)
5020     FORMAT(1X,F8.1,4X,6(2F7.1,3H I ))
         PRINT 5015
5015     FORMAT(120('='))
         PRINT 5010,(RIDENT(I),I=7,12)
         PRINT 5011,(AELEM(I),I=7,12)
         PRINT 5014,(PPN(II),PPP(II),II=1,6)
         PRINT 5012
         DO 9000 II=1,46
9000     PRINT 5020,ENERGY(II),(CSN(II,JJ),CSP(II,JJ),JJ=7,12)
         STOP
C
10000   PRINT 1000,A
1000    FORMAT(1X,'SUBROUTINE BARASH: NO INFORMATION ABOUT A =',G12.5)
        STOP
20000   PRINT 2000,T0
        WRITE(1,2000)T0
        WRITE(8,2000)T0
        CSNON=0.
        RETURN
2000    FORMAT(1X,'SUBROUTINE BARASH: NO INFORMATION FOR ENERGY = ',
     $  G12.5/ 1X,' CSNON =0.')
3000    FORMAT(1X,'Attention !'/1X,' For low atomic numbers ',
     $  ' SUBR BARASH gets approximated cross-sections'//)
4000    FORMAT(//1X,' Attention !'/1X,'BARASH: Cross-section is taken ',
     $  ' at the energy = ',G14.7//)
         END
************************************************************************
*               SUBROUTINE BINDEN                                      *
************************************************************************
      SUBROUTINE BINDEN(ZEE,AMASS,NZ,NA,AP,AT,ZP,ZT,QVAL,M3,MP)
* taken from Blann code ALICE
      COMMON/LYM1/BE(11,24,4),SYMB(11,24),PAIR(11,24),SYMBP(11,24)
      DIMENSION EXCES(4),RES(4),ERR(4)
      DATA TAB/4H TAB/
      IZEE=ZEE+.1
      IMASS=AMASS+.1
      IAP=AP+.1
      IAT=AT+.1
      IZP=ZP+.1
      IZT=ZT+.1
      INP=IAP-IZP
      INT=IAT-IZT
      IRET=0
      N=IMASS-IZEE
      CALL MASS(IZP,INP,EXCES(1),ERR(1),IRET)
      CALL MASS(IZT,INT,EXCES(2),ERR(2),IRET)
      CALL MASS(IZEE,N,EXCES(3),ERR(3),IRET)
      IF(IRET.GT.0) GO TO 10
      IF(QVAL.NE.0.)GO TO 10
      QVAL=-EXCES(3)+EXCES(2)+EXCES(1)
cccc  WRITE(6,4)
    4 FORMAT(//,20X,'********************************************'//)
cccc  WRITE(6,5)QVAL
cccc  WRITE(6,4)
5     FORMAT(20X,' QVAL USED (CALCULATED FROM MASS TABLE) = ',F5.1)
10    IRET=0
      CALL MASS(0,1,EXCES(1),ERR(1),IRET)
      CALL MASS(1,0,EXCES(2),ERR(2),IRET)
      CALL MASS(2,2,EXCES(3),ERR(3),IRET)
      CALL MASS(1,1,EXCES(4),ERR(4),IRET)
      IF(IRET.GT.0) RETURN
cccc  WRITE(6,6)
6     FORMAT(30X,'BINDING ENERGIES CALCULATED FROM MASS TABLE',
     1 ' WHERE POSSIBLE.')
cccc  IF(MP.EQ.0)WRITE(6,7)
7     FORMAT(35X,'PAIRING REMOVED FROM MASSES IN TABLE')
cccc  IF (MP.EQ.0.AND.MC.EQ.1) WRITE(6,8)
    8 FORMAT (35X,'SHELL CORRECTION REMOVED FROM MASSES IN TABLE')
      DO 65 IZ=1,NZ
      DO 65 IA=1,NA
      IZZ=IZEE-IZ+1
      INN=IMASS-IZEE-IA+1
      IZZ1=IZZ-1
      INN1=INN-1
      INN2=INN-2
      IZZ2=IZZ-2
      IRET=0
      CALL MASS(IZZ,INN,XMASS,ERR(1),IRET)
      CALL MASS(IZZ,INN1,RES(1),ERR(1),IRET)
      IF(M3.GE.2)CALL MASS(IZZ1,INN,RES(2),ERR(2),IRET)
      IF(M3.GE.3)CALL MASS(IZZ2,INN2,RES(3),ERR(3),IRET)
      IF(M3.EQ.4)CALL MASS(IZZ1,INN1,RES(4),ERR(4),IRET)
      IF(IRET.GT.0) GO TO 65
      IF(MP.NE.0)GO TO 55
      XMASS=XMASS+PAIR(IZ,IA)
      RES(1)=RES(1)+PAIR(IZ,IA+1)
      RES(2)=RES(2)+PAIR(IZ+1,IA)
      RES(3)=RES(3)+PAIR(IZ+2,IA+2)
      RES(4)=RES(4)+PAIR(IZ+1,IA+1)
   55 DO 60 I=1,M3
60    BE(IZ,IA,I)=-XMASS+EXCES(I)+RES(I)
      SYMB(IZ,IA)=TAB
65    CONTINUE
      RETURN
      END
************************************************************************
*                FUNCTION BKAL(M,E1)                                   *
************************************************************************
           FUNCTION BKAL(M,E1)
           RM=FLOAT(M*(M+1))
           AL=0.036+0.0039*RM
           BL=92.-90./SQRT(RM)
           BKAL=FLOAT(2*M+1)/(1.+EXP(AL*(BL-E1)))
           RETURN
           END
************************************************************************
*                  BLOCK DATA                                          *
************************************************************************
      BLOCK DATA                                                        
      COMMON/DATEVA/GP,GD,GT,GHE,GAL,GAMP,GAMD,GAMT,GAMHE,GAMAL,CP,CD,  
     *CT,CHE,CAL,VP,VD,VT,VHE,VAL,QN,QP,QD,QT,QHE,QAL                   
      COMMON/FIGA1B/T1(16),BA1(16),BB1(16),BB2(9),BB3(8)                
      COMMON/DATCAM/CAMN(130),CAMP(130),MAXN,MAXP                       
      COMMON/DOSTRO/RKPD(6),RKAD(6),CPD(6),CAD(6),ZD(6)                 
      COMMON/DATREN/RL0N,RL1N,RM0N,RM1N,RN0N,RN1N,RN2N                  
      COMMON/DATREP/P0P,P1P,P2P,RL0P,RL1P,RM0P,RM1P,RN0P,RN1P,RN2P      
      COMMON/SHEL2/DWA(220)                                             
      COMMON/DATREA/P0A,P1A,P2A,RL0A,RL1A,RM0A,RM1A,RN0A,RN1A,RN2A
C
      DATA GAMP,GAMD,GAMT,GAMHE,GAMAL/2*1., 2*3., 2./                   
      DATA T1/ 0.,  40.,  80.,  120.,  160.,  200.,  240.,              
     *280.,  300.,  320.,  360.,  400.,  440.,  480.,  520.,  560./     
      DATA BA1/1592., 12., 5.2, 3.3, 2.3, 2., 1.9, 1.8, 1.75,           
     * 1.7, 1.5, 1.4, 1.3, 1.2, 1.1, 1./                                
      DATA BB1/ 0., 7.,  8.1,  6.6,  3.9,  11*3.6/                      
      DATA BB2/0.,  7.,  8.3,  9.,  7.7,  6.5,  6.2,  6.,  5.8071425/   
      DATA BB3/8.1299995,  7.8,  7.4,  7.,  6.7,  6.4,  6.1,  5.8/      
C                                                                       
C     CAMN/CAMP : corrections for nuclei with neutrons/protons number
C     equal to array number
      DATA CAMN/-8.4, -12.9, -8.0, -11.9, -9.2, -12.5, -10.8, -13.6,    
     * -11.2, -12.2,                                                    
     * -12.81, -15.40, -13.07, -15.80, -13.81, -14.98,                  
     * -12.63, -13.76, -11.37,  -12.38,  -9.23,  -9.65, -7.64,  -9.17,  
     * -8.05, -9.72,  -8.87,  -10.76,  -8.64,  -8.89,  -6.60,  -7.13,   
     * -4.77, -5.33,  -3.06,  -3.79,  -1.72,  -2.79, -0.93,  -2.19,     
     *  -0.52, -1.90, -0.45,  -2.20,  -1.22,  -3.07, -2.42,  -4.37,     
     * -3.94, -6.08, -4.49, -4.5, -3.14, -2.93, -1.04, -1.36, 0.69,     
     * 0.21, 2.11, 1.33,                                                
     * 3.29, 2.46, 4.30, 3.32, 4.79, 3.62, 4.97, 3.64,
     * 4.63, 3.07, 4.06, 2.49, 3.30, 1.46, 2.06, 0.51, 0.74,-1.18,
     *-1.26,-3.54,-3.97,-5.26,-4.18,-3.71,-2.10,-1.70,-0.08,-0.18,
     * 0.94, 0.27, 1.13, 0.08, 0.91, 0.31, 0.49,-0.78, 0.08,-1.15,
     *-0.23,-1.41,-0.42,-1.55,-0.55,-1.66,-0.66,-1.73,-0.75,-1.74,
     *-0.78,-1.69,-0.78,-1.60,-0.75,-1.46,-0.67,-1.26,-0.51,-1.04,
     *-0.53,-1.84,-2.42,-4.52,-4.76,-6.33,-6.76,-7.81,-5.80,-5.37,
     *-3.63,-3.35/
      DATA CAMP/ 20.8, 15.8, 21.0, 16.8, 19.8, 16.5, 18.8, 16.5,        
     *  18.5, 17.2,                                                     
     *  18.26,  15.05,  16.01,  12.04,  13.27,  11.09,                  
     *  12.17,  10.26,  11.04,  8.41,  9.79,  7.36,  8.15,  5.63, 5.88, 
     *  3.17,  3.32,  0.82,  1.83,  0.97,  2.33,  1.27,  2.92, 1.61,    
     *  2.91,  1.35,  2.40,  0.89,  1.74,  0.36,  0.95, -0.65,  -0.04,  
     *  -1.73, -0.96, -2.87, -2.05, -4.05, -3.40, -5.72, -3.75, -4.13,  
     * -2.42, -2.85, -1.01, -1.33, 0.54, -0.02, 1.74, 0.75,             
     * 2.24, 1.00, 1.98, 0.79, 1.54, 0.39, 1.08, 0.00, 0.78,-0.35, 0.58,
     *-0.55, 0.59,-0.61, 0.59,-0.35, 0.32,-0.96,-0.52,-2.08,-2.46,-3.64,
     *-1.55,-0.96, 0.97, 0.88, 2.37, 1.75, 2.72, 1.90, 2.55, 1.46, 1.93,
     * 0.86, 1.17, 0.08,-0.39,-0.76,-0.39,-1.51,-1.17,-2.36,-1.95,-3.06,
     *-2.62,-3.55,-2.95,-3.75,-3.07,-3.79,-3.06,-3.77,-3.05,-3.78,-3.12,
     *-3.90,-3.35,-4.24,-3.86,-4.92,-5.06,-6.77,-7.41, 9.18,-10.16,
     *-11.12,-9.76,-9.23,-7.96,-7.65/
C                                      1000. is simply "big" number
      DATA ZD/10., 20., 30., 50., 70., 1000./                           
      DATA RKPD/ 0.42, 0.58, 0.68, 0.77, 0.8, 0.8/                      
      DATA CPD/ 0.5, 0.28, 0.2, 0.15, 0.1, 0.1/                         
      DATA RKAD/ 0.68, 0.82, 0.91, 0.97, 0.98, 0.98/                    
      DATA CAD/ 3*0.1, 0.08, 0.06, 0.06/                                
C  CHATTERJEE COMPILATION
C        NEUTRONS WILMORE                                               
         DATA RL0N,RL1N,RM0N,RM1N,RN0N,RN1N,RN2N/                       
     *31.05,-25.91,342.4,21.89,0.223,0.673,617.4/                       
C        PROTONS BECCHETTI                                              
         DATA P0P,P1P,P2P,RL0P,RL1P,RM0P,RM1P,RN0P,RN1P,RN2P/           
     *15.72,9.65,-449.0,0.00437,-16.58,244.7,0.503,273.1,-182.4,-1.872/ 
C        ALPHA-PARTICLES HUIZENGA
         DATA P0A,P1A,P2A,RL0A,RL1A,RM0A,RM1A,RN0A,RN1A,RN2A/
     *10.95,-85.2,1146.,0.0643,-13.96,781.2,0.29,-304.7,-470.,-8.58/
      DATA DWA/22*0.0,
     * -0.6, -0.7, -0.8, -0.9, -1.8, -2.0, -2.9, -2.4, -2.3, -1.6, -1.3,
     * -1.0, -0.8, -0.4, -0.3,  0.1,  0.5,  0.8,  1.4,  2.0,  1.8,  1.5,
     *  1.4,  1.3,  0.8,  0.3, -0.0, -0.8, -1.5, -1.6, -1.7, -1.8, -1.8,
     * -1.8, -2.4, -2.0, -1.7, -1.6, -1.6, -1.3, -0.7, -0.6, -0.2,  0.0,
     *  0.9,  0.8,  1.2,  1.5,  1.8,  2.0,  2.4,  1.8,  2.4,  2.0,  1.7,
     *  2.4,  2.4,  1.8,  1.2,  0.4, -0.1, -0.3,  0.5, -0.9, -2.0, -1.7,
     * -2.4, -2.4, -2.0, -1.6, -1.1, -0.7, -0.2, -0.2, -0.2, -0.1,  0.7,
     *  1.2,  1.8,  0.1,  0.8,  1.1,  1.5,  1.6,  0.5,  0.7,  1.1,  1.2,
     *  1.2, -0.0,  0.3,  0.2,  0.4,  0.3,  0.3, -0.7, -0.0, -1.1, -0.6,
     * -0.7, -1.0, -1.6, -2.0, -1.7, -1.5, -2.2, -2.3, -3.1, -2.6, -3.2,
     * -2.6, -3.3, -4.2, -2.4, -4.1, -3.8, -4.1, -3.7, -3.2, -2.9, -2.2,
     * -2.4, -1.8, -0.6, -0.4,  0.1,  0.2,  0.3, -0.1, -0.5, -0.7, -1.1,
     * -1.4, -1.7, -2.0, -2.1, -2.1, -2.3, -2.5, -2.2, -2.5, -2.7, -3.0,
     * -3.2, -3.4, -3.1, -3.2, -3.4, -3.5, -3.3, -3.7, -3.1, -3.4, -3.5,
     * -3.4, -3.2, -3.5, -3.2, -3.5, -3.7, -3.4, -3.4, -3.4, -3.2, -3.0,
     * -2.9, -2.5, -2.8, -3.0, -3.3, -3.7, -4.3, -4.8, -5.4, -6.0, -6.8,
     * -7.1, -8.1, -8.7, -9.2, -9.6,-10.5,-11.3,-12.2,-12.0,-12.7,-12.1,
     *-11.2,-10.6,-10.0, -9.4, -8.8, -8.2, -7.6, -7.0, -6.4, -5.8, -5.2/
c      RETURN
       END
************************************************************************
*                  BLOCK DATA C                                        *
************************************************************************
      BLOCK DATA C
C Written by Barashenkov, Polanski
C     NUCLEUS-NUCLEUS CROSS-SECTION PARAMETERS
      COMMON/CX/CX(38)
      DATA  CX/2.07,560.,0.8,0.426,
     *           100.,-2.05,1.9,
     *           200.,0.07,0.87,
     *           20.,-1.55,2.1,
     *           700.,-1.01,1.08,
     *           400.,-0.59,0.94,
     *        2.45,225.,-2.25,2.,
     *           100.,-4.61,3.18,
     *           185.,-3.,2.4,
     *           185.,-3.,2.4,
     *           185.,-4.77,3.18,
     *           185.,-4.77,3.18/
      END
************************************************************************
*                 FUNCTION CAMERO                                      *
************************************************************************
      FUNCTION CAMERO(RN,Z)                                             
* Defect mass calculation. Barashenkov, Toneev "Interaction of particles
* and nuclei", 1972, Atomizdat (error on p.419 corrected)
      A=RN+Z                                                            
      A13=A**0.333333333                                              
      A23=A13*A13                                                     
      A43=A23*A23                                                     
      Z43=Z**(4./3.)                                                  
      AZ=((A-2.*Z)/A)**2                                               
      RMOB=A*(8.367+31.4506*AZ)-(0.783*Z+17.0354*A)                    
      RMPOW=A23*(25.8357-44.2355*AZ)*((1.-0.62025/A23)**2)             
      RMK=0.779*(Z*(Z-1.)/A13)*(1.-1.5849/A23+1.2273/A+1.5772/A43)     
      RMEX=-0.4328*(Z43/A13)*(1.-0.57811/A13-0.14518/A23+0.49597/A)    
      CAMERO=RMOB+RMPOW+RMK+RMEX                                       
      RETURN                                                          
      END                                                             
************************************************************************
*                 SUBROUTINE CFUN                                      *
************************************************************************
      SUBROUTINE CFUN                                                   
      COMMON/CFUMAS/CF /TR2CFU/REC /EDEFF/Ed
      COMMON/QBOCFU/NSUMN,NSUMP /AN/AN /MPARIN/MPARIN
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                      
         AP=1.
         IF(MPARIN.eq.3) AP=4.           
         Z2=Z-FLOAT(NSUMP)+1.+(MPARIN-1)
         A2=AN-FLOAT(NSUMN+NSUMP)+2.+AP
         Z1=Z
         A1=AN
      CALL NRT_COEFF(Z1,Z2,A1,A2,ANRT,BNRT,GNRT)   
      EDkeV=Ed
* NRT 
      TT=REC*1000.
      If(TT.lt.EDkeV) then
                      CF=0.0
                      Return
                      Endif
       If(TT.lt.2.*EDkeV) TT=2.*EDkeV
       CF=(0.8/(2.*EDkeV))*TT/
     + (1.+ANRT*TT+BNRT*(TT**0.75)+GNRT*(TT**0.16666666666))     
       RETURN                                                            
       END                                                               
************************************************************************
*                 SUBROUTINE CHECK1                                    *
************************************************************************
      SUBROUTINE CHECK1(G,T1,W1,IGEN,M1)                                
* limitation on orbital momenta according to Bunakov
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/ACTSCI/PIN1,PIN2,PIN3,WPX,RK3,RK4,GAMMA,SK2,VC2,VCX,       
     *VCY,VCZ,MPX                                                       
      COMMON/SCIMEM/WPM,PXM,PYM,PZM,PM,TM,EM,XM,YM,ZM,RM,JINM,MM        
      COMMON/IMOM/IMOM                                                  
      IF(IMOM.EQ.0)RETURN                                               
C                                                                       
      IF(G)1,1,2                                                        
    1 RK=RK4-(GAMMA-1.)*SK2/VC2                                         
      GOTO 3                                                            
    2 RK=RK3+(GAMMA-1.)*SK2/VC2                                         
    3 CONTINUE                                                          
    4 PX5=G*PIN1+RK*VCX                                                 
      PY5=G*PIN2+RK*VCY                                                 
      PZ5=G*PIN3+RK*VCZ                                                 
      P5=SQRT(PX5*PX5+PY5*PY5+PZ5*PZ5)                                  
      T5=T1                                                             
      RORM=ORBIT(PX5,PY5,PZ5,X,Y,Z)                                     
      CALL QUES(RORM,T5,W1,JIN,M1,IGEN)                                 
      RETURN                                                            
C                                                                       
      END                                                               
************************************************************************
*                 SUBROUTINE CHESEP                                    *
************************************************************************
      SUBROUTINE CHESEP                                                 
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/EVAMAS/NEVAN,NEVAP,NEVAD,NEVAT,NEVAHE,NEVAAL               
      COMMON/INFSEP/KSEP(100,4),INFSEP,JSEPM                        
        DO 100 J=1,JSEPM
        IF(KSEP(J,1).NE.
     +  (NPREN+NEVAN+NEVAD+2*NEVAT+NEVAHE+2*(NEVAAL+NPREA))) GOTO 100
        IF(KSEP(J,2).NE.
     +  (NPREP+NEVAP+NEVAD+NEVAT+2*NEVAHE+2*(NEVAAL+NPREA))) GOTO 100
        KSEP(J,4)=KSEP(J,4)+1
100     CONTINUE
      RETURN
      END
************************************************************************
*                 SUBROUTINE CHOPAR                                    *
************************************************************************
      SUBROUTINE CHOPAR(JZ,SXX)                                        
      COMMON/DAINT/PF(33,4),RO1(33),RZON(33),FIG                          
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/PARTNR/PPX,PPY,PPZ,PP,MX                                   
      COMMON/TYPACT/L,L7 /QPARX/QPROT,QNEUT,QPROT2,QNEUT2
      COMMON/BOND1/QBON(200,200,6) /TFERMI/TF(34,4)                                              
      COMMON/RNUCL/RNUCL /XPARAM/XPARAM,FIALPH
      COMMON/FICAP/FICAP,MZONA
      COMMON/URAND1/IYG                                                 
C
C Types of inetractions: L = 1  N-P  or  P-N
C                        L = 2  N-N  or  P-P
C                        L = 3  Elastic scattering NUCELON-ALPHA    
C                        L = 4  Elastic scattering ALPHA-NUCLEON    
C                        L = 5  Decay of ALPHA-PARTICLE in N-A interaction
C                        L = 6  NUCLEON-T  or  NUCLEON-HE-3 
C                        L = 7  Decay of ALPHA-PARTICLE in A-N interaction
C
      MX = 0
      L  = 0
      L7 = 0
                      QNEUTX=QNEUT
                      QPROTX=QPROT
      IF(JZ.GE.MZONA) QNEUTX=QNEUT2
      IF(JZ.GE.MZONA) QPROTX=QPROT2
C
      IF(M.EQ.3) GOTO 300     
C 
      CALL CSPPPN(T,SPP,SPN)                                            
      CALL CSPANA(T,SPA,1)                                                
C "+QBON" because FLM coefficients are shifted on Q         
       TT = T - QBON(1,1,6) - TF(JZ,M)        +  QBON(1,1,6) 
       IF(TT.LT.0.0) TT = 0.0
       CSCAPT = 0.1 * 
     # (-1.011E-06*(TT**3) + 0.0001748*TT*TT - 0.01128*TT+0.275742)
       CSCAPT = CSCAPT/( RNUCL * RO1(JZ) )
       IF(CSCAPT.LT.0.0) CSCAPT =0.0
       CSCAPT = CSCAPT*FICAP
C                                                                       
      GOTO(4,5),M
C   NEUTRON                                                             
    4 QPAR1=QNEUTX
      QPAR2=QPROTX                                                       
      GOTO 6                                                            
C   PROTON                                                             
    5 QPAR1=QPROTX                                                       
      QPAR2=QNEUTX                                                       
    6 SPP=SPP*QPAR1                                                     
      SPN=SPN*QPAR2                                                     
C + CSCAPT due to introduction of D,HE3 in calculstions
                  STOT=SPN+SPP
      IF(JZ.GE.MZONA) STOT=SPN+SPP+SPA+CSCAPT
      SXX = STOT 
      YY=STOT * RANDOMG(0)
      IF(YY-SPP)10,10,20                                                 
C   INTERACTION WITH THE SAME TYPE                                       
   10 MX=M                                                              
      L=2                                                               
      RETURN                                                            
   20 IF(YY-(SPN+SPP))100,100,200                                                 
  100 L=1                                                               
      IF(M-1)30,30,40                                                   
C  INTERACTION NEUTRON-----PROTON
   30 MX=M+1                                                            
      RETURN                                                            
C  INTERACTION PROTON-----NEUTRON
   40 MX=M-1                                                            
      RETURN                                                            
  200 IF(YY-(SPN+SPP+SPA))110,110,210                                                 
C  INTERACTION NUCLEON-----ALPHA
  110 MX = 3
C DEFINE TYPE OF INTERACTION (ELASTIC-NONELASTIC)
      CALL CSPANA(T,SEL,2) 
                If(SPA.lt.SEL) SPA = SEL
      YY=SPA * RANDOMG(0)
      IF(YY-SEL)103,103,105                                                 
C ELASTIC INTERACTION N-A
  103 L=3
      RETURN
C DECAY OF ALPHA
C NO DECAY DUE TO PAULI
  105 L=3
      RETURN                                                            
C  INTERACTION NUCLEON-----T,HE3
  210 MX = 4
      L = 6
      RETURN                                                            
C
C PROJECTILE IS ALPHA-PARTICLE
  300 T4 = T/4.
          FI = FIALPH
          FIALPH = 1.
      CALL CSPANA(T4,STOT,1) 
      CALL CSPANA(T4,SEL,2) 
                If(STOT.lt.SEL) STOT = SEL
          FIALPH = FI
      SXX = STOT
      YY=STOT * RANDOMG(0)                                                          
      IF(YY-SEL)1004,1004,1005                                                 
C ELASTIC INTERACTION A-N
 1004 L=4
      GOTO 1007
C DECAY OF ALPHA-PARTICLE
 1005 L=7
      L7 = 1
C
C DEFINE PARTNER
 1007 YY = (QPROTX+QNEUTX) * RANDOMG(0)
      IF(YY-QPROTX)1000,1000,2000    
 1000 MX=2
C  INTERACTION ALPHA-----PROTON
      RETURN                                                            
 2000 MX=1
C  INTERACTION ALPHA-----NEUTRON
      RETURN
      END                                                               
************************************************************************
*                  SUBROUTINE COULCH                                   *
************************************************************************
      SUBROUTINE COULCH(VP,VA,IPAR,AEFF,ZEFF,
     + P11P,RL11P,RM11P,RN11P,ECOP,P11A,RL11A,RM11A,RN11A,ECOA)
C Calculate Coulomb potential for protons and neutrons for inverse
C reaction cross-sections according to Chatterjee (see Block data also)
         IPAR=0
         ECO2=ECOP*ECOP
         B=-2.*P11P*ECOP+RL11P-RN11P/ECO2
         C=P11P*ECO2+RM11P+2.*RN11P/ECOP
C Discriminant of square equation
             D=B*B-4.*P11P*C
             IF(D.LT.0.) GOTO 80
             SQD=SQRT(D)
         ES1=0.5*(-B+SQD)/P11P
         ES2=0.5*(-B-SQD)/P11P
             IF(P11P)10,20,30
10       VP=AMIN1(ES1,ES2)
         GOTO 40
20       WRITE(8,21)P11P
21       FORMAT(1X,'ERROR: SUBROUTINE COULCH  P11P=',E12.5)
          STOP
30       VP=AMAX1(ES1,ES2)
C the same for alpha-particles
40       ECO2=ECOA*ECOA
         B=-2.*P11A*ECOA+RL11A-RN11A/ECO2
         C=P11A*ECO2+RM11A+2.*RN11A/ECOA
C Discriminant of square equation
             D=B*B-4.*P11A*C
             IF(D.LT.0.) GOTO 80
             SQD=SQRT(D)
         ES1=0.5*(-B+SQD)/P11A
         ES2=0.5*(-B-SQD)/P11A
             IF(P11A)50,60,70
50       VA=AMIN1(ES1,ES2)
           GOTO 75
60       WRITE(8,61)P11A
61       FORMAT(1X,'ERROR:   SUBROUTINE COULCH  P11A=',E12.5)
           STOP
70       VA=AMAX1(ES1,ES2)
75       RETURN
  80    WRITE(8,1080)ZEFF,AEFF
1080    FORMAT(1X,'FOR ZEFF=',F6.1,' AEFF=',F6.1,' BLANN SHARP CUT',
     +  'OFF CR SECT IS TAKEN')
        IPAR=1
        RETURN
        END
************************************************************************
*                 SUBROUTINE CROZON                                    *
************************************************************************
      SUBROUTINE CROZON(J1,J2,WM,P1,T,M)
      COMMON/TFERMI/TF(34,4)                                              
      T=T+TF(J2,M)-TF(J1,M)                                                 
      P1=SQRT(T*(T+2.*WM))                                              
      RETURN                                                            
      END                                                               
************************************************************************
*                 FUNCTION CSCHAT                                      *
************************************************************************
      FUNCTION CSCHAT(T0,MPARIN)                                        
C Inverse cross-sections according to Chatterjee A., Murthy K.H.N., 
C Gupta  S.K. Optical reaction cross sections for light projectiles 
C Report IAEA,INDC(IND)- 27/GJ, 1980.
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/AN/AN                                                      
      COMMON/DATREN/RL0N,RL1N,RM0N,RM1N,RN0N,RN1N,RN2N                  
      COMMON/DATREP/P0P,P1P,P2P,RL0P,RL1P,RM0P,RM1P,RN0P,RN1P,RN2P      
             GOTO(1,2,3),MPARIN  
C  NEUTRONS
1       AN13=AN**0.333333333                                            
        AN23=AN13*AN13                                                  
        RL11N=RL0N/AN13+RL1N                                            
        RM11N=RM0N*AN13+RM1N*AN23                                       
        RN11N=RN0N*AN23*AN23+RN1N*AN23+RN2N                             
      CSCHAT=0.001*(RL11N*T0+RM11N+RN11N/T0)                            
         RETURN                                                         
C  PROTONS                                                             
2     AP=AN                                                             
      ECOP=1.44*Z/(1.5*(AP**0.3333333333))                              
      EC2=ECOP*ECOP                                                     
         AM=AP**RM1P                                                    
         P11P=P0P+P1P/ECOP+P2P/EC2                                      
         RL11P=RL0P*AP+RL1P                                             
         RM11P=RM0P*AM                                                  
         RN11P=AM*(RN0P+RN1P*ECOP+RN2P*EC2)                             
C   EKSI=AMAX1(T0,ECOP)  CEAC T0 BCEA > ECOP                        
       EKSI=T0                                                          
      CS=P11P*((T0-EKSI)**2)+RL11P*T0+RM11P+RN11P*(2.-T0/EKSI)/EKSI     
      CSCHAT=0.001*CS      
        RETURN                                                          
C NO CALCULATIONS FOR ALPHA INCIDENT
3       CSCHAT=0.0
        RETURN                                                          
        END                                                             
************************************************************************
*                 SUBROUTINE CSPANA                                    *
************************************************************************
      SUBROUTINE CSPANA(T,SPA,ITYPE)                                      
* Nucleon-alpha interaction cross-sections (fm**2)
* Data are correct only for T < 1 GeV                                                                      
C ITYPE=1 total, =2 elastic
      COMMON/XPARAM/XPARAM,FI
      GOTO(1,2),ITYPE
C Total
1     IF(T-1.125)30,30,10                                                 
   10 IF(T-20.)  40,40,20                                                
   20 IF(T-190.)50,50,60                                                
C                                                                       
   30 SPA=6754.8*(T**2)  -1608.5*T + 778.94    
      SPA=0.1*FI*SPA
      RETURN                                                            
C                                                                       
   40 SPA=7467.2/(T**1.6089) -51.109*T + 1773.7    
      SPA=0.1*FI*SPA
      RETURN                                                            
C                                                                       
   50 SPA=5230.0/(T**0.43473) + 1.2270*T  -658.81        
      SPA=0.1*FI*SPA
      RETURN                                                            
C                                                                        
   60 SPA= 3425.3/T + 0.073484* T  +  74.410    
      SPA=0.1*FI*SPA
      RETURN                                                            
C
C Elastic
2     IF(T-1.125)300,300,100                                                 
  100 IF(T-20.)  400,400,200                                                
  200 IF(T-190.)500,500,600                                                
C                                                                       
  300 SPA=6754.8*(T**2)  -1608.5*T + 778.94    
      SPA=0.1*FI*SPA
      RETURN                                                            
C                                                                       
  400 SPA=7466.4/(T**1.6338) -53.939*T + 1815.2    
      SPA=0.1*FI*SPA
      RETURN                                                            
C                                                                       
  500 SPA=10182.0/(T**0.76746) + 0.68190*T  -282.56             
      SPA=0.1*FI*SPA
      RETURN                                                            
C                                                                        
  600 SPA=  4833.8/T + 0.036414* T  -2.9546    
      SPA=0.1*FI*SPA
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE CSPPPN                                    *
************************************************************************
      SUBROUTINE CSPPPN(T,SPP,SPN)                                      
* Nucleon-nucleon interaction cross-sections (fm**2)
      IF(T-40.)30,30,10                                                 
   10 IF(T-310.)40,40,20                                                
   20 IF(T-400.)50,50,60                                                
C                                                                       
   30 SPN=-505.74/T**2+906.92/T+0.69466                                 
      SPP=-117.42/T**2+308.85/T+0.53107                                 
      RETURN                                                            
C                                                                       
   40 SPN=23938./T**2+180.2/T+2.7147                                    
      SPP=9307.4/T**2-1.1148/T+2.2429                                   
      RETURN                                                            
C                                                                       
   50 SPN=23938./T**2+180.2/T+2.7147                                    
      SPP=88.737/T+.005337*T+.35475                                     
      RETURN                                                            
C                                                                       
   60 SPN=3.45                                                          
      SPP=88.737/T+.005337*T+.35475                                     
      RETURN                                                            
      END                                                               
************************************************************************
*                  SUBROUTINE DEFINE_ED                                *
************************************************************************
       SUBROUTINE DEFINE_ED
C Effective threshold damage energy Ed (eV)
C Data are from NJOY, except global value (NJOY: 25 eV)
       COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB  /EDEFF/Ed
       Ed=40.
       IZ=Ifix(Z+0.0001)
       If(IZ.eq. 4) Ed=31.
       If(IZ.eq. 6) Ed=31.
       If(IZ.eq.12) Ed=25.
       If(IZ.eq.13) Ed=27.
       If(IZ.eq.14) Ed=25.
       If(IZ.eq.20) Ed=40.
       If(IZ.ge.22.and.IZ.le.29) Ed=40.
       If(IZ.eq.40) Ed=40.
       If(IZ.eq.41) Ed=40.
       If(IZ.eq.42) Ed=60.
       If(IZ.eq.47) Ed=60.
       If(IZ.eq.73) Ed=90.
       If(IZ.eq.74) Ed=90.
       If(IZ.eq.79) Ed=30.
       If(IZ.eq.82) Ed=25.
C --> keV
       Ed=Ed/1000.
       Return
       End
************************************************************************
*                  SUBROUTINE DENS                                     *
************************************************************************
      SUBROUTINE DENS
* Level density calculation (idea of M.Blann)
      DOUBLE PRECISION POW,SQ11,EE,PT,UCLA
      COMMON/LAB10/POW(6,10000) /LAB3/SIG(6,2000)
      COMMON/LAB4/UCLA(6,2000) /INCR/ED
      COMMON/DATINI/RA,T0,W0                                            
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/AN/AN /BOND1/QBON(200,200,6)                                      
      COMMON/MPARIN/MMM /JMAX1/TENED,JMAX
      COMMON/XPARAM/XPARAM,FIALPH 
      DIMENSION RD(6)
        IF(MMM.le.2) MPARIN=MMM
        IF(MMM.eq.3) MPARIN=6
      ED=0.5
C
C                 1-N, 2-P, 3-D, 4-T, 5-HE3, 6-A
C
      DO 6 I=1,2000
      DO 6 K=1,6
  6   UCLA(K,I)=0.
         ZEFF=Z
         AEFF=AN
      XMAX= T0+QBON(1,1,MPARIN)            
      If(QBON(1,1,6).lt.0.0) XMAX= T0+QBON(1,1,MPARIN)-QBON(1,1,6)
      IMAX=INT(XMAX/ED+1.)
      IF(IMAX.GT.2000)Print 30000
      IF(IMAX.GT.2000)IMAX=2000
      PLD=1./XPARAM
      M3 = 6
C Inverse reaction cross-sections 
      CALL SIGICH(ZEFF,AEFF)
      AMASS=AEFF
C This value corresponds to 150 MeV energy for total equilibrium spectra
      QJMAX=FLOAT(150)/ED
      JMAX=INT(QJMAX)
      IF(JMAX.GT.2000)JMAX=2000
      TENED=10.*ED
      RR=AMASS/PLD
      SOR=SQRT(RR*100.)
C
C Level density parameters for particles channels POW(I)
      RD(1)=(AMASS-1.)/PLD
      RD(2)=(AMASS-1.)/PLD
      RD(3)=(AMASS-2.)/PLD
      RD(4)=(AMASS-3.)/PLD
      RD(5)=(AMASS-3.)/PLD
      RD(6)=(AMASS-4.)/PLD
C
      DO 7050 L=1,M3
      DO 7050 IB=1,10000
      BJ=DFLOAT(IB)/10.-.05
      SQ=2.*SQRT(RD(L)*BJ)-SOR
      SQ11=SQ
 7050 POW(L,IB)=(1./(1.+BJ**1.25))*DEXP(SQ11)
C Energy to join Fermi gas and constant temperature
      EX=2.
      TEN=10.*EX+0.05
      IT=INT(TEN)
      IF=IT-1
      DO 7047 L=1,M3
      TEMP=SQRT(EX/RD(L))
      D=EXP((EX)/TEMP)
      CQ1=POW(L,IT)/D
      DO 7048 IB=1,IF
      EE=0.10*DFLOAT(IB)-0.05
      POW(L,IB)=CQ1*DEXP((EE)/TEMP)
7048  CONTINUE
7047  CONTINUE
         Print *,'Level density calculated...' 
      DO 4000 KJ=1,M3
      PRINT *,KJ
      DO 1000  I=1,IMAX
      EMAX=FLOAT(I-1)*ED 
      M=INT(EMAX/ED+1.0001)
      IF(M-JMAX)415,415,410
  410 M=JMAX
  415 IF(M-1)430,420,420
  430 Print *,'M < 1'
      Goto 1000
  420 PT=0.0
          BI=10.*EMAX+0.05
          IB=INT(BI)
          If(IB.gt.10000) IB = 10000
          IF(IB.LE.0) GO TO 1000
      DO 435 L=1,M
      IF(IB.LT.1)GO TO 435
      PT=PT+POW(KJ,IB)*SIG(KJ,L)
      BI=BI-TENED
      IB=BI
  435 CONTINUE
      UCLA(KJ,I) = PT
 1000 Continue
 4000 Continue
      Return
30000 Format(//1x,60('')/1x,5x,'ATTENTION!  IMAX is REDEFINED'
     # /1x,60(''))
      End
************************************************************************
*                 SUBROUTINE DISTPA                                    *
************************************************************************
      SUBROUTINE DISTPA(JZ)                                        
      COMMON/DAINT/PF(33,4),RO1(33),RZON(33),FIG                          
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/PARTNR/PPX,PPY,PPZ,PP,MX                                   
      COMMON/DATCHO/RMP                                                 
      COMMON/TYPACT/L,L7
      COMMON/URAND1/IYG
      COMMON/k1996/k1996                                                 
      COMMON/XPARAM/XPARAM,FIALPH
C
C Types of interactions:  L = 1  N-P or P-N
C                         L = 2  N-N or P-P
C                         L = 3  Elastic NUCLEON-ALPHA
C                         L = 4  Elastic ALPHA-NUCLEON 
C                         L = 5  Decay of ALPHA in N-A interaction 
C                         L = 6  NUCLEON-T OR NUCLEON-HE-3
C                         L = 7  Decay of ALPHA in A-N interaction 
C
C Temporarily: no averaging,  L=5 is considered by SEL:
C For L=6 cross-sectios are taken the same for all T or HE-3
       GOTO(1,2,3,4,5,106,7),L
1      CALL CSPPPN(T,SPP,SYY)
       GOTO 8
2      CALL CSPPPN(T,SYY,SPN)
       GOTO 8
3      CALL CSPANA(T,SYY,2) 
       GOTO 8
4      T4 = T/4.
       FI = FIALPH
       FIALPH = 1.
       CALL CSPANA(T4,SYY,2) 
       FIALPH = FI
       GOTO 8
5      CALL CSPANA(T,STOT,1) 
       CALL CSPANA(T,SEL,2) 
                SYY = STOT-SEL
                If(SYY.lt.0.0) SYY = 0.0
       GOTO 8
7      T4 = T/4.
       FI = FIALPH
       FIALPH = 1.
       CALL CSPANA(T4,STOT,1) 
       CALL CSPANA(T4,SEL,2) 
                SYY = STOT-SEL
                If(SYY.lt.0.0) SYY = 0.0
       FIALPH = FI
C
8      UU=RANDOMG(0)   
       IF(UU.ge.1.0) UU=0.99999
       RKSI = SYY * INT( 10.*UU + 1.0 )
106                PFM=PF(JZ,MX)
C
             VX = PX/WP
             VY = PY/WP
             VZ = PZ/WP
             V  = P /WP
       WPP=WM(MX)
       CALL WERO(PFM,PP,MX)
C
      KSS =0  
9       SUM = 0.
        DO 900 II=1,15
C                                                                       
      QCOS=1.-2.*RANDOMG(0)                                                   
      FI=6.283185*RANDOMG(0)                                                  
      QSIN=SQRT(ABS(1.-QCOS**2))                                        
      CC=PP*QSIN                                                        
      PPX=CC*COS(FI)                                                    
      PPY=CC*SIN(FI)                                                    
      PPZ=PP*QCOS                                                       
      EP=SQRT(PP*PP+WPP*WPP)                                            
      TRE=((E*SQRT(PP*PP+WPP*WPP)-PX*PPX-PY*PPY-PZ*PPZ)/WPP)-WP         
             VXP = PPX/WPP
             VYP = PPY/WPP
             VZP = PPZ/WPP
        VV = SQRT((VXP-VX)**2 +(VYP-VY)**2 +(VZP-VZ)**2 )/V
C
C DEFINE CROSS-SECTION
C
       GOTO(10,20,30,40,50,60,70),L
10     CALL CSPPPN(TRE,SPP,SZZ)
       GOTO 800
20     CALL CSPPPN(TRE,SZZ,SPN)
       GOTO 800
30     CALL CSPANA(TRE,SZZ,2) 
       GOTO 800
40     T4 = TRE/4.
       FI = FIALPH
       FIALPH = 1.
       CALL CSPANA(T4,SZZ,2) 
       FIALPH = FI
       GOTO 800
50     CALL CSPANA(TRE,STOT,1) 
       CALL CSPANA(TRE,SEL,2) 
                SZZ = STOT-SEL
                If(SZZ.lt.0.0) SZZ = 0.0
       GOTO 800
60     RETURN
70     T4 = TRE/4.
       FI = FIALPH
       FIALPH = 1.
       CALL CSPANA(T4,STOT,1) 
       CALL CSPANA(T4,SEL,2) 
                SZZ = STOT-SEL
                If(SZZ.lt.0.0) SZZ = 0.0
       FIALPH = FI
C
800    SUM = SUM + SZZ * VV
C                                1  2  3  4   5  6   7
           If(SUM.ge.RKSI) GOTO(99,99,99,99,905,99,907),L
900    Continue
C
950    k1996 = k1996+1
                           GOTO(99,99,99,99,905,99,907),L
99    RETURN
C-----------------------------L=5-----------------------------------
C REDEFINITION OF PARTNER TYPE FOR ALPHA-DECAY (L=5)
905   PP=PP/4.                                                        
      PPX=PPX/4.                                                    
      PPY=PPY/4.                                                    
      PPZ=PPZ/4.                                                       
      TP = (PP**2)/(2.*WM(1))
      CALL CSPPPN(TP,SPP,SPN)
      YY=(SPN+SPP) * RANDOMG(0)
      IF(YY-SPP)11,11,22                                                 
C  INTERACTION WITH THE SAME TYPE
   11 MX=M                                                              
      L=2                                                               
      RETURN                                                            
   22 L=1                                                               
      IF(M-1)33,33,44                                                   
C  INTERACTION NEUTRON----PROTON
   33 MX=M+1                                                            
      RETURN                                                            
C  INTERACTION PROTON-----NEUTRON
   44 MX=M-1                                                            
      RETURN                                                            
C-----------------------------L=7-----------------------------------
C REDEFINITION OF TYPE OF INCIDENT PARTICLE FOR ALPHA-DECAY (L=7)
907   CALL MEMDEC(1)
      WP = WP/4.   
      PX = PX/4.
      PY = PY/4.
      PZ = PZ/4.
      P  = P /4.
      T  = T /4.
      E  = E /4.
      CALL CSPPPN(T,SPP,SPN)
      YY=(SPN+SPP) * RANDOMG(0)
      IF(YY-SPP)111,111,222                                                 
C  INTERACTION WITH THE SAME TYPE
  111  M=MX                                                              
       L=2                                                               
       RETURN                                                            
  222  L=1                                                               
       IF(MX-1)333,333,444                                                   
C  INTERACTION NEUTRON----PROTON
  333  M=MX+1                                                            
       RETURN                                                            
C  INTERACTION PROTON----NEUTRON
  444  M=MX-1                                                            
       RETURN                                                            
       END                                                               
************************************************************************
*                 SUBROUTINE EVAPAR                                    *
************************************************************************
      SUBROUTINE EVAPAR                                                 
      COMMON/DATEVA/GP,GD,GT,GHE,GAL,GAMP,GAMD,GAMT,GAMHE,GAMAL,CP,CD,  
     *CT,CHE,CAL,VP,VD,VT,VHE,VAL,QN,QP,QD,QT,QHE,QAL                   
      COMMON/EVATR2/WEIG,VX,VY,VZ                                       
      COMMON/EVAMAS/NEVAN,NEVAP,NEVAD,NEVAT,NEVAHE,NEVAAL               
      COMMON/TR1EVA/EXCIT,WMAI /URAND1/IYG                                   
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/SUM90/ER90,KER90
      COMMON/INFDIS/INFDIS,INFOUP(3)
      DIMENSION WIDTH(6),TAUX(6)
      WEIG=WMAI                                                         
                   ER90=ER90+EXCIT
                   KER90=KER90+1
    1 CALL QBOND(EXCIT,WIDTH,TAUX,KEY)                   
         IF(KEY.EQ.0) RETURN
      CC=RANDOMG(0)
      DO 2 KX = 1,6
      IF(CC.LE.WIDTH(KX)) GOTO 3
    2 CONTINUE
      PRINT 1000,WIDTH,CC
      STOP
    3 GOTO(11,22,33,44,55,66),KX
C N
   11 NEVAN=NEVAN+1                                                     
      CALL FLIG(1,TAUX(1),E)
      WPAR=WM(1)
      WEIG = WEIG - WPAR
      EXCIT = TAUX(1) - E
      IF(INFOUP(1).EQ.1)CALL MEMEQU(E,1)
      GOTO 200
C P 
   22 NEVAP=NEVAP+1                                                     
      CALL FLIG(2,TAUX(2),E)
      WPAR=WM(2)
      WEIG = WEIG - WPAR
      EXCIT = TAUX(2) - E
      IF(INFOUP(2).EQ.1)CALL MEMEQU(E,2)
      GOTO 200
C D 
   33 NEVAD=NEVAD+1                                                     
      CALL FLIG(3,TAUX(3),E)
      WPAR=WM(5)
      WEIG = WEIG - WPAR
      EXCIT = TAUX(3) - E
      GOTO 200
C T 
   44 NEVAT=NEVAT+1                                                     
      CALL FLIG(4,TAUX(4),E)
      WPAR=WM(4)
      WEIG = WEIG - WPAR
      EXCIT = TAUX(4) - E
      GOTO 200
C HE3
   55 NEVAHE=NEVAHE+1                                                     
      CALL FLIG(5,TAUX(5),E)
      WPAR=WM(4)
      WEIG = WEIG - WPAR
      EXCIT = TAUX(5) - E
      GOTO 200
C A 
   66 NEVAAL=NEVAAL+1                                                     
      CALL FLIG(6,TAUX(6),E)
      WPAR=WM(3)
      WEIG = WEIG - WPAR
      EXCIT = TAUX(6) - E
      IF(INFOUP(3).EQ.1)CALL MEMEQU(E,3)
  200 V=VELOC(WPAR,WEIG,E)                                              
      CC=RANDOMG(0)
      QCOS=1.-2.*CC                                                     
      QSIN=SQRT(ABS(1.-QCOS*QCOS))                                      
      CC=RANDOMG(0)
      FI=6.2831852*CC                                                   
      VX=VX+V*QSIN*COS(FI)                                              
      VY=VY+V*QSIN*SIN(FI)                                              
      VZ=VZ+V*QCOS                                                      
      GOTO 1                                                            
C
 1000 FORMAT(1X,'CONTROL SUBR EVAPAR:'/1X,6G12.5/1X,G12.5)
      END                                                               
************************************************************************
*                  FUNCTION FC                                         *
************************************************************************
      FUNCTION FC(T,B)
C Written by Barashenkov, Polanski
      COMMON /FH/AMP,AMT,AP,AT,B0,R0
C     CMS ENERGY
      TC=T*AMT/(AMP+AMT)
      X=(TC-B)/1.2
      IF(X.GT.5) GO TO 1      
      D=1.+EXP(X)
      FC=ALOG(D)/TC
      RETURN
  1   FC=X/TC
      RETURN
      END
************************************************************************
*                  FUNCTION FHS                                        *
************************************************************************
      FUNCTION FHS(IS,E,C)
C Written by Barashenkov, Polanski
C     CALCULATION OF HIGH-ENERGY TOTAL (IS=2) AND
C     INELASTIC (IS=1) CROSS-SECTIONS
C      E - LAB. KINETIC ENERGY OF PROJECTILE(MEV)
      COMMON/FH/AM      P,AMT,AP,AT,B0,R0
C     SQUARED PROJECTILE CMS MOMENTUM
      PPC=AMT*AMT*E*(E+2.*AMP)/((AMP+AMT)**2+2.*AMT*E)
C     DE BROGLE WAVE LANGTH
      AL=1.41*140./SQRT(PPC)
      EC=SQRT(PPC+AMP*AMP)-AMP
C     COULOMB BARRIER
      B=B0/R0/(AP+AT+AL)
      FHS=31.416*1.21*(1.-B/EC)*(AP+AT+1.85*AP*AT/(AP+AT)
     *+AL-C)**2*IS
      RETURN
      END
************************************************************************
*                 SUBROUTINE FLIG                                      *
************************************************************************
      SUBROUTINE FLIG(KJ,TAUX,E)
      DOUBLE PRECISION UCLA,WTOT,PT,POW
      COMMON/URAND1/IYG  /MAIIPR/IPR                                    
      COMMON/LAB10/POW(6,10000)
      COMMON/LAB3/SIG(6,2000)
      COMMON/LAB4/UCLA(6,2000)
      COMMON/INCR/ED
      COMMON/JMAX1/TENED,JMAX
      E=0.
      M=INT(TAUX/ED+1.)
      EMAX=FLOAT(M-1)*ED 
            CC=RANDOMG(0)
            WTOT = CC*UCLA(KJ,M) 
      IF(M-JMAX)415,415,410
  410 M=JMAX
  415 IF(M-1)430,420,420
  430 RETURN
C
  420    PT=0.0
         BI=10.*EMAX+0.05
         IB=INT(BI)
         If(IB.gt.10000) IB = 10000
         IF(IB.LE.0) RETURN
C
      DO 435 L=1,M
      IF(IB.LT.1)GO TO 435
      PT=PT+POW(KJ,IB)*SIG(KJ,L)
      IF(PT.GE.WTOT) GOTO 500
      BI=BI-TENED
      IB=BI
  435 CONTINUE
      PRINT *,'BAD INTEGRAL: ',PT,' < ',WTOT,' CC=',CC 
  500 E=FLOAT(L)*ED - ED/2.
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE GRAPH                                     *
************************************************************************
      SUBROUTINE GRAPH(Y,F,N3,IALOG)                                     
* IALOG.ne.0 : logarithmic scale for function (Y)
      COMMON/MAIIPR/IPR1                                                
      DIMENSION Y(N3),F(N3),F1(150)                                     
      INTEGER A1(40),B1,C1,D1,D2,D3,D4,D5,D6                            
      DATA B1,C1,D1,D2,D5,D6/1H*,1H ,1H!,1H-,1HI,1H./                   
      IF(N3.GT.150)STOP
      N1=1                                                              
      W=F(1)                                                            
      DO 1 L=1,N3                                                       
      IF(ABS(W).GT.ABS(F(L)))GOTO 1                                     
      W=F(L)                                                            
    1 CONTINUE                                                          
      IF(W.NE.0.)GOTO 70                                                
      WRITE(IPR1,41)                                                    
   41 FORMAT(1X,' SUBR GRAPH: MAXIMAL FUNCTION VALUE IS EQUAL TO ZERO')      
      RETURN                                                            
   70 IF(IALOG.NE.0)GOTO 199                                            
      WRITE(IPR1,60)                                                    
   60 FORMAT(/3X,'Agrument    Function   ',4X,4('.........!'))          
      T=40./ABS(W)                                                      
      DO 300 I=1,N3                                                     
  300 F1(I)=F(I)                                                        
      GOTO 7                                                            
  199 WMIN=1.E+10                                                       
      DO 200 I=1,N3                                                     
      IF(F(I).NE.0..AND.F(I).LT.WMIN)WMIN=F(I)                          
  200 CONTINUE                                                          
      IMAX=-8                                                           
  210 IF(W.LE.10.**IMAX)GOTO 220                                        
      IMAX=IMAX+1                                                       
      GOTO 210                                                          
  220 IMIN=IMAX                                                         
  230 IF(WMIN.GE.10.**IMIN)GOTO 240                                     
      IMIN=IMIN-1                                                       
      GOTO 230                                                          
  240 R10=10.**IMIN                                                     
      IF(IMIN.EQ.IMAX)GOTO 250                                          
      WW1=FLOAT(IMIN)                                                   
      WW=FLOAT(IMAX-IMIN)                                               
      R20=10.**IMAX                                                     
      WRITE(IPR1,62)R10,R20                                             
   62 FORMAT(1X,5X,'LOGARITHMICAL SCALE FOR FUNCTION'
     1/3X,23X,E8.2,32X,E8.2)  
      GOTO 260                                                          
  250 WW1=ALOG10(WMIN)                                                  
      WW=ALOG10(WMAX)-ALOG10(WMIN)                                      
  260 DO 270 I=1,N3                                                     
      FF=F(I)                                                           
      IF(FF.EQ.0.)FF=R10                                                
  270 F1(I)=ALOG10(FF)-WW1                                              
      WRITE(IPR1,63)                                                    
   63 FORMAT(/3X,'Agrument    Function   ',4X,4('..........'))          
      T=40./WW                                                          
    7 CONTINUE                                                          
      DO 3 I=1,N3                                                       
      X=F1(I)                                                           
      N=INT(X*T)                                                        
      IF(I.EQ.N3)GOTO 105                                               
      IF(I.EQ.N1*10)GOTO 107                                            
      D4=C1                                                             
      GOTO 108                                                          
  105 D4=D6                                                             
      GOTO 108                                                          
  107 D4=D2                                                             
      N1=N1+1                                                           
  108 N2=1                                                              
      DO 4 J1=1,40                                                      
      IF(J1.EQ.20)GOTO 110                                              
      IF(J1.EQ.1.OR.J1.EQ.40)GOTO 24                                    
      D3=D4                                                             
      GOTO 25                                                           
   24 D3=D5                                                             
   25 CONTINUE                                                          
      GOTO 111                                                          
  110 D3=D1                                                             
      N2=N2+1                                                           
  111 CONTINUE                                                          
      IF(J1.EQ.N)GOTO 101                                               
      A1(J1)=D3                                                         
      GOTO 102                                                          
  101 A1(J1)=B1                                                         
  102 CONTINUE                                                          
    4 CONTINUE                                                          
      WRITE(IPR1,61)Y(I),F(I),A1                                        
   61 FORMAT(G12.5,1X,1PE12.5,5X,40A1)                                  
    3 CONTINUE                                                          
      RETURN                                                            
      END                                                               
************************************************************************
*                   SUBROUTINE INIDAT                                  *
************************************************************************
      SUBROUTINE INIDAT(KZONESC)
      COMMON/DATINI/RA,T0,W0  /DAINT/PF(33,4),RO1(33),RZON(33),FIG                          
      COMMON/DATCHO/RMP /TFERMI/TF(34,4)                                              
      COMMON/DATEVA/GP,GD,GT,GHE,GAL,GAMP,GAMD,GAMT,GAMHE,GAMAL,CP,CD,  
     *CT,CHE,CAL,VP,VD,VT,VHE,VAL,QN,QP,QD,QT,QHE,QAL                   
      COMMON/K/K /DATOUT/SGEOM,FOUT 
      COMMON/DATTR1/QNN,QPP /URAND1/IYG  /DATPAU/BONCUT(3)
      COMMON/EMEM/EMEM0(21),EMEM(21),RMEM(21,3),RMEM0(21,3),HMEM
      COMMON/RNUCL/RNUCL/CSABS/CSABS,FIALP2
      COMMON/EOUT/SPE(19,5,3),PI(19),EOUT1(5,3),EOUT2(5,3),MSPE
      COMMON/TEMP2/BONNE/NREJ/REFR,NREJ/MM/RMASS      
      COMMON/QPARX/QPROT,QNEUT,QPROT2,QNEUT2 /BOND1/QBON(200,200,6)                                      
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/ALIBLI/ALINPK(6),BLINPK(6),ALINPC(6),BLINPC(6),         
     *ALINAK(6),BLINAK(6),ALINAC(6),BLINAC(6)                        
      COMMON/DOSTRO/RKPD(6),RKAD(6),CPD(6),CAD(6),ZD(6)              
      COMMON/QNNN/QNNN /MAIIPR/IPR /AN/AN /INF/INFBIG,INFS0     
      COMMON/EMEM91/EMEMT(21),RMEMT(21),HMEMT                        
      COMMON/SPEFUL/ANGLIM(9,2,3),ANGSUM(21,9,3),ANGCEN(9,3),DCEN,MANG
      COMMON/XPARAM/XPARAM,FIALPH /MPARIN/MPARIN  
      DIMENSION A1(10),A2(33),A(33)
C
C  Number of zones (K)                                 
C  Values to approximate Woods-Saxon distribution
C 1.0 corresponds to the center of the nucleus
C 10 zones
      DATA A1/ 0.9, 0.8, 0.5, 0.3, 0.2, 0.1,  0.075, 0.05, 0.025, 0.01/  
C 33 zones
      DATA A2/ 
     *  0.98, 0.95,  0.90, 0.85,  0.80, 0.75, 0.70,  0.60,  0.50, 0.40,
     *  0.30, 0.20,  0.10, 0.08,  0.06,  0.04, 0.02, 0.01, 0.008, 0.006, 
     *  0.004, 0.002, 0.001, 8.e-4, 6.e-4, 4.e-4, 2.e-4, 1.e-4, 8.e-5,
     *  6.e-5, 4.e-5, 2.e-5, 1.e-5/
                            If(KZONESC.eq.0) KZONESC=1
                            If(KZONESC.lt.1.or.KZONESC.gt.2) goto 2000
C
C KZONESC =1 : 10 zones;  = 2 :  33 zones
       If(KZONESC.eq.1) then
       K=10                                                            
       Do i=1,K
       A(i)=A1(i)
       Enddo  
                        else
       K=33                                                            
       Do i=1,K
       A(i)=A2(i)
       Enddo  
                        endif 
       AM=AN                      
C  QPROT2,QNEUT2  are for zones with alpha-particles
      QPROT=Z/AN                                                        
      QNEUT=(AN-Z)/AN                                                   
         QPROT2=(Z-2.*FIALPH*AN)/(AN-3.*FIALPH*AN)
         QNEUT2=(AN-Z-2.*FIALPH*AN)/(AN-3.*FIALPH*AN)
C Recalculation FIALPH
      FIALP2=FIALPH
      FIALPH=FIALPH*AN/(AN-3.*FIALPH*AN)
      ONE=QPROT2+QNEUT2+FIALPH
      print *,'ONE=',ONE
      RMASS=1./(1.+AM)                                                  
C Effective nucleus radius 
      RNUCL=1.25*(AM**0.3333333333)                                     
C Nuclear density
      DATA AA/0.545/,RO/0.17/                                           
      R=1.07*(AN**0.333333333)                                          
      X1=(3.*(3.1415926**2))**0.333333333                               
      PARTFM=0.5*(20.7214+20.74998)*(X1**2)                             
      PARPFM=197.3285*X1                                                
C
      RMP=0.5*(938.2796+939.5731)                                       
      PRINT 69                                                          
      IF(INFBIG.GT.0)WRITE(IPR,69)                                      
C
C PF(I,M), TF(I,M):
C M = 1   neutron
C M = 2   proton 
C M = 3   alpha-particle
C M = 4   He-3, triton 
       DO 1 I=1,K                                                       
          RO1(I)=A(I)*RO                                                
          ROPRO=RO1(I)*QPROT                                            
          RONEU=RO1(I)*QNEUT                                            
          RZON(I)=R+AA*ALOG((1.-A(I))/A(I))                             
          PF(I,2)=PARPFM*(ROPRO**0.333333333)                             
          TF(I,2)=PARTFM*(ROPRO**0.666666666)                             
          PF(I,1)=PARPFM*(RONEU**0.333333333)                             
          TF(I,1)=PARTFM*(RONEU**0.666666666)                             
          TFEFF=QPROT*TF(I,2)+QNEUT*TF(I,1)
          PFEFF=SQRT(2.*RMP*TFEFF)                                      
             TF(I,3) = 4.* TFEFF
             PF(I,3) = SQRT(2.*WM(3)*TF(I,3))                                      
          TF(I,4) = 3.* TFEFF
          PF(I,4) = SQRT(2.*WM(4)*TF(I,4))                                      
          PRINT 70,I,RZON(I),RO1(I),
     *    PF(I,2),PF(I,1),PF(I,3),TF(I,2),TF(I,1),TF(I,3),PFeff,TFeff 
          IF(INFBIG.GT.0)WRITE(IPR,70)I,RZON(I),RO1(I),
     *    PF(I,2),PF(I,1),PF(I,3),TF(I,2),TF(I,1),TF(I,3),PFeff,TFeff 
C TF and PF for neutrons and protons
          PF(I,1)=PFEFF
          TF(I,1)=TFEFF
              PF(I,2)=PFEFF
              TF(I,2)=TFEFF
    1  CONTINUE                                                         
   69 FORMAT(1X,'ZONE RADIUS  DENS ',
     *' PF(P) PF(N)  PF(A) TF(P) TF(N) TF(A) PF(Eff) TF(Eff)')                 
   70 FORMAT(1X,1x,I2,1x, F7.2,  F7.4, 2F6.1, F7.1, 3F6.1, 2F8.2)                  
C Number of division for free particle path (not used)
      FIG=3.
      FOUT=FIG                                                          
C Woods-Saxon nucleus radius                                       
      RA=RZON(K)                                                       
C Mass of incident particle             
                       W0=939.5731                                                     
        IF(MPARIN.EQ.2)W0=938.2796                                      
        IF(MPARIN.EQ.3)W0=4.0026033*931.4812 
C                                                                       
C For Dostrovsky inverse cross-section ( Barashenkov, Toneev Book,1972 p.413)
C Dostrovsky coeff = ALINAK * Z + BLINAK                              
           DO 555 I=2,6                                                 
         ZZ=ZD(I)-ZD(I-1)                                               
              ALINPK(I)=(RKPD(I)-RKPD(I-1))/ZZ                          
              BLINPK(I)=-ALINPK(I)*ZD(I-1)+RKPD(I-1)                    
                ALINPC(I)=(CPD(I)-CPD(I-1))/ZZ                          
                BLINPC(I)=-ALINPC(I)*ZD(I-1)+CPD(I-1)                   
         ALINAK(I)=(RKAD(I)-RKAD(I-1))/ZZ                               
         BLINAK(I)=-ALINAK(I)*ZD(I-1)+RKAD(I-1)                         
           ALINAC(I)=(CAD(I)-CAD(I-1))/ZZ                               
555        BLINAC(I)=-ALINAC(I)*ZD(I-1)+CAD(I-1)                        
C  See also BLOCK DATA                                                 
C                                                                       
C Geometrical cross-section             
      SGEOM=(3.1415926E-02)*((RA+4.552/SQRT(T0))**2)                    
        QN=QBON(1,1,1)                                                  
        QP=QBON(1,1,2)                                                  
      TF(K+1,1)=-QN                                       
      TF(K+1,2)=-QP                                       
      TF(K+1,3)=-QBON(1,1,6)
      TF(K+1,4)=-0.5*( QBON(1,1,4)+QBON(1,1,5) )
C Redefinition of this value for neutron and proton           
      TF(K+1,1)=QNEUT*TF(K+1,1)+QPROT*TF(K+1,2)
      TF(K+1,2)=TF(K+1,1)
C
       QNN=QN                                                           
       QPP=QP                                                           
           QNNN=QN                                                      
           IF(MPARIN.EQ.2)QNNN=QP                                       
           IF(MPARIN.EQ.3)QNNN=QBON(1,1,6)
C                                                                       
C Coulomb potential for protons and alphas                              
C             VP=0.1*Z+0.8                                              
C             VP=1.44*Z/RNUCL                                           
C best value
              VP=1.0 *Z/RNUCL                                           
CC Zr (N,P) reaction
CC    VP=(  Z-FLOAT(MPARIN-2)  )*1.15/( 1.6 + 1.21*( AN**.3333+1.))     
CC    VP=0.1*Z-0.2                                                      
      VAL=0.21*Z+2.5                                                    
      PRINT 600,VP,VAL                                                  
C                                                                       
C Cut-off parameter BONCUT(1)-neutrons, (2)-protons, (3)-alpha
      BONCUT(1)=-TF(K+1,1)+BONNE                                           
      BONCUT(2)=-TF(K+1,2)+VP+BONNE                                        
      BONCUT(3)=-TF(K+1,3)+VAL+BONNE                                        
      PRINT 1999,QN,QP,BONCUT(1),BONCUT(2),BONCUT(3),TF(K+1,1),BONNE,VP
        IF(QN.GT.-TF(K+1,1))BONCUT(1)=QN+BONNE                             
        IF(QP.GT.-TF(K+1,2))BONCUT(2)=QP+VP+BONNE                          
      PRINT 1999,QN,QP,BONCUT(1),BONCUT(2),BONCUT(3),TF(K+1,1),BONNE,VP
 1999 FORMAT(1X,' QN=',F6.2,' QP=',F6.2,' BONCUT(1)=',F6.2,' (2)=',  
     *F6.2,' (3)=',F6.2,' TF(max)=',F6.2,' BONNE=',F6.2,' VP=',F6.2)
C                                                                       
C=======================================================================
C Arrays and auxilarily for calculation energy spectra
C EMEM: evaporation spectrum, EMEM0: non-equilibrium spectrum           
C EMEM=EMEM0. EMEMT: recoil spectrum                                       
      EMEM0(1)=0.                                                       
      RMEM0(1,1)=0.                                                       
      RMEM0(1,2)=0.                                                       
      RMEM0(1,3)=0.                                                       
            QBMIN = QBON(1,1,MPARIN)
       IF(MPARIN.eq.3) QBMIN =QBON(1,1,6)
            If(QBMIN.gt.QBON(1,1,1)) QBMIN = QBON(1,1,1)
            If(QBMIN.gt.QBON(1,1,2)) QBMIN = QBON(1,1,2)
            If(QBMIN.gt.QBON(1,1,6)) QBMIN = QBON(1,1,6)
          HMEM=( T0+QBON(1,1,MPARIN)-QBMIN )/20.                                                     
          IF(MPARIN.eq.3) HMEM=( T0+QBON(1,1,6)-QBMIN )/20.                                                     
          EMEM(1)=0.                                                      
          RMEM(1,1)=0.                                                      
          RMEM(1,2)=0.                                                      
          RMEM(1,3)=0.                                                      
                 HMEMT=(9.*T0/AN)+0.2
         IF(MPARIN.eq.3)  HMEMT=0.3*T0 ! rather arbitrary
                 HMEMT=HMEMT/20.
              EMEMT(1)=0.                                                
              RMEMT(1)=0.                                                
      DO 567 NU=2,21                                                    
      EMEM0(NU)=EMEM0(NU-1)+HMEM                                       
        EMEM(NU)=EMEM(NU-1)+HMEM                                        
          EMEMT(NU)=EMEMT(NU-1)+HMEMT                                   
      RMEM0(NU,1)=0.                                                      
      RMEM0(NU,2)=0.                                                      
      RMEM0(NU,3)=0.                                                      
         RMEM(NU,1)=0.                                                     
         RMEM(NU,2)=0.                                                     
         RMEM(NU,3)=0.                                                     
  567       RMEMT(NU)=0.                                                  
            EMEMT(21)=(9.*T0/AN)+3.0
C
C Arrays for calcualtion total angular distribution
      QPI=3.1415926/18.                                                 
      QAN=0.                                                            
      PI(1)=1.                                                          
      DO 597 IQAN =1,19
      DO 597 IQAN2=1,5
      DO 597 IQAN3=1,3
  597 SPE(IQAN,IQAN2,IQAN3)=0.                                                   
         DO 598 IQAN=2,19                                               
         QAN=QAN+QPI                                                    
  598    PI(IQAN)=COS(QAN)                                              
C
C Arrays for calcualtion of inclusive particle spectra 
C ANGCEN is array for angles (9)
C DCEN is the angular bin for angles  ANGCEN +/- DCEN
           DCEN = 4.
      QPI=3.1415926/180.                                                
            DO 1014 MP = 1,3
      DO 1012 ICEN=1,9
         QAN1= ANGCEN(ICEN,MP) - DCEN
         QAN2= ANGCEN(ICEN,MP) + DCEN
      IF(QAN1.LT.0.0)   QAN1 =0.0
      IF(QAN2.GT.180.0) QAN2 =180.0
      ANGLIM(ICEN,1,MP) = COS(QAN1*QPI)
      ANGLIM(ICEN,2,MP) = COS(QAN2*QPI)
      DO 1011 NU=1,21
1011  ANGSUM(NU,ICEN,MP) = 0.0
1012  CONTINUE
1014       CONTINUE
C=======================================================================
  600 FORMAT(1X,10X,'VP=',F6.1,' VAL=',F6.1)                            
C REFR is the maximal number of reflections for current MC history
      REFR=100.                                                         
      PRINT 731,TF(K+1,1)                                                  
      IF(INFBIG.GT.0)WRITE(IPR,731)TF(K+1,1)                               
  731 FORMAT(1X,' Average binding energy ',E12.5)                       
C
C Define effective threshold damage energy
      CALL DEFINE_ED(Z)
C 
      RETURN                                                            
 2000 Print 2001,KZONESC
      Write(IPR,2001)KZONESC
 2001 Format(' Parameter KZONESC =',i5,' is not valid')
      STOP
      END                                                               
************************************************************************
*                 SUBROUTINE INIPAR                                    *
************************************************************************
      SUBROUTINE INIPAR                                                 
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/K/K /DATINI/RA,T0,W0 /MAIIPR/IPR /MPARIN/MPARIN                                           
      COMMON/URAND1/IYG                                                 
      WP=W0                                                             
      CC=RANDOMG(0)
      RK=RA*SQRT(CC)                                                    
      Z=-RA*SQRT(1.-CC)                                                 
      UU=6.2831852*RANDOMG(0)
      X=RK*COS(UU)                                                      
      Y=RK*SIN(UU)                                                      
      R=RA                                                              
      T=T0                                                              
      JIN=K                                                             
      PX=0.                                                             
      PY=0.                                                             
      P=SQRT(T**2+2.*WP*T)                                              
      PZ=P                                                              
         M=MPARIN                                                       
      CALL TRANS(K+1,K,ITR9)                                            
                    IF(ITR9.NE.0)  GOTO 10
      E=T+WP                                                            
      RETURN                                                            
   10 WRITE(IPR,20)
   20 FORMAT(1X,'ERROR IN INIPAR (REFLECTION AT THE ENTRANCE ',
     1'IN NUCLEUS)')       
      STOP                                                              
      END                                                               
************************************************************************
*                   SUBROUTINE INSEP                                   *
************************************************************************
      SUBROUTINE INSEP                                                  
      COMMON/INFSEP/KSEP(100,4),INFSEP,JSEPM                            
      COMMON/MAIIPR/IPR /IWRI/IWRI                                                  
C JSEPM is maximal number of reactions required
C If INFSEP=1 and input contains 0 0 0, no calculations
         I=0
77       I=I+1
         IF(I.GT.100)GOTO 3000
      READ(5,*)IN,IP,IA
            KSEP(I,1)=IABS(IN)
            KSEP(I,2)=IABS(IP)
            KSEP(I,3)=IABS(IA)
            JSEPM=I
      IF((IABS(IN)+IABS(IP)+IABS(IA)).EQ.0) INFSEP=0
      IF(INFSEP.EQ.0) RETURN
      IF(IN.LT.0.OR.IP.LT.0.OR.IA.LT.0) RETURN
      GOTO 77
3000  WRITE(IPR,4000)
      IF(IWRI.NE.0)WRITE(IWRI,4000)
4000  FORMAT(1X,' SUBR INSEP.  NUMBER OF REACTIONS REQUIRED > 100')
      STOP
      END
************************************************************************
*                   SUBROUTINE INSEP2                                  *
************************************************************************
      SUBROUTINE INSEP2                                                 
      COMMON/INFSEP/KSEP(100,4),INFSEP,JSEPM                            
      COMMON/SEPSEP/RSEP2(100,2),JSEPM2                                 
      COMMON/MAIIPR/IPR                                                 
      COMMON/IWRI/IWRI                                                  
C JSEPM is maximal number of reactions required
C If INFSEP=2 and input contains 0 0 0, no calculations
         I=0
77       I=I+1
         IF(I.GT.100)GOTO 3000
      READ(5,*)ZZZ,AAA
            RSEP2(I,1)=ABS(ZZZ)
            RSEP2(I,2)=ABS(AAA)
            JSEPM2=I
      IF((ABS(ZZZ)+ABS(AAA)).EQ.0.) INFSEP=0
      IF(INFSEP.EQ.0) RETURN
      IF(ZZZ.LT.0..OR.AAA.LT.0.) RETURN
      GOTO 77
3000  WRITE(IPR,4000)
      IF(IWRI.NE.0)WRITE(IWRI,4000)
4000  FORMAT(1X,'SUBR INSEP2. NUMBER OF REACTIONS REQUIRED >  100')
      STOP
      END
************************************************************************
*                   SUBROUTINE INSEP3                                  *
************************************************************************
      SUBROUTINE INSEP3(MM,ZZ,AA)                                       
      COMMON/INFSEP/KSEP(100,4),INFSEP,JSEPM                            
      COMMON/SEPSEP/RSEP2(100,2),JSEPM2                                 
      COMMON/MAIIPR/IPR /IWRI/IWRI                                                  
      MPARIN=MM
      Z=ZZ
      AN=AA
          ZCOMP=Z+FLOAT(MPARIN)-1.
          ACOMP=AN+1.
           IF(MPARIN.eq.3)  ZCOMP=Z+2.
           IF(MPARIN.eq.3)  ACOMP=AN+4.
        DO 10 I=1,JSEPM2
        TOT=ACOMP-RSEP2(I,2)
        ZI=ZCOMP-RSEP2(I,1)
        RNI=TOT-ZI
                 IN=RNI+0.01
                 IP=ZI+0.01
                 IA=0
            KSEP(I,1)=IN
            KSEP(I,2)=IP
10          KSEP(I,3)=IA
            JSEPM=JSEPM2
        RETURN
      END
************************************************************************
*                 SUBROUTINE INTPOP                                    *
************************************************************************
      SUBROUTINE INTPOP(IKS,INT9)                                       
      COMMON/DAINT/PF(33,4),RO1(33),RZON(33),FIG                          
      COMMON/K/K /NDIM/NPAR                                                  
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/PARTNR/PPX,PPY,PPZ,PP,MX                                   
      COMMON/TYPACT/L,L7 /QSUM/QSUM /BOND1/QBON(200,200,6)                 
      COMMON/URAND1/IYG /INFDIS/INFDIS,INFOUP(3)
      COMMON/JACT/JACT /MAIIPR/IPR                                                 
                               INT9=0
      J1=JIN                                                            
C                                                                       
      CC=RANDOMG(0)
C                                                                       
      X1=ALOG(CC)                                                       
   10 CONTINUE                                                          
      J3=J1-1                                                           
      IF(J3)12,12,14                                                    
   12 RZJ0=0.                                                           
      GOTO 16                                                           
   14 RZJ0=RZON(J3)                                                     
   16 CONTINUE                                                          
      RZONX=RZON(J1)                                                    
      CALL ZONWAY(RZONX,RZJ0,J1,J3,J2,SLINE)                            
   20 CONTINUE                                                          
        IF(J1.GT.K)GOTO 1985                                             
      CALL CHOPAR(J1,SXX)                                             
                   IF(MX.eq.0 .or. L.eq.0) GOTO 1995
      PATH=1./(RO1(J1)*SXX)                                             
CCCCC      DSL=PATH/FIG                                                      
      DSL=PATH
      IF(SLINE-DSL)30,30,40                                             
   30 D1=SLINE                                                          
      GOTO 50                                                           
   40 D1=DSL                                                            
   50 X1=X1+D1/PATH                                                     
      HH=D1/P                                                           
                  X=X+HH*PX                                             
                  Y=Y+HH*PY                                             
                  Z=Z+HH*PZ                                             
      R=SQRT(X*X+Y*Y+Z*Z)                                               
      SLINE=SLINE-D1                                                    
      IF(X1)60,52,150                                                   
   52 IF(SLINE)200,53,150                                               
   53 DELTA=0.001                                                       
      GOTO 200                                                          
   60 CONTINUE                                                          
      IF(ABS(SLINE)-0.0001)70,70,20                                     
   70 IF(J1-J2)80,80,140                                                
   80 J2=J1+1                                                           
      IF(J2-K)140,140,90                                                
   90 CONTINUE                                                          
      CALL TRANS(J1,J2,ITR9)                                            
                    IF(ITR9.NE.0)  GOTO 250
      IF(J1-K)10,10,95                                                  
   95            PWX=PWX+PX                                             
                 PWY=PWY+PY                                             
                 PWZ=PWZ+PZ                                             
                 TW=TW+T                                                
      IF(M.NE.3)  QSUM=QBON(NPREN+2*NPREA+1,NPREP+2*NPREA+1,M)+QSUM                            
      IF(M.EQ.3)  QSUM=QBON(NPREN+2*NPREA+1,NPREP+2*NPREA+1,6)+QSUM                            
C
           IF(INFDIS.EQ.1.AND.JACT.NE.0)CALL MEMPRE(M,PX,PY,PZ,T)
C
      IF(M-2)101,102,103                                                
  101 NPREN=NPREN+1                                                     
      GOTO 111                                                          
  102 NPREP=NPREP+1                                                     
      GOTO 111
  103 NPREA=NPREA+1
C
  111 CONTINUE                                                          
      IF(NPAR)112,112,114                                               
  112 IKS=-1                                                            
      RETURN                                                            
  114 IKS=0                                                             
      RETURN                                                            
  140 CONTINUE                                                          
      CALL TRANS(J1,J2,ITR9)                                            
                    IF(ITR9.NE.0)  GOTO 250
  145         E=T+WP                                                    
      GOTO 10                                                           
  150 DELTA=PATH*X1                                                     
  200 HH=DELTA/P                                                        
                  X=X-HH*PX                                             
                  Y=Y-HH*PY                                             
                  Z=Z-HH*PZ                                             
                  R=SQRT(X**2+Y**2+Z**2)                                
      IKS=1                                                             
      JIN=J1                                                            
      CALL DISTPA(J1)                                        
      RETURN                                                            
  250                     INT9=1                                        
                          RETURN
C
C
 1985 PRINT 1986,J1,K                                                   
      WRITE(IPR,1986)J1,K                                               
 1986 FORMAT(1X,' INTPOP  FALSE  J1=',I4,' K=',I4)                      
      STOP                                                              
 1995 PRINT 1996,M,MX,L 
      WRITE(IPR,1996)M,MX,L 
 1996 FORMAT(1X,' ERROR IN CHOPAR: M=',I5,' MX=',I5,' L=',I5)
      STOP                                                              
      END                                                               
************************************************************************
*               SUBROUTINE LEGEN                                       *
************************************************************************
        SUBROUTINE LEGEN(X,P)
        DIMENSION P(30)
        P(1)=1.
        P(2)=X
        DO 1 M=1,7
        RM=FLOAT(M)
    1   P(M+2)=((2.*RM+1.)*X*P(M+1)-RM*P(M))/(RM+1.)
        RETURN
        END
************************************************************************
*                 SUBROUTINE LIBGEN                                    *
************************************************************************
      SUBROUTINE LIBGEN                                                 
      COMMON/MPARIN/MPARIN /QBOCFU/NSUMN,NSUMP /AN/AN                                  
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/LIB91/WINLIB(100,250),INFLIB                               
              A1=1.+AN-FLOAT(NSUMN+NSUMP)+2.  
              Z1=FLOAT(MPARIN-1)+Z-FLOAT(NSUMP)+1. 
        IF(MPARIN.eq.3)   A1=4.+AN-FLOAT(NSUMN+NSUMP)+2.
        IF(MPARIN.eq.3)   Z1=2.+Z-FLOAT(NSUMP)+1. 
      IAA=A1+0.01
      IZZ=Z1+0.01
      IF(IAA.GT.250.OR.IZZ.GT.100) GOTO 1000
      WINLIB(IZZ,IAA)=WINLIB(IZZ,IAA)+1.
      RETURN                                                            
1000  WRITE(12,2000)IAA , IZZ
      WRITE(1,2000)IAA , IZZ
      PRINT 2000,IAA , IZZ
2000  FORMAT(1X,' SUBR. LIBGEN : IAA=',I6,' IZZ=',I6,' EXCEED LIMIT')
      STOP
      END                                                               
************************************************************************
*                 SUBROUTINE LIBOUT                                    *
************************************************************************
      SUBROUTINE LIBOUT(CSNON,RRR)                                      
      REAL*8 ITYP(3),ICS(4)   
      COMMON/MAIIPR/IPR  /IWRI/IWRI /MPARIN/MPARIN                                              
      COMMON/DATINI/RA,T0,W0  /AN/AN                                                      
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/KHIST/KHIST /LIB91/WINLIB(100,250),INFLIB                               
      COMMON/INF/INFBIG,INFS0                                           
      DIMENSION CSNON(4),LA(8),CC(8)
C B=BARASH,G=GEOMETRY,O=OPTICAL,C=CHATTERJEE
      DATA ICS/'B','G','O','C'/                                         
      DATA ITYP/' NEUTRON','  PROTON','   ALPHA'/   
C Output unit           
      M=12
      ITZ=Z+0.01
      ITA=AN+0.01
      IPZ=MPARIN-1
      IPA=1
         IF(MPARIN.eq.3) IPZ=2
         IF(MPARIN.eq.3) IPA=4
C
      REASUM=RRR
C Define nonelastic cross-section
            ICSN=INFS0
            CRSNON=1000.*CSNON(ICSN)
            CRSTMP=CRSNON/REASUM
C
C Form file
        WRITE(M,1000)
1000    FORMAT('1',79('*'))
        KHISTN=REASUM+0.001
        IZSUP=ITZ+IPZ
        IASUP=ITA+IPA
            ISUMAL=0
            DO 50 LLLZ=1,IZSUP
            ISUMZ=0
            DO 20 MMMA=1,IASUP
            IF(WINLIB(LLLZ,MMMA).GE.1.E-04)ISUMZ=1
            IF(ISUMZ.EQ.1)GOTO 25
20          CONTINUE
25          IF(ISUMZ.EQ.1) ISUMAL=ISUMAL+1
50          CONTINUE
C Header
        WRITE(M,1001)ITZ,ITA, T0,ITYP(MPARIN),CRSNON,ICS(ICSN),
     %               ISUMAL,KHISTN
1001    FORMAT(I3,I4,F8.1,' MEV',A8,F9.1,A1,'   (',I2,'Z)',
     %      3X,'   DISCA',I7)
        DO 500 I=1,IZSUP
        IZ=IZSUP-I+1
        ISUMZ=0
        DO 200 JJ=1,IASUP
        IF(WINLIB(IZ,JJ).GE.1.E-04)ISUMZ=ISUMZ+1
200     CONTINUE
        IF(ISUMZ.EQ.0) GOTO 500
        WRITE(M,1500)IZ,ISUMZ
1500    FORMAT(I3,'      (',I3,'A)')
                          JJJ=0
        DO 300 JA=1,IASUP
        JM=IASUP-JA+1
        WW=WINLIB(IZ,JM)   *   CRSTMP
        IF(WW.LT.1.E-04) GOTO 300
        JJJ=JJJ+1
        IF(JJJ.GT.8) GOTO 7000
        LA(JJJ)=JM
        CC(JJJ)=WW
        IF(JJJ.NE.8) GOTO 300
            WRITE(M,2000)(LA(J11),J11=1,8)
            WRITE(M,2001)(CC(J11),J11=1,8)
2000        FORMAT(4X,I3,7(7X,I3))
2001        FORMAT(8E10.3)
         DO 299 LL=1,8
         LA(LL)=-10
299      CC(LL)=-10.
            JJJ=0
300      CONTINUE
             IF(JJJ.NE.0)  WRITE(M,2000)(LA(J11),J11=1,JJJ)
             IF(JJJ.NE.0)  WRITE(M,2001)(CC(J11),J11=1,JJJ)
500     CONTINUE
C
      RETURN
7000       WRITE(M,7001)
7001       FORMAT(1X,' ERROR IN SUBR LIBOUT ')
           STOP
      END
************************************************************************
*               SUBROUTINE LYMASS                                      *
************************************************************************
      SUBROUTINE LYMASS(ZEE,AMASS,NZ,NA,MC,MP,AP,AT,ZP,ZT,QVAL)
* taken from Blann code ALICE
      DIMENSION EM(10),XK(10),Y(2),F(2),XMS(24,11), EMP(10)
      DIMENSION XQ(30)
      COMMON/LYM1/BE(11,24,4),SYMB(11,24),PAIR(11,24),SYMBP(11,24)
      COMMON/SF/M3,KPLT
      DATA BLANK,FOR,RINP/4H    ,4H MSL,4H INP/
      DO 1 I=1,11
      DO 1 K=1,24
      SYMBP(I,K)=BLANK
      SYMB(I,K)=BLANK
      PAIR(I,K)=0.
      DO 1 L=1,4
      BE(I,K,L)=0.
    1 CONTINUE
      DEL=0.
      IF(MP.EQ.0.)DEL=2.
      IF(MP.EQ.3.)DEL=1.
C
C  ABOVE STATEMENTS DEFINE PAIRING TREATMENT
      IBIND=0
      IF(MC.LT.10) GO TO 6
      IBIND = 1
      MC=MC-10
    6 EM(1)=0.0
      EM(2)=2.0
      EM(3)=8.0
      EM(4)=14.0
      EM(5)=28.0
      EM(6)=50.0
      EM(7)=82.0
      EM(8)=126.0
      EM(9)=184.0
      EM(10)=258.0
      CAY1=1.15303
      CAY3=200.0
      CAY4=11.0
      CAY5=8.07144
      CAY6=7.28899
      GAMMA=1.7826
      A1=15.4941
      A2=17.9439
      A3=0.7053
      D=0.444
      C=5.8
      SMALC=0.325
      PVAL=0.
      DO 15 I=1,10
      EMP(I)=EM(I)**(5.0/3.0)
   15 CONTINUE
      DO 20 I=1,9
      XK(I)=0.6*(EMP(I+1)-EMP(I))/(EM(I+1)-EM(I))
   20 CONTINUE
      RZ=.863987/A3
      L=0
      Z=1.0
   25 KZ=ZEE
      KA=AMASS
      IF(QVAL.EQ.0..AND.PVAL.EQ.0.)GO TO 30
      GO TO 35
   30 NNZ=3
      NNA=1
      GO TO 90
   35 NNZ=NZ+2
      NNA=NA+2
cccc      WRITE (6,36)
   36 FORMAT (1H1,53X,'MASS OPTIONS'/)
      IF (MC.EQ.1.AND.MP.NE.0) MC=0
cccc      IF(IBIND.EQ.1)WRITE(6,86)
   86 FORMAT(20X,' EXPERIMENTAL MASSES ARE USED WHERE TABUL'
     1,'ATED;LIQUID DROP VALUES OTHERWISE.')
cccc      IF(MC.EQ.0) WRITE(6,70)
cccc      IF(MC.EQ.1) WRITE(6,65)
cccc      IF (MC.EQ.2) WRITE (6,70)
   50 Continue                
cccc   IF(MP.EQ.0)WRITE(6,75)
cccc   IF(MP.EQ.1)WRITE(6,80)
cccc   IF(MP.EQ.3)WRITE(6,81)
   81 FORMAT(' NORMAL PAIRING SHIFT WITH ODD-EVEN REFERENCE POINT')
   65 FORMAT(40X,'LIQUID DROP WITHOUT SHELL CORRECTION TERM')
   70 FORMAT(41X,'LIQUID DROP WITH SHELL CORRECTION TERM')
   75 FORMAT(21X,'WITHOUT PAIRING, I.E. LEVEL DENSITY PAIRING ',
     1 'SHIFT ABSORBED IN BINDING ENERGIES')
   80 FORMAT(10X,'WITH PAIRING, LEVEL DENSITY PAIRING SHIFT',
     1 ' CALC. FROM MSL FORMULA AND APPLIED IN BACKSHIFTED',
     2 ' CONVENTION')
cccc      IF (MP.EQ.2) WRITE(6,85)
   85 FORMAT (20X,'MSL SHELL CORRECTION TERM INCLUDED IN LEVEL ',
     1 'DENSITY GROUND STATE SHIFT')
   90 DO 215 JZ=1,NNZ
      DO 215 JA=1,NNA
      IF(QVAL.EQ.0..AND.PVAL.EQ.0.)GO TO 95
      GO TO 115
   95 IF(JZ-2)100,105,110
  100 Z=ZEE
      A=AMASS
      IA=A
      IZ=Z
      N=IA-IZ
      UN=AMASS-ZEE
      GO TO 125
  105 Z=ZT
      A=AT
      IA=A
      IZ=Z
      N=IA-IZ
      UN=AT-ZT
      GO TO 125
  110 Z=ZP
      A=AP
      IZ=Z
      IA=A
      N=IA-IZ
      UN=AP-ZP
      GO TO 125
  115 IA=KA+2-JA-JZ
      IZ=KZ+1-JZ
      N=IA-IZ
  120 Z=IZ
      UN=N
      A=IA
  125 A3RT=A**(1.0/3.0)
      A2RT=SQRT(A)
      A3RT2=A3RT**2.0
      ZSQ=Z**2.0
      SYM=((UN-Z)/A)**2
      ACOR=1.0-GAMMA*SYM
      PARMAS=CAY5*UN+CAY6*Z
      VOLNUC=-1.0*A1*ACOR*A
      SUFNUC=A2*ACOR*A3RT2
      COULMB=A3*ZSQ/A3RT
      FUZSUR=-1.0*CAY1*ZSQ/A
      ODDEV=-1.0*(1.0+2.0*(N/2)-UN+2.*(IZ/2)-Z)/SQRT(A)*CAY4
      PAIR(JZ,JA)=-ODDEV
      SYMBP(JZ,JA)=FOR
      IF(MP.EQ.0)ODDEV=0.
      IF(MP.EQ.0)GO TO 11
   10 PAIR(JZ,JA)=(2.0*(N/2)-UN+2.0*(IZ/2)-Z+DEL)/SQRT(A)*CAY4
      SYMBP(JZ,JA) = FOR
   11 CONTINUE
      IF(SYM.GT.0.4)WTERM=0.
  130 WTERM=0.
      WOTNUC=PARMAS+COULMB+FUZSUR+ODDEV+WTERM
      SMASS=WOTNUC+VOLNUC+SUFNUC
      XMS(JA,JZ)=SMASS
      XQ(JZ)=SMASS
  135 CONTINUE
      C2=(SUFNUC+WTERM)/(A**(2.0/3.0))
      X=COULMB/(2.0*(SUFNUC+WTERM))
  140 BARR=0.0
  145 Y(1)=UN
      Y(2)=Z
      DO 165 J=1,2
      DO 150 I=1,9
      IF (Y(J)-EM(I+1)) 160,160,150
  150 CONTINUE
  155 STOP
  160 F(J)=XK(I)*(Y(J)-EM(I))-.6*(Y(J)**(5./3.)-EMP(I))
  165 CONTINUE
      S=(2.0/A)**(2.0/3.0)*(F(1)+F(2))-SMALC*A**(1./3.)
      EE=2.*C2*D**2*(1.0-X)
      FF=.42591771*C2*D**3*(1.+2.*X)/A3RT
      SSHELL=C*S
      V=SSHELL/EE
      EPS=1.5*FF/EE
      IF(EE*(1.-3.*V).LE.0.0) GO TO 170
      QCALC=0.0
      THETA=0.0
      SHLL=SSHELL
      GO TO 210
  170 TO=1.0
  175 DO 180 IPQ=1,10
      T=TO-(1.-EPS*TO-V*(3.-2.*TO**2)*EXP(-TO**2))/(-EPS+V*(10.*TO-4.
     1 *TO**3)*EXP(-TO**2))
      IF (T.LE.0.0) GO TO 190
      IF (ABS(T-TO) .LT.0.0001) GO TO 185
      TO=T
  180 CONTINUE
      GO TO 200
  185 IF (2.*EE*(1.-2.*EPS*T-V*(3.-12.*T**2+4.*T**4)*EXP(-T**2))
     1 .GT.0.0) GO TO 205
  190 DO 195 I=1,20
      TO=FLOAT(I)/10.
      GL=EE*(1.-EPS*TO-V*(3.-2.*TO**2)*EXP(-TO**2))
      IF (GL.GE.0.0) GO TO 175
  195 CONTINUE
  200 CONTINUE
      GO TO 215
  205 THETA=T
      ALPHA0=D*SQRT(5.)/A**(1./3.)
      ALPHA=ALPHA0*THETA
      SIGMA=ALPHA*(1.+ALPHA/14.)
      QCALC=.004*Z*(RZ*A3RT)**2*(EXP(2.*SIGMA)-EXP(-SIGMA))
      SHLL=EE*T**2-FF*T**3+SSHELL*(1.-2.*T**2)*EXP(-T**2)
  210 IF(MC.NE.1.OR.MP.NE.0) GO TO 211
      PAIR(JZ,JA)=PAIR(JZ,JA)-SHLL
      SHLL = 0.
  211 CMASS=SMASS+SHLL
      XMS(JA,JZ)=CMASS
      IF(MP.EQ.2) PAIR(JZ,JA)=PAIR(JZ,JA)-SHLL
      XQ(JZ)=CMASS
  215 CONTINUE
      IF(QVAL.EQ.0..AND.PVAL.EQ.0.)GO TO 220
      GO TO 240
  220 IF(ZP-20.)225,225,230
  225 IF(AP.EQ.01..AND.ZP.EQ.01.)XQ(3)=7.29
      IF(AP.EQ.01..AND.ZP.EQ.00.)XQ(3)=8.07
      IF(AP.EQ.02..AND.ZP.EQ.01.)XQ(3)=13.14
      IF(AP.EQ.03..AND.ZP.EQ.01.)XQ(3)=14.95
      IF(AP.EQ.03..AND.ZP.EQ.02.)XQ(3)=14.93
      IF(AP.EQ.04..AND.ZP.EQ.02.)XQ(3)=2.43
      IF(AP.EQ.06..AND.ZP.EQ.03.)XQ(3)=14.09
      IF(AP.EQ.07..AND.ZP.EQ.03.)XQ(3)=14.91
      IF(AP.EQ.09..AND.ZP.EQ.04.)XQ(3)=11.35
      IF(AP.EQ.10..AND.ZP.EQ.05.)XQ(3)=12.05
      IF(AP.EQ.11..AND.ZP.EQ.05.)XQ(3)=8.67
      IF(AP.EQ.12..AND.ZP.EQ.06.)XQ(3)=0.
      IF(AP.EQ.13..AND.ZP.EQ.06.)XQ(3)=3.13
      IF(AP.EQ.14..AND.ZP.EQ.07.)XQ(3)=2.86
      IF(AP.EQ.15..AND.ZP.EQ.07.)XQ(3)=0.10
      IF(AP.EQ.16..AND.ZP.EQ.08.)XQ(3)=-4.74
      IF(AP.EQ.17..AND.ZP.EQ.08.)XQ(3)=-.81
      IF(AP.EQ.18..AND.ZP.EQ.08.)XQ(3)=-.78
      IF(AP.EQ.19..AND.ZP.EQ.09.)XQ(3)=-1.49
      IF(AP.EQ.20..AND.ZP.EQ.10.)XQ(3)=-7.04
      IF(AP.EQ.21..AND.ZP.EQ.10.)XQ(3)=-5.73
      IF(AP.EQ.22..AND.ZP.EQ.10.)XQ(3)=-8.03
      IF(AP.EQ.23..AND.ZP.EQ.11.)XQ(3)=-9.53
      IF(AP.EQ.24..AND.ZP.EQ.12.)XQ(3)=-13.93
      IF(AP.EQ.25..AND.ZP.EQ.12.)XQ(3)=-13.19
      IF(AP.EQ.26..AND.ZP.EQ.12.)XQ(3)=-16.21
      IF(AP.EQ.27..AND.ZP.EQ.13.)XQ(3)=-17.2
      IF(AP.EQ.28..AND.ZP.EQ.14.)XQ(3)=-21.49
      IF(AP.EQ.29..AND.ZP.EQ.14.)XQ(3)=-21.89
      IF(AP.EQ.30..AND.ZP.EQ.14.)XQ(3)=-24.44
      IF(AP.EQ.31..AND.ZP.EQ.15.)XQ(3)=-24.44
      IF(AP.EQ.32..AND.ZP.EQ.16.)XQ(3)=-26.01
      IF(AP.EQ.33..AND.ZP.EQ.16.)XQ(3)=-26.58
      IF(AP.EQ.34..AND.ZP.EQ.16.)XQ(3)=-29.93
      IF(AP.EQ.36..AND.ZP.EQ.16.)XQ(3)=-30.66
      IF(AP.EQ.35..AND.ZP.EQ.17.)XQ(3)=-29.01
      IF(AP.EQ.37..AND.ZP.EQ.17.)XQ(3)=-31.77
      IF(AP.EQ.36..AND.ZP.EQ.18.)XQ(3)=-30.23
      IF(AP.EQ.38..AND.ZP.EQ.18.)XQ(3)=-34.72
      IF(AP.EQ.40..AND.ZP.EQ.18.)XQ(3)=-35.04
      IF(AP.EQ.39..AND.ZP.EQ.19.)XQ(3)=-33.80
      IF(AP.EQ.40..AND.ZP.EQ.19.)XQ(3)=-33.53
      IF(AP.EQ.41..AND.ZP.EQ.19.)XQ(3)=-35.55
      IF(AP.EQ.40..AND.ZP.EQ.20.)XQ(3)=-34.85
      IF(AP.EQ.42..AND.ZP.EQ.20.)XQ(3)=-38.54
      IF(AP.EQ.43..AND.ZP.EQ.20.)XQ(3)=-38.40
      IF(AP.EQ.44..AND.ZP.EQ.20.)XQ(3)=-41.46
      IF(AP.EQ.46..AND.ZP.EQ.20.)XQ(3)=-43.14
      IF(AP.EQ.48..AND.ZP.EQ.20.)XQ(3)=-44.22
  230 PVAL=XQ(2)+XQ(3)-XQ(1)
cccc    WRITE(6,235)PVAL
  235 FORMAT(/41X,' QVAL FROM MYERS SWIATECKI MASS FORMULA = ',F8.3)
      GO TO 25
  240 DO 245 JZ=1,NZ
      DO 245 JA=1,NA
      SYMB(JZ,JA) = FOR
      BE(JZ,JA,1)=8.07+XMS(JA+1,JZ)-XMS(JA,JZ)
      BE(JZ,JA,2)=7.29+XMS(JA,JZ+1)-XMS(JA,JZ)
      BE(JZ,JA,4)=13.3+XMS(JA+1,JZ+1)-XMS(JA,JZ)
  245 BE(JZ,JA,3)=2.42+XMS(JA+2,JZ+2)-XMS(JA,JZ)
      IF(IBIND.EQ.1) CALL BINDEN(ZEE,AMASS,NZ,NA,AP,AT,ZP,ZT,
     1   QVAL,M3,MP)
cccc      IF(QVAL.EQ.0.)WRITE(6,235)PVAL
      IF(QVAL.EQ.0.)QVAL=PVAL
      IF(MC.NE.2) GO TO 260
  250 DO 255 IZ=1,NNZ
      DO 255 IA=1,NNA
      READ(5,270)BE1,BE2,BE3,BE4,PDEL
      IF(BE1.EQ.0.) GO TO 400
      BE(IZ,IA,1)=BE1
      BE(IZ,IA,2)=BE2
      BE(IZ,IA,3)=BE3
      BE(IZ,IA,4)=BE4
      SYMB(IZ,IA)=RINP
  400 IF(PDEL.EQ.0.) GO TO 255
      PAIR(IZ,IA)=PDEL
      SYMBP(IZ,IA)=RINP
  255 CONTINUE
cccc      WRITE (6,275)
  260 Continue
cccc  WRITE(6,280)
      DO 265 IZ=1,NNZ
      MZ=ZEE+1-IZ
      DO 265 IA=1,NNA
      MA=AMASS+2-IA-IZ
cccc   WRITE(6,285)MZ,MA,(BE(IZ,IA,K),K=1,4),SYMB(IZ,IA),
cccc     1 PAIR(IZ,IA),SYMBP(IZ,IA)
      IF(MP.LE.0)PAIR(IZ,IA)=0.
      PAIR(IZ,IA)=10.*PAIR(IZ,IA)
  265 CONTINUE
cccc  WRITE (6,268)
  268 FORMAT (1H1)
      RETURN
  270 FORMAT(5F10.5)
  275 FORMAT (20X,'SOME BINDING ENERGIES OR LEVEL DENSITY GROUND ',
     * 'STATE SHIFTS PROVIDED BY USER')
  280 FORMAT (/30X,'BINDING ENERGIES AND LEVEL DENSITY GROUND ',
     * 'STATE SHIFTS USED'//22X,' IZ = Z-INDEX OF NUCLEUS,',
     * ' IA = A-INDEX OF NUCLEUS IN PROGRAM ISOTOPE TABLE'/32X,
     * 'MSL = CALCULATED BY MYERS SWIATECKI LYSEKILL MASS FORMULA'/
     * 32X,'TAB = TAKEN FROM 1971 MASS TABLE'/32X,'INP = PROVIDED',
     * ' BY USER'/32X,'ABE = ABSORBED IN BINDING ENERGY'//
     * 10X,'  IZ  IA     NEUTRON      PROTON      ALPHA     ',
     * 'DEUTERON    SOURCE    GS SHIFT  SOURCE'/)
  285 FORMAT(10X,2I4,2X,4(F10.5,2X),3X,A4,3X,F10.5,3X,A4)
      END
************************************************************************
*                 SUBROUTINE MASDAT                                    *
************************************************************************
* Only nucleon and alpha projectile is assumed 
      SUBROUTINE MASDAT                                                 
      COMMON/MASTR1/W(21,21)                                            
      COMMON/AN/AN                                                   
      COMMON/MPARIN/MPARIN
            AM=AN
            If(MPARIN.eq.3) AM=AN+3.
      DO 2 I=1,21                                                       
      DO 1 J=I,21                                                       
      W(I,J)=(AM-FLOAT(I-1)-FLOAT(J-2))*931.5016                        
      W(J,I)=W(I,J)                                                     
    1 CONTINUE                                                          
    2 CONTINUE                                                          
      RETURN                                                            
      END                                                               
************************************************************************
*               SUBROUTINE MASS                                        *
************************************************************************
      SUBROUTINE MASS(MZ,N,EXCES,ERRR,IRET)
* taken from Blann code ALICE
C     FINDS MASS EXCESS (EXCES, IN MEV) AND ERROR (ERRR) FROM 1971
C     WAPSTRA GOVE MASS TABLE UP TO 199PT, FROM 1977(?) TABLE UP TO 256E
C     ERRR=500. MEANS MASS IS FROM SYSTEMATICS
C     ERRR=+0.  MEANS STABLE NUCLIDE
C     PIONS IN MASS TABLE HAVE HAD Z ELECTRONS ADDED TO BE CONSISTENT
C     WITH REST OF THE ATOMIC MASS TABLE
      DATA NT/ 1755/
      NZNO=MZ*1000+N
      NL=((MZ/10)*2-4)*100
      IF(NL.LE.0) NL=1
      DO 11 J=NL,NT
      IF(IZATAB(J).EQ.NZNO) GO TO 12
   11 CONTINUE
      IRET=IRET+1
      RETURN
   12 EXCES=ZAMASS(J)
      ERRR=ERRMAS(J)
      RETURN
      END
      FUNCTION IZATAB(J)
C     TABLE OF ZA (1000*Z + A)
      DIMENSION ITABLE(1800),
     1 I1(54),I1A(46),I2(54),I2A(46),I3(54),I3A(46),I4(54),I4A(46),
     2 I5(54),I5A(46),I6(54),I6A(46),I7(54),I7A(46),I8(54),I8A(46),
     3 I9(54),I9A(46),I10(54),I10A(46),I11(54),I11A(46),
     4 I12(54),I12A(46),I13(54),I13A(46),I14(54),I14A(46),
     5 I15(54),I15A(46),I16(54),I16A(46),I17(54),I17A(46),
     6 I18(54),I18A(46)
      EQUIVALENCE (I1(1),ITABLE(1)),(I2(1),ITABLE(101)),
     1(I3 (1),ITABLE(201 )),(I4 (1),ITABLE( 301)),(I5 (1),ITABLE( 401)),
     2(I6 (1),ITABLE( 501)),(I7 (1),ITABLE( 601)),(I8 (1),ITABLE( 701)),
     3(I9 (1),ITABLE( 801)),(I10(1),ITABLE( 901)),(I11(1),ITABLE(1001)),
     4(I12(1),ITABLE(1101)),(I13(1),ITABLE(1201)),(I14(1),ITABLE(1301)),
     5(I15(1),ITABLE(1401)),(I16(1),ITABLE(1501)),(I17(1),ITABLE(1601)),
     6(I18(1),ITABLE(1701))
      EQUIVALENCE (I1A(1),ITABLE(55)),(I2A(1),ITABLE(155)),
     1 (I3A (1),ITABLE(255 )),(I4A (1),ITABLE( 355)),
     2 (I5A (1),ITABLE(455 )),(I6A (1),ITABLE( 555)),
     3 (I7A (1),ITABLE(655 )),(I8A (1),ITABLE( 755)),
     4 (I9A (1),ITABLE(855 )),(I10A(1),ITABLE( 955)),
     5 (I11A(1),ITABLE(1055)),(I12A(1),ITABLE(1155)),
     6 (I13A(1),ITABLE(1255)),(I14A(1),ITABLE(1355)),
     7 (I15A(1),ITABLE(1455)),(I16A(1),ITABLE(1555)),
     8 (I17A(1),ITABLE(1655)),(I18A(1),ITABLE(1755))
      DATA I1/
     1  -999,     0,   999,     1,     4,  1000,  1001,  1002,  1004,
     2  2001,  2002,  2003,  2004,  2006,  3002,  3003,  3004,  3005,
     3  3006,  3007,  3008,  4001,  4002,  4003,  4004,  4005,  4006,
     4  4007,  4008,  5002,  5003,  5004,  5005,  5006,  5007,  5008,
     5  5009,  5010,  6002,  6003,  6004,  6005,  6006,  6007,  6008,
     6  6009,  6010,  6011,  7003,  7004,  7005,  7006,  7007,  7008/
      DATA I1A/
     1  7009,  7010,  7011,  7012,  8003,  8004,  8005,  8006,  8007,
     2  8008,  8009,  8010,  8011,  8012,  9005,  9006,  9007,  9008,
     3  9009,  9010,  9011,  9012,  9013,  9014, 10005, 10006, 10007,
     4 10008, 10009, 10010, 10011, 10012, 10013, 10014, 11007, 11008,
     5 11009, 11010, 11011, 11012, 11013, 11014, 11015, 11016, 12007,
     6 12008/
      DATA I2/
     1 12009, 12010, 12011, 12012, 12013, 12014, 12015, 12016, 13009,
     2 13010, 13011, 13012, 13013, 13014, 13015, 13016, 13017, 13018,
     3 14009, 14010, 14011, 14012, 14013, 14014, 14015, 14016, 14017,
     4 14018, 15011, 15012, 15013, 15014, 15015, 15016, 15017, 15018,
     5 15019, 15020, 16011, 16012, 16013, 16014, 16015, 16016, 16017,
     6 16018, 16019, 16020, 16021, 16022, 17013, 17014, 17015, 17016/
      DATA I2A/
     1 17017, 17018, 17019, 17020, 17021, 17022, 17023, 18013, 18014,
     2 18015, 18016, 18017, 18018, 18019, 18020, 18021, 18022, 18023,
     3 18024, 18025, 18026, 18027, 18028, 19015, 19016, 19017, 19018,
     4 19019, 19020, 19021, 19022, 19023, 19024, 19025, 19026, 19027,
     5 19028, 20015, 20016, 20017, 20018, 20019, 20020, 20021, 20022,
     6 20023/
      DATA I3/
     1 20024, 20025, 20026, 20027, 20028, 20029, 20030, 21019, 21020,
     2 21021, 21022, 21023, 21024, 21025, 21026, 21027, 21028, 21029,
     3 22019, 22020, 22021, 22022, 22023, 22024, 22025, 22026, 22027,
     4 22028, 22029, 22030, 23021, 23022, 23023, 23024, 23025, 23026,
     5 23027, 23028, 23029, 23030, 23031, 24021, 24022, 24023, 24024,
     6 24025, 24026, 24027, 24028, 24029, 24030, 24031, 24032, 25023/
      DATA I3A/
     1 25024, 25025, 25026, 25027, 25028, 25029, 25030, 25031, 25032,
     2 25033, 26023, 26024, 26025, 26026, 26027, 26028, 26029, 26030,
     3 26031, 26032, 26033, 26034, 26035, 27025, 27026, 27027, 27028,
     4 27029, 27030, 27031, 27032, 27033, 27034, 27035, 27036, 27037,
     5 28025, 28026, 28027, 28028, 28029, 28030, 28031, 28032, 28033,
     6 28034/
      DATA I4/
     1 28035, 28036, 28037, 28038, 28039, 29029, 29030, 29031, 29032,
     2 29033, 29034, 29035, 29036, 29037, 29038, 29039, 29040, 30029,
     3 30030, 30031, 30032, 30033, 30034, 30035, 30036, 30037, 30038,
     4 30039, 30040, 30041, 30042, 31032, 31033, 31034, 31035, 31036,
     5 31037, 31038, 31039, 31040, 31041, 31042, 31043, 31044, 32033,
     6 32034, 32035, 32036, 32037, 32038, 32039, 32040, 32041, 32042/
      DATA I4A/
     1 32043, 32044, 32045, 32046, 32047, 33936, 33937, 33938, 33939,
     2 33940, 33941, 33942, 33943, 33944, 33945, 33946, 33947, 33948,
     3 34037, 34038, 34039, 34040, 34041, 34042, 34043, 34044, 34045,
     4 34046, 34047, 34048, 34049, 34050, 35038, 35039, 35040, 35041,
     5 35042, 35043, 35044, 35045, 35046, 35047, 35048, 35049, 35050,
     6 35051/
      DATA I5/
     1 35052, 36038, 36039, 36040, 36041, 36042, 36043, 36044, 36045,
     2 36046, 36047, 36048, 36049, 36050, 36051, 36052, 36053, 36054,
     3 36055, 37042, 37043, 37044, 37045, 37046, 37047, 37048, 37049,
     4 37050, 37051, 37052, 37053, 37054, 37055, 37056, 38043, 38044,
     5 38045, 38046, 38047, 38048, 38049, 38050, 38051, 38052, 38053,
     6 38054, 38055, 38056, 38057, 39044, 39045, 39046, 39047, 39048/
      DATA I5A/
     1 39049, 39050, 39051, 39052, 39053, 39054, 39055, 39056, 39057,
     2 39058, 40045, 40046, 40047, 40048, 40049, 40050, 40051, 40052,
     3 40053, 40054, 40055, 40056, 40057, 40058, 40059, 40060, 40061,
     4 41046, 41047, 41048, 41049, 41050, 41051, 41052, 41053, 41054,
     5 41055, 41056, 41057, 41058, 41059, 41060, 41061, 41061, 42046,
     6 42047/
      DATA I6/
     1 42048, 42049, 42050, 42051, 42052, 42053, 42054, 42055, 42056,
     2 42057, 42058, 42059, 42060, 42061, 42062, 43048, 43049, 43050,
     3 43051, 43052, 43053, 43054, 43055, 43056, 43057, 43058, 43059,
     4 43060, 43061, 43062, 43063, 44049, 44050, 44051, 44052, 44053,
     5 44054, 44055, 44056, 44057, 44058, 44059, 44060, 44061, 44062,
     6 44063, 44064, 45050, 45051, 45052, 45053, 45054, 45055, 45056/
      DATA I6A/
     1 45057, 45058, 45059, 45060, 45061, 45062, 45063, 45064, 45065,
     2 46051, 46052, 46053, 46054, 46055, 46056, 46057, 46058, 46059,
     3 46060, 46061, 46062, 46063, 46064, 46065, 46066, 47052, 47053,
     4 47054, 47055, 47056, 47057, 47058, 47059, 47060, 47061, 47062,
     5 47063, 47064, 47065, 47066, 47067, 47068, 47069, 48053, 48054,
     6 48055/
      DATA I7/
     1 48056, 48057, 48058, 48059, 48060, 48061, 48062, 48063, 48064,
     2 48065, 48066, 48067, 48068, 48069, 48070, 48071, 49053, 49054,
     3 49055, 49056, 49057, 49058, 49059, 49060, 49061, 49062, 49063,
     4 49064, 49065, 49066, 49067, 49068, 49069, 49070, 49071, 49072,
     5 49073, 49074, 49075, 50053, 50054, 50055, 50056, 50057, 50058,
     6 50059, 50060, 50061, 50062, 50063, 50064, 50065, 50066, 50067/
      DATA I7A/
     1 50068, 50069, 50070, 50071, 50072, 50073, 50074, 50075, 50076,
     2 50077, 50078, 51054, 51055, 51056, 51057, 51058, 51059, 51060,
     3 51061, 51062, 51063, 51064, 51065, 51066, 51067, 51068, 51069,
     4 51070, 51071, 51072, 51073, 51074, 51075, 51076, 51077, 51078,
     5 51079, 51080, 51081, 51082, 52055, 52056, 52057, 52058, 52059,
     6 52060/
      DATA I8/
     1 52061, 52062, 52063, 52064, 52065, 52066, 52067, 52068, 52069,
     2 52070, 52071, 52072, 52073, 52074, 52075, 52076, 52077, 52078,
     3 52079, 52080, 52081, 52082, 52083, 53060, 53061, 53062, 53063,
     4 53064, 53065, 53066, 53067, 53068, 53069, 53070, 53071, 53072,
     5 53073, 53074, 53075, 53076, 53077, 53078, 53079, 53080, 53081,
     6 53082, 53083, 53084, 54062, 54062, 54063, 54064, 54065, 54066/
      DATA I8A/
     1 54067, 54068, 54069, 54070, 54071, 54072, 54073, 54074, 54075,
     2 54076, 54077, 54078, 54079, 54080, 54081, 54082, 54083, 54084,
     3 54085, 54086, 55068, 55069, 55070, 55071, 55072, 55073, 55074,
     4 55075, 55076, 55077, 55078, 55079, 55080, 55081, 55082, 55083,
     5 55084, 55085, 55086, 55087, 56069, 56070, 56071, 56072, 56073,
     6 56074/
      DATA I9/
     1 56075, 56076, 56077, 56078, 56079, 56080, 56081, 56082, 56083,
     2 56084, 56085, 56086, 56087, 56088, 57070, 57071, 57072, 57073,
     3 57074, 57075, 57076, 57077, 57078, 57079, 57080, 57081, 57082,
     4 57083, 57084, 57085, 57086, 57087, 57088, 57089, 58073, 58074,
     5 58075, 58076, 58077, 58078, 58079, 58080, 58081, 58082, 58083,
     6 58084, 58085, 58086, 58087, 58088, 58089, 58090, 59075, 59076/
      DATA I9A/
     1 59077, 59078, 59079, 59080, 59081, 59082, 59083, 59084, 59085,
     2 59086, 59087, 59088, 59089, 59090, 59091, 60076, 60077, 60078,
     3 60079, 60080, 60081, 60082, 60083, 60084, 60085, 60086, 60087,
     4 60088, 60089, 60090, 60091, 60092, 61078, 61079, 61080, 61081,
     5 61082, 61083, 61084, 61085, 61086, 61087, 61088, 61089, 61090,
     6 61091/
      DATA I10/
     1 61092, 61093, 62079, 62080, 62081, 62082, 62083, 62084, 62085,
     2 62086, 62087, 62088, 62089, 62090, 62091, 62092, 62093, 62094,
     3 63080, 63081, 63082, 63083, 63084, 63085, 63086, 63087, 63088,
     4 63089, 63090, 63091, 63092, 63093, 63094, 63095, 63096, 63097,
     5 64080, 64081, 64082, 64083, 64084, 64085, 64086, 64087, 64088,
     6 64089, 64090, 64091, 64092, 64093, 64094, 64095, 64096, 64097/
      DATA I10A/
     1 64098, 65081, 65082, 65083, 65084, 65085, 65086, 65087, 65088,
     2 65089, 65090, 65091, 65092, 65093, 65094, 65095, 65096, 65097,
     3 65098, 65099, 66082, 66083, 66084, 66085, 66086, 66087, 66088,
     4 66089, 66090, 66091, 66092, 66093, 66094, 66095, 66096, 66097,
     5 66098, 66099, 66100, 67082, 67083, 67084, 67085, 67086, 67087,
     6 67088/
      DATA I11/
     1 67089, 67090, 67091, 67092, 67093, 67094, 67095, 67096, 67097,
     2 67098, 67099, 67100, 67101, 67102, 67103, 68082, 68083, 68084,
     3 68085, 68086, 68087, 68088, 68089, 68090, 68091, 68092, 68093,
     4 68094, 68095, 68096, 68097, 68098, 68099, 68100, 68101, 68102,
     5 68103, 68104, 68105, 69082, 69083, 69084, 69085, 69086, 69087,
     6 69088, 69089, 69090, 69091, 69092, 69093, 69094, 69095, 69096/
      DATA I11A/
     1 69097, 69098, 69099, 69100, 69101, 69102, 69103, 69104, 69105,
     2 69106, 69107, 70083, 70084, 70085, 70086, 70087, 70088, 70089,
     3 70090, 70091, 70092, 70093, 70094, 70095, 70096, 70097, 70098,
     4 70099, 70100, 70101, 70102, 70103, 70104, 70105, 70106, 70107,
     5 70108, 71084, 71085, 71086, 71087, 71088, 71089, 71090, 71091,
     6 71092/
      DATA I12/
     1 71093, 71094, 71095, 71096, 71097, 71098, 71099, 71100, 71101,
     2 71102, 71103, 71104, 71105, 71106, 71107, 71108, 71109, 72085,
     3 72086, 72087, 72088, 72089, 72090, 72091, 72092, 72093, 72094,
     4 72095, 72096, 72097, 72098, 72099, 72100, 72101, 72102, 72103,
     5 72104, 72105, 72106, 72107, 72108, 72109, 72110, 72111, 73090,
     6 73091, 73092, 73093, 73094, 73095, 73096, 73097, 73098, 73099/
      DATA I12A/
     1 73100, 73101, 73102, 73103, 73104, 73105, 73106, 73107, 73108,
     2 73109, 73110, 73111, 73112, 73113, 74091, 74092, 74093, 74094,
     3 74095, 74096, 74097, 74098, 74099, 74100, 74101, 74102, 74103,
     4 74104, 74105, 74106, 74107, 74108, 74109, 74110, 74111, 74112,
     5 74113, 74114, 74115, 75092, 75093, 75094, 75095, 75096, 75097,
     6 75098/
      DATA I13/
     1 75099, 75100, 75101, 75102, 75103, 75104, 75105, 75106, 75107,
     2 75108, 75109, 75110, 75111, 75112, 75113, 75114, 75115, 75116,
     3 76093, 76094, 76095, 76096, 76097, 76098, 76099, 76100, 76101,
     4 76102, 76103, 76104, 76105, 76106, 76107, 76108, 76109, 76110,
     5 76111, 76112, 76113, 76114, 76115, 76116, 76117, 76118, 76119,
     6 77094, 77095, 77096, 77097, 77098, 77099, 77100, 77101, 77102/
      DATA I13A/
     1 77103, 77104, 77105, 77106, 77107, 77108, 77109, 77110, 77111,
     2 77112, 77113, 77114, 77115, 77116, 77117, 77118, 77119, 77120,
     3 77121, 78095, 78096, 78097, 78098, 78099, 78100, 78101, 78102,
     4 78103, 78104, 78105, 78106, 78107, 78108, 78109, 78110, 78111,
     5 78112, 78113, 78114, 78115, 78116, 78117, 78118, 78119, 78120,
     6 78121/
      DATA I14/
     1 78122, 78123, 79098, 79099, 79100, 79101, 79102, 79103, 79104,
     2 79105, 79106, 79107, 79108, 79109, 79110, 79111, 79112, 79113,
     3 79114, 79115, 79116, 79117, 79118, 79119, 79120, 79121, 79122,
     4 79123, 79124, 79125, 80097, 80098, 80099, 80100, 80101, 80102,
     5 80103, 80104, 80105, 80106, 80107, 80108, 80109, 80110, 80111,
     6 80112, 80113, 80114, 80115, 80116, 80117, 80118, 80119, 80120/
      DATA I14A/
     1 80121, 80122, 80123, 80124, 80125, 80126, 81102, 81103, 81104,
     2 81105, 81106, 81107, 81108, 81109, 81110, 81111, 81112, 81113,
     3 81114, 81115, 81116, 81117, 81118, 81119, 81120, 81121, 81122,
     4 81123, 81124, 81125, 81126, 81127, 81128, 81129, 82103, 82104,
     5 82105, 82106, 82107, 82108, 82109, 82110, 82111, 82112, 82113,
     6 82114/
      DATA I15/
     1 82115, 82116, 82117, 82118, 82119, 82120, 82121, 82122, 82123,
     2 82124, 82125, 82126, 82127, 82128, 82129, 82130, 82131, 82132,
     3 83106, 83107, 83108, 83109, 83110, 83111, 83112, 83113, 83114,
     4 83115, 83116, 83117, 83118, 83119, 83120, 83121, 83122, 83123,
     5 83124, 83125, 83126, 83127, 83128, 83129, 83130, 83131, 83132,
     6 83133, 84109, 84110, 84111, 84112, 84113, 84114, 84115, 84116/
      DATA I15A/
     1 84117, 84118, 84119, 84120, 84121, 84122, 84123, 84124, 84125,
     2 84126, 84127, 84128, 84129, 84130, 84131, 84132, 84133, 85134,
     3 85111, 85112, 85113, 85114, 85115, 85116, 85117, 85118, 85119,
     4 85120, 85121, 85122, 85123, 85124, 85125, 85126, 85127, 85128,
     5 85129, 85130, 85131, 85132, 85133, 85134, 85135, 86114, 86115,
     6 86116/
      DATA I16/
     1 86117, 86118, 86119, 86120, 86121, 86122, 86123, 86124, 86125,
     2 86126, 86127, 86128, 68129, 86130, 86131, 86132, 86133, 86134,
     3 86135, 86136, 87115, 87116, 87117, 87118, 87119, 87120, 87121,
     4 87122, 87123, 87124, 87125, 87126, 87127, 87128, 87129, 87130,
     5 87131, 87132, 87133, 87134, 87135, 87136, 87137, 87138, 87139,
     6 87140, 88116, 88117, 88118, 88119, 88120, 88121, 88122, 88123/
      DATA I16A/
     1 88124, 88125, 88126, 88127, 88128, 88129, 88130, 88131, 88132,
     2 88133, 88134, 88135, 88136, 88137, 88138, 88139, 88140, 88141,
     3 88142, 89120, 89121, 89122, 89123, 89124, 89125, 89126, 89127,
     4 89128, 89129, 89130, 89131, 89132, 89133, 89134, 89135, 89136,
     5 89137, 89138, 89139, 89140, 89141, 89142, 89143, 90123, 90124,
     6 90125/
      DATA I17/
     1 90126, 90127, 90128, 90129, 90130, 90131, 90132, 90133, 90134,
     2 90135, 90136, 90137, 90138, 90139, 90140, 90141, 90142, 90143,
     3 90144, 90145, 91131, 91132, 91133, 91134, 91135, 91136, 91137,
     4 91138, 91139, 91140, 91141, 91142, 91143, 91144, 91145, 91146,
     5 91147, 92134, 92135, 92136, 92137, 92138, 92139, 92140, 92141,
     6 92142, 92143, 92144, 92145, 92146, 92147, 92148, 93136, 93137/
      DATA I17A/
     1 93138, 93139, 93140, 93141, 93142, 93143, 93144, 93145, 93146,
     2 93147, 93148, 93149, 94138, 94139, 94140, 94141, 94142, 94143,
     3 94144, 94145, 94146, 94147, 94148, 94149, 94150, 94151, 94152,
     4 95139, 95140, 95141, 95142, 95143, 95144, 95145, 95146, 95147,
     5 95148, 95149, 95150, 95151, 95152, 95153, 96140, 96141, 96142,
     6 96143/
      DATA I18/
     1 96144, 96145, 96146, 96147, 96148, 96149, 96150, 96151, 96152,
     2 96153, 96154, 97141, 97142, 97143, 97144, 97145, 97146, 97147,
     3 97148, 97149, 97150, 97151, 97152, 97153, 97154, 97155, 98142,
     4 98143, 98144, 98145, 98146, 98147, 98148, 98149, 98150, 98151,
     5 98152, 98153, 98154, 98155, 98156, 99144, 99145, 99146, 99147,
     6 99148, 99149, 99150, 99151, 99152, 99153, 99154, 99155, 99156/
      DATA I18A/
     1 99157,     0,     0,     0,     0,     0,     0,     0,     0,
     2     0,     0,     0,     0,     0,     0,     0,     0,     0,
     3     0,     0,     0,     0,     0,     0,     0,     0,     0,
     4     0,     0,     0,     0,     0,     0,     0,     0,     0,
     5     0,     0,     0,     0,     0,     0,     0,     0,     0,
     6     0/
      IZATAB=ITABLE(J)
      RETURN
      END
      FUNCTION ZAMASS(J)
C
C     MASS EXCESS IN MEV.
C
      DIMENSION AMASS(1800),
     1 A1 (54),A2 (54),A3 (54),A4 (54),A5 (54),A6 (54),A7 (54),
     2 A8 (54),A9 (54),A10(54),A11(54),A12(54),A13(54),A14(54),
     3 A15(54),A16(54),A17(54),A18(54),
     4 A1A(46),A2A(46),A3A(46),A4A(46),A5A(46),A6A(46),A7A(46),
     5 A8A(46),A9A(46),A10A(46),A11A(46),A12A(46),A13A(46),
     6 A14A(46),A15A(46),A16A(46),A17A(46),A18A(46)
      EQUIVALENCE (A1(1),AMASS (1)),(A2(1),AMASS (101)),
     1(A3 (1),AMASS (201 )),(A4 (1),AMASS ( 301)),(A5 (1),AMASS ( 401)),
     2(A6 (1),AMASS ( 501)),(A7 (1),AMASS ( 601)),(A8 (1),AMASS ( 701)),
     3(A9 (1),AMASS ( 801)),(A10(1),AMASS ( 901)),(A11(1),AMASS (1001)),
     4(A12(1),AMASS (1101)),(A13(1),AMASS (1201)),(A14(1),AMASS (1301)),
     5(A15(1),AMASS (1401)),(A16(1),AMASS (1501)),(A17(1),AMASS (1601)),
     6(A18(1),AMASS (1701))
      EQUIVALENCE (A1A(1),AMASS (55)),(A2A(1),AMASS (155)),
     1 ( A3A(1),AMASS ( 255)),( A4A(1),AMASS ( 355)),
     2 ( A5A(1),AMASS ( 455)),( A6A(1),AMASS ( 555)),
     3 ( A7A(1),AMASS ( 655)),( A8A(1),AMASS ( 755)),
     4 ( A9A(1),AMASS ( 855)),(A10A(1),AMASS ( 955)),
     5 (A11A(1),AMASS (1055)),(A12A(1),AMASS (1155)),
     6 (A13A(1),AMASS (1255)),(A14A(1),AMASS (1355)),
     7 (A15A(1),AMASS (1455)),(A16A(1),AMASS (1555)),
     8 (A17A(1),AMASS (1655)),(A18A(1),AMASS (1755))
      DATA A1/
     1139.06700,134.97500,140.08900,  8.07169, 32.28676,  7.28922,
     2 13.13626, 14.95038, 33.78999, 14.93173,  2.42494, 11.39000,
     3 17.59730, 31.61300, 11.68000, 14.08750, 14.90859, 20.94750,
     4 24.95540, 34.10000, 41.70000, 34.92304, 18.37500, 15.77029,
     5  4.94180, 11.34840, 12.60810, 20.17700, 24.94999, 27.94000,
     6 22.92230, 12.41569, 12.05230,  8.66795, 13.37040, 16.56200,
     7 24.60000, 29.70000, 35.10000, 28.91200, 15.70270, 10.65019,
     8  0.00000,  3.12527,  3.01995,  9.87350, 13.69299, 17.56000,
     9 40.23163, 25.44999, 17.34400,  5.34570,  2.86382,   .10180/
      DATA A1A/
     1  5.68350,  7.87100, 13.27400, 16.35000, 50.59094, 32.97922,
     2 23.10600,  8.00859,  2.86110, -4.73668,  -.80700,  -.78250,
     3  3.33230,  3.80000, 34.32074, 17.66000, 10.69300,  1.95180,
     4   .87280, -1.48610,  -.01570,  -.04600,  2.82800,  3.36000,
     5 42.65895, 24.66971, 16.47999,  5.31900,  1.75210, -7.04170,
     6 -5.73120, -8.02510, -5.15000, -5.94800, 25.57849, 12.97999,
     7  6.84000, -2.18300, -5.18290, -9.52900, -8.41670, -9.35600,
     8 -6.85300, -5.98000, 32.71106, 17.74000/
      DATA A2/
     1 10.91100,  -.39900, -5.47240,-13.93130,-13.19149,-16.21339,
     2-14.58470,-15.01700, 18.05000,  6.77000,  -.04900, -8.91230,
     3-12.20880,-17.19500,-16.84880,-18.21300,-15.89000,-15.56000,
     4 23.93176, 10.76000,  3.82400, -7.14300,-12.38539,-21.49110,
     5-21.89329,-24.43130,-22.94790,-24.09100, 10.57867,   .21000,
     6 -7.15400,-16.94999,-20.20390,-24.43960,-24.30420,-26.33700,
     7-24.83000,-24.93600, 17.55025,  4.45666, -3.16000,-14.06200,
     8-18.99800,-26.01429,-26.58599,-29.92919,-28.84560,-30.66589,
     9-26.90700,-26.86300,  4.88808, -7.20000,-13.26299,-21.00239/
      DATA A2A/
     1-24.43840,-29.01300,-29.52180,-31.76150,-29.80000,-29.80200,
     2-27.54000, 11.18168, -2.15889, -9.40000,-18.37900,-23.04939,
     3-30.23049,-30.94740,-34.71440,-33.24000,-35.03919,-33.06610,
     4-34.42000,-31.98000,-32.76000,-29.72700,-29.73200, -1.69218,
     5-11.25000,-17.31700,-24.79840,-28.79200,-33.80529,-33.53410,
     6-35.55830,-35.02140,-36.58200,-35.80500,-36.61100,-35.42600,
     7-35.70400,  4.74011, -6.44739,-13.14400,-22.02299,-27.28300,
     8-34.84570,-35.13710,-38.53810,-38.39900/
      DATA A3/
     1-41.46359,-40.80630,-43.13800,-42.34300,-44.22200,-41.29200,
     2-39.57800,-20.52099,-28.64100,-32.10700,-36.17900,-37.81400,
     3-41.06309,-41.75840,-44.32890,-44.49500,-46.55200,-44.54500,
     4-15.80000,-25.12100,-29.34100,-37.54800,-39.00070,-44.12579,
     5-44.92919,-48.48559,-48.55729,-51.43359,-49.73900,-49.47000,
     6-23.85400,-31.90000,-37.07140,-42.00480,-44.47020,-47.95610,
     7-49.21670,-52.19740,-51.43690,-51.86100,-49.93000,-19.47600,
     8-31.24000,-34.62500,-42.81600,-45.38800,-50.25500,-51.44600,
     9-55.41500,-55.28380,-56.93230,-55.12100,-55.26600,-31.01700/
      DATA A3A/
     1-37.72000,-42.62460,-48.24000,-50.70500,-54.68650,-55.55700,
     2-57.71000,-56.90870,-57.62000,-56.06000,-26.75500,-35.79100,
     3-40.23200,-48.33390,-50.94200,-56.25170,-57.47840,-60.60940,
     4-60.18380,-62.15510,-60.67000,-61.43500,-59.03000,-37.03100,
     5-44.06400,-48.00200,-54.01240,-56.04120,-59.34700,-59.84720,
     6-62.23570,-61.65560,-62.92000,-61.53000,-61.86300,-60.11000,
     7-29.63200,-40.71200,-45.35000,-53.90800,-56.10400,-60.23500,
     8-61.16260,-64.47920,-64.22700,-66.75190/
      DATA A4/
     1-65.52150,-67.10930,-65.13390,-66.06000,-63.20000,-51.66800,
     2-56.36300,-58.35200,-61.98180,-62.80500,-65.58740,-65.43180,
     3-67.26480,-66.25980,-67.30200,-69.42000,-65.94000,-48.43700,
     4-54.19300,-56.58000,-61.11500,-62.22200,-66.00640,-65.91410,
     5-68.89450,-67.87670,-70.00430,-68.41620,-69.55970,-67.33200,
     6-68.13100,-56.72000,-58.93400,-62.65500,-63.71900,-66.87600,
     7-67.08500,-69.32300,-68.90600,-70.13810,-68.58760,-69.74000,
     8-67.92000,-68.54000,-56.36000,-61.61700,-62.45000,-66.69800,
     9-67.09750,-70.55950,-69.90300,-72.58070,-71.29320,-73.42240/
      DATA A4A/
     1-71.84100,-73.21230,-71.16000,-71.78000,-69.39000,-63.13000,
     2-64.33800,-67.89400,-68.23000,-70.95400,-70.85870,-73.02970,
     3-72.28620,-73.91700,-72.76000,-73.69000,-71.76000,-72.59000,
     4-62.89000,-67.63000,-68.21400,-72.21300,-72.16490,-75.25460,
     5-74.60140,-77.02680,-75.93390,-77.75700,-76.38700,-77.58700,
     6-75.44000,-75.92000,-63.51000,-65.21000,-69.15500,-70.15000,
     7-73.23690,-73.45300,-76.07410,-75.88530,-77.97400,-77.50300,
     8-79.01800,-77.73000,-78.67000,-75.96000/
      DATA A5/
     1-74.20000,-62.11000,-64.05000,-69.15000,-70.23700,-74.14700,
     2-74.44300,-77.89600,-77.68000,-80.59100,-79.98700,-82.43320,
     3-81.47260,-83.26130,-80.70000,-79.70000,-76.56000,-74.89000,
     4-71.50000,-70.92000,-72.10000,-75.42000,-76.19400,-78.94900,
     5-79.75300,-82.15960,-82.73830,-84.59260,-82.60400,-81.71000,
     6-79.30000,-78.00000,-75.02000,-73.05000,-71.62000,-75.59000,
     7-76.69900,-80.63980,-81.09600,-84.50940,-84.86610,-87.90760,
     8-86.19600,-85.92790,-83.68400,-82.92000,-79.95000,-78.74000,
     9-75.54000,-72.20000,-73.69000,-77.83600,-79.23600,-82.98400/
      DATA A5A/
     1-84.28900,-87.68560,-86.47390,-86.34900,-84.83400,-84.25400,
     2-82.26000,-81.23600,-78.63000,-76.83000,-72.94000,-77.94000,
     3-79.48400,-83.61000,-84.85100,-88.76260,-87.89350,-88.45690,
     4-87.14370,-87.26310,-85.66600,-85.42600,-82.93390,-81.27300,
     5-78.36000,-77.09000,-72.90000,-74.28000,-76.41000,-80.98000,
     6-82.65200,-86.63200,-86.45300,-87.20710,-86.36430,-86.78850,
     7-85.60900,-85.60500,-83.51000,-82.86000,-80.19000,-79.40000,
     8-76.20000,-76.20000,-71.81000,-75.01000/
      DATA A6/
     1-80.16500,-82.18800,-86.80840,-86.80900,-88.40990,-87.71339,
     2-88.79590,-87.54020,-88.11090,-85.95600,-86.18510,-83.50400,
     3-83.60000,-80.50000,-80.19000,-76.59000,-78.86000,-83.62300,
     4-84.15000,-86.01200,-85.86000,-87.19500,-86.52000,-87.32800,
     5-85.85000,-86.32500,-84.60000,-84.90000,-82.79000,-82.53000,
     6-79.82000,-77.42000,-82.56900,-83.45000,-86.07300,-86.04000,
     7-88.22300,-87.62020,-89.22190,-87.95570,-89.10020,-87.25300,
     8-88.09400,-85.93000,-86.32300,-83.71000,-83.71000,-78.45000,
     9-79.63000,-82.55000,-83.16600,-85.56800,-85.59200,-87.40200/
      DATA A6A/
     1-86.77800,-88.01600,-86.94400,-87.84700,-86.36200,-86.86000,
     2-85.03000,-85.11000,-82.94000,-77.75000,-81.37000,-82.16300,
     3-85.19000,-85.41200,-87.92700,-87.46300,-89.41100,-88.41300,
     4-89.90200,-88.37300,-89.52600,-87.60600,-88.34000,-86.02000,
     5-86.28000,-76.13000,-77.89000,-81.01000,-82.36700,-84.78000,
     6-85.31100,-87.07800,-86.92800,-88.40800,-87.60500,-88.72150,
     7-87.45550,-88.22400,-86.58000,-87.03500,-85.01000,-84.91000,
     8-82.42000,-75.48000,-79.47000,-80.38000/
      DATA A7/
     1-84.01000,-84.28000,-87.13020,-86.99100,-89.24800,-88.53900,
     2-90.34640,-89.25160,-90.57690,-89.04490,-90.01420,-88.09000,
     3-88.71500,-86.40800,-86.70400,-84.21000,-69.67000,-73.78000,
     4-75.51000,-79.18000,-80.39000,-83.50000,-84.10000,-86.52000,
     5-86.42000,-88.42600,-87.98900,-89.34200,-88.58400,-89.54100,
     6-88.24800,-88.92900,-87.45000,-87.71400,-85.49000,-85.82000,
     7-83.24000,-83.42000,-80.83000,-65.88000,-70.91000,-72.58000,
     8-77.09000,-78.20000,-82.00000,-82.72000,-85.82400,-85.91800,
     9-88.64800,-88.31700,-90.56500,-90.02700,-91.52180,-90.39260/
      DATA A7A/
     1-91.64830,-90.06160,-91.09430,-89.20270,-89.93560,-87.80900,
     2-88.22900,-85.89000,-86.01300,-83.51000,-83.40000,-63.18000,
     3-65.69000,-70.10000,-72.20000,-76.02000,-77.62000,-81.02000,
     4-81.85000,-84.41900,-84.87000,-86.99700,-87.02000,-88.64000,
     5-87.95300,-89.48300,-88.41400,-89.58990,-88.32560,-89.21910,
     6-87.61420,-88.26200,-86.33900,-86.70800,-84.70000,-84.59100,
     7-82.35000,-82.09000,-79.59000,-79.00000,-60.05000,-65.29000,
     8-67.42000,-72.12000,-73.62000,-77.65000/
      DATA A8/
     1-78.52000,-82.17000,-82.46000,-85.46000,-85.15000,-87.65000,
     2-87.18900,-89.40200,-88.59000,-90.30380,-89.16200,-90.51410,
     3-89.02730,-90.06490,-88.28900,-88.98890,-87.00400,-87.34540,
     4-85.19100,-85.19300,-82.90000,-82.57000,-77.78000,-71.32000,
     5-73.47000,-76.96000,-78.16000,-80.84000,-81.55000,-83.99000,
     6-84.10000,-86.22000,-86.16000,-87.96000,-87.35400,-88.87930,
     7-87.91400,-88.98140,-87.73510,-88.50300,-86.88800,-87.44320,
     8-85.69800,-85.86000,-83.97000,-83.77600,-79.42000,-76.81000,
     9-73.66000,-73.66000,-74.77000,-78.25000,-79.00000,-81.90000/
      DATA A8A/
     1-82.43000,-85.06000,-85.29000,-87.45000,-87.14000,-89.16500,
     2-88.31700,-89.86010,-88.69400,-89.88010,-88.41400,-89.27840,
     3-87.66000,-88.12300,-86.50200,-86.42300,-82.21300,-80.07000,
     4-75.98000,-73.24000,-81.09000,-81.55000,-84.07000,-84.16000,
     5-86.22700,-85.95300,-87.59000,-86.85700,-88.05900,-87.17900,
     6-88.08700,-86.90600,-87.65900,-86.35600,-86.56100,-82.87000,
     7-80.78000,-77.54000,-74.87000,-71.07000,-79.57000,-82.36000,
     8-82.73000,-85.25000,-85.15000,-87.29700/
      DATA A9/
     1-86.71900,-88.45100,-87.57200,-88.96500,-87.86800,-88.90400,
     2-87.73400,-88.27400,-84.92600,-83.24100,-79.97000,-77.77000,
     3-74.01000,-71.80000,-77.73000,-78.45000,-81.15000,-81.60000,
     4-83.76000,-83.74000,-85.67000,-85.25500,-86.83000,-86.03000,
     5-87.23000,-86.48000,-87.18600,-84.27600,-82.96900,-79.97000,
     6-78.21040,-74.90000,-72.91000,-69.44000,-79.46000,-82.34000,
     7-82.37000,-84.75000,-84.53000,-86.46200,-86.03000,-87.53600,
     8-86.91100,-88.04200,-85.39900,-84.48700,-81.59300,-80.40300,
     9-77.11000,-75.74000,-72.23000,-70.68000,-78.55000,-80.95000/
      DATA A9A/
     1-81.26000,-83.28000,-83.09900,-84.79900,-84.65400,-85.98000,
     2-83.75200,-83.03800,-80.71900,-79.59900,-76.82000,-75.43000,
     3-72.48000,-71.38000,-68.66000,-78.80000,-79.28000,-81.80000,
     4-82.00000,-84.18000,-84.17500,-85.91600,-83.97000,-83.71600,
     5-81.40400,-80.89800,-78.12900,-77.38100,-74.37700,-73.66200,
     6-70.89900,-70.12600,-77.50000,-78.28000,-80.45000,-81.10000,
     7-82.90100,-81.34000,-81.23400,-79.42100,-79.02300,-76.85200,
     8-76.04600,-73.53000,-73.36500,-71.35000/
      DATA A10/
     1-70.74000,-68.45000,-76.05000,-79.05000,-79.42200,-81.90400,
     2-80.59600,-80.94700,-79.24800,-79.31700,-77.11800,-77.03390,
     3-74.55300,-74.74900,-72.54400,-72.45100,-70.19300,-69.35900,
     4-74.42000,-75.57700,-77.87600,-77.07500,-77.48600,-76.21700,
     5-76.36000,-74.71900,-74.62900,-72.86300,-73.34700,-71.71300,
     6-71.81800,-70.07200,-69.46100,-67.25000,-65.92000,-63.53000,
     7-71.88000,-72.88000,-75.88000,-75.15800,-76.20700,-75.07200,
     8-75.72800,-74.16500,-74.69100,-73.10600,-73.69100,-72.06500,
     9-72.52400,-70.82100,-70.68000,-68.55300,-67.93400,-65.49400/
      DATA A10A/
     1-64.29000,-67.78000,-70.56000,-70.59000,-71.37500,-71.06000,
     2-71.55700,-70.87100,-71.31000,-70.29000,-71.22000,-70.22000,
     3-70.75700,-69.44000,-69.50300,-67.81300,-67.44500,-65.69000,
     4-64.67000,-62.59000,-67.79000,-67.48000,-69.10000,-68.55200,
     5-70.05700,-69.09000,-70.35600,-69.12100,-70.49100,-69.39400,
     6-70.38400,-69.13800,-69.64800,-68.02700,-68.15100,-66.35100,
     7-65.93400,-63.57700,-62.56300,-61.58000,-62.00000,-63.50000,
     8-63.67000,-64.83200,-64.59800,-65.82000/
      DATA A11/
     1-65.39000,-66.89000,-66.40700,-67.44000,-66.72800,-67.21000,
     2-65.98100,-66.34200,-64.95500,-64.87300,-63.04400,-62.29800,
     3-60.20000,-58.75000,-56.39000,-57.90000,-58.20000,-60.43000,
     4-60.25000,-62.40000,-62.01000,-63.69000,-62.99000,-64.91000,
     5-64.34000,-65.93000,-65.16100,-66.29900,-65.13400,-65.91800,
     6-64.50100,-64.90400,-63.26800,-62.96800,-60.89900,-60.09100,
     7-57.70000,-56.48000,-53.42000,-50.90000,-51.93000,-53.90000,
     8-54.49000,-56.31000,-56.69000,-58.19000,-58.31000,-60.14000,
     9-60.13000,-61.64000,-61.60000,-62.71700,-61.95600,-62.93600/
      DATA A11A/
     1-61.86900,-62.52100,-61.27000,-61.25100,-59.77300,-59.19000,
     2-57.36900,-56.21500,-53.87000,-52.28000,-49.34000,-47.30000,
     3-50.01000,-50.42000,-53.07000,-53.21000,-55.31000,-55.14000,
     4-57.33900,-57.14000,-59.30000,-59.02000,-60.86000,-60.18400,
     5-61.60900,-60.56600,-61.54900,-60.34400,-60.74100,-59.28300,
     6-59.23900,-57.53500,-56.93390,-54.68100,-53.48500,-50.97500,
     7-49.47000,-42.69000,-43.93000,-46.31000,-47.11000,-48.94000,
     8-49.53000,-51.64000,-52.20000,-54.22000/
      DATA A12/
     1-54.46000,-56.18000,-56.11000,-57.50000,-57.19000,-58.07400,
     2-57.30100,-57.89000,-56.74000,-56.84500,-55.56200,-55.14900,
     3-53.37000,-52.37100,-50.17000,-49.10000,-46.47000,-39.05000,
     4-42.18000,-42.74000,-45.23000,-45.54000,-48.20000,-48.62000,
     5-51.06000,-51.08000,-53.41000,-53.20000,-55.19000,-54.70000,
     6-56.10000,-55.29000,-56.34000,-55.25000,-55.76000,-54.54200,
     7-54.55900,-52.86800,-52.42200,-50.45000,-49.76600,-47.38900,
     8-45.90000,-43.21900,-41.52000,-42.46000,-44.88000,-45.61000,
     9-47.80000,-48.19000,-50.10000,-50.10000,-51.59000,-51.34000/
      DATA A12A/
     1-52.35000,-51.76000,-52.34000,-51.46000,-51.71000,-50.51000,
     2-50.33100,-48.84000,-48.41200,-46.40300,-45.25900,-42.63700,
     3-41.38000,-38.58000,-37.78000,-40.61000,-41.40000,-43.99000,
     4-44.30000,-46.60000,-46.59000,-48.54000,-48.35000,-49.86000,
     5-49.34000,-50.46000,-49.71000,-50.42000,-49.23000,-49.65000,
     6-48.22500,-48.20800,-46.32700,-45.66700,-43.34500,-42.47500,
     7-39.87000,-38.63400,-35.44000,-33.70000,-34.99000,-37.50000,
     8-38.40000,-40.69000,-41.24000,-43.15000/
      DATA A13/
     1-43.46000,-45.04000,-44.96000,-46.11000,-45.76000,-46.54000,
     2-45.86000,-46.43000,-45.34800,-45.77100,-44.06000,-43.77400,
     3-41.88100,-41.18100,-38.98300,-37.94200,-35.49000,-34.46000,
     4-29.60000,-32.60000,-33.49000,-36.14000,-36.75000,-39.06000,
     5-39.34000,-41.36000,-41.41000,-42.96000,-42.74000,-43.96000,
     6-43.40000,-44.25000,-43.37000,-44.15800,-42.75900,-42.95800,
     7-41.18400,-41.10100,-38.95200,-38.67400,-36.36200,-35.85000,
     8-33.36700,-32.39700,-29.85000,-25.23000,-26.62000,-29.30000,
     9-30.37000,-32.74000,-33.58000,-35.59000,-35.96000,-37.64000/
      DATA A13A/
     1-37.86000,-39.10000,-38.95000,-39.97000,-39.44000,-40.26000,
     2-39.12700,-39.68000,-38.26800,-38.45000,-36.62000,-36.67200,
     3-34.79900,-34.49900,-32.49400,-31.85100,-29.46000,-28.41000,
     4-25.51000,-20.84000,-24.00000,-24.97000,-27.85000,-28.68000,
     5-31.07000,-31.65000,-33.68000,-33.85000,-35.59000,-35.48000,
     6-36.94000,-36.46000,-37.50000,-36.78000,-37.72800,-36.55000,
     7-37.29300,-35.67200,-36.25600,-34.43800,-34.73390,-32.78600,
     8-32.63500,-30.41400,-29.90600,-27.40600/
      DATA A14/
     1-26.60000,-23.74000,-21.19000,-22.41000,-24.75000,-25.63000,
     2-27.64000,-28.18000,-30.01000,-30.22000,-31.73000,-31.69000,
     3-32.87000,-32.49000,-33.41000,-32.87600,-33.87000,-32.76800,
     4-33.36000,-32.25600,-32.57200,-31.16200,-31.15000,-29.59100,
     5-29.10400,-27.30000,-26.40000,-23.86000,-22.98000,-20.20000,
     6-12.65000,-15.93000,-16.80000,-19.86000,-20.79000,-23.21000,
     7-23.69000,-26.04000,-26.14000,-28.35000,-28.06000,-29.88000,
     8-29.21000,-30.96000,-30.48000,-31.97400,-31.02000,-32.20600,
     9-31.05600,-31.84600,-30.73500,-30.96400,-29.55700,-29.51400/
      DATA A14A/
     1-27.67200,-27.36500,-25.27700,-24.70300,-22.29900,-20.95500,
     2-15.83000,-16.90000,-19.11000,-19.86000,-21.93000,-22.29000,
     3-24.02000,-24.16000,-25.67000,-25.59000,-27.02000,-26.81000,
     4-27.85000,-27.35000,-28.33900,-27.50000,-28.08000,-27.06000,
     5-27.18500,-25.98800,-25.76900,-24.35300,-23.83700,-22.26900,
     6-21.04100,-16.76800,-13.65000, -9.25100,-11.74000,-14.33900,
     7-14.94000,-17.51000,-17.86000,-20.22000,-20.23000,-22.29000,
     8-22.07000,-23.81000,-23.55000,-25.15000/
      DATA A15/
     1-24.63000,-25.90000,-25.98000,-26.16000,-25.32700,-25.94200,
     2-24.79400,-25.11700,-23.77700,-23.79500,-22.46300,-21.79500,
     3-17.62400,-14.73800,-10.49190, -7.56200, -3.14000,  -.18500,
     4 -9.87000,-10.85000,-15.05000,-13.67000,-15.56400,-15.98000,
     5-17.68000,-17.76000,-19.41000,-19.30000,-20.61000,-20.46000,
     6-21.41000,-21.04000,-21.60000,-20.82000,-21.07000,-20.03390,
     7-20.05800,-18.87900,-18.26800,-14.80100,-11.86500, -8.13500,
     8 -5.24300, -1.20900,  1.71000,  5.97000, -8.31000,-10.81000,
     9-11.06000,-13.21000,-13.23000,-15.07000,-15.05000,-16.74000/
      DATA A15A/
     1-16.41000,-17.78000,-17.36000,-18.25000,-17.57600,-18.19000,
     2-17.15000,-17.47500,-16.37300,-15.96300,-12.44400,-10.38100,
     3 -6.63390, -4.47900,  -.54000,  1.76900,  5.96000,  8.35460,
     4 -4.05000, -6.03000, -6.67000, -8.47000, -8.67000,-10.52000,
     5-10.52000,-11.97000,-11.97000,-12.96000,-12.73000,-13.31000,
     6-12.64000,-12.88800,-11.97600,-11.63500, -8.62500, -6.58900,
     7 -3.38900, -1.26200,  2.23700,  4.38200,  8.99000, 10.53000,
     8 14.20000, -3.74000, -3.95000, -5.88000/
      DATA A16/
     1 -6.00000, -7.77000, -7.60000, -8.97000, -8.69000, -9.56000,
     2 -8.94000, -9.60800, -8.76100, -8.66600, -5.70600, -4.32800,
     3 -1.17900,   .24500,  3.64900,  5.21200,  8.83070, 10.59900,
     4 14.38000, 16.37000,  3.16000,  1.23000,   .87000, -1.04000,
     5 -1.18000, -2.65000, -2.77000, -3.76000, -3.64000, -4.22000,
     6 -3.69000, -3.55600,  -.96500,   .30900,  2.97500,  4.30700,
     7  7.05000,  8.61700, 11.47000, 13.26500, 16.33800, 18.38230,
     8 21.71000, 23.79000, 27.46000, 29.58000,  6.28000,  5.98000,
     9  3.96000,  3.70000,  1.93000,  1.97000,   .61000,   .78000/
      DATA A16A/
     1  -.11000,   .29000,   .09000,  2.53100,  3.28500,  5.88100,
     2  6.66400,  9.37700, 10.26300, 12.95700, 14.32100, 17.23480,
     3 18.81300, 21.98730, 23.66570, 27.18500, 28.94100, 32.72000,
     4 34.56000,  9.12000,  8.86000,  7.40000,  7.18000,  6.17000,
     5  6.14000,  5.95000,  7.98000,  8.70100, 10.83700, 11.56000,
     6 13.74700, 14.51800, 16.61700, 17.82500, 20.21900, 21.62600,
     7 24.30100, 25.85000, 28.89500, 30.72000, 33.76000, 35.91000,
     8 39.15000, 12.24000, 10.87000, 10.87000/
      DATA A17/
     1 10.39000, 12.14100, 12.36200, 14.47000, 14.66300, 16.93400,
     2 17.19700, 19.25600, 19.99300, 22.30300, 23.18900, 25.80630,
     3 26.75800, 29.58090, 30.86130, 33.81220, 35.44720, 38.73230,
     4 40.61200, 44.15000, 21.95900, 22.33900, 23.79800, 24.32000,
     5 26.02900, 26.83200, 28.87000, 29.88700, 32.16550, 33.42310,
     6 35.93400, 37.48710, 40.34900, 42.32000, 45.54000, 47.64000,
     7 51.27000, 27.18600, 28.88000, 29.22100, 31.20100, 31.60700,
     8 33.78000, 34.59700, 36.91470, 38.14260, 40.91640, 42.44200,
     9 45.38870, 47.30700, 50.57220, 52.71200, 33.75800, 35.23200/
      DATA A17A/
     1 35.62600, 37.29000, 38.01000, 39.95100, 41.03950, 43.42600,
     2 44.86930, 47.45260, 49.30640, 52.21000, 54.31000, 57.52000,
     3 38.36200, 40.04200, 40.34200, 42.16000, 42.88900, 45.08700,
     4 46.16080, 48.58510, 50.12280, 52.95300, 54.71500, 57.75250,
     5 59.80300, 63.15700, 65.29000, 44.46000, 44.65000, 46.02000,
     6 46.64000, 48.41700, 49.38900, 51.44300, 52.93220, 55.46270,
     7 57.17010, 59.87860, 61.89730, 64.92000, 67.13000, 70.49000,
     8 47.89000, 49.17000, 49.39800, 51.09000/
      DATA A18/
     1 51.71200, 53.69600, 54.80150, 57.17740, 58.44960, 61.00130,
     2 62.61600, 65.53000, 67.38900, 70.74800, 72.98600, 54.28000,
     3 54.28000, 55.71000, 56.10000, 57.80000, 58.68500, 60.64600,
     4 61.81100, 64.02000, 65.48400, 67.99000, 69.84800, 72.95000,
     5 72.25000, 78.53000, 58.03000, 59.19000, 59.33200, 60.91000,
     6 61.46500, 63.37700, 64.09620, 66.15000, 67.24300, 69.72160,
     7 71.16980, 74.13000, 70.03100, 79.29900, 81.34200, 64.80000,
     8 65.97000, 66.38000, 67.93000, 68.55000, 70.22000, 71.11600,
     9 73.17000, 74.50300, 77.15000, 79.01240, 81.99200, 84.08000/
      DATA A18A/
     1 87.26000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     2  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     3  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     4  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     5  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     6  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     7  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,
     8  0.00000,  0.00000,  0.00000,  0.00000/
      ZAMASS=AMASS(J)
      RETURN
      END
      FUNCTION ERRMAS(J)
C
C     MASS EXCESS ERROR IN MEV.
C
      DIMENSION ERR(1800),
     1 E1 (54),E2 (54),E3 (54),E4 (54),E5 (54),E6 (54),E7 (54),
     2 E8 (54),E9 (54),E10(54),E11(54),E12(54),E13(54),E14(54),
     3 E15(54),E16(54),E17(54),E18(54),
     4 E1A(46),E2A(46),E3A(46),E4A(46),E5A(46),E6A(46),E7A(46),
     5 E8A(46),E9A(46),E10A(46),E11A(46),E12A(46),E13A(46),E14A(46),
     6 E15A(46),E16A(46),E17A(46),E18A(46)
      EQUIVALENCE (E1(1),ERR(1)),(E2(1),ERR(101)),
     1(E3 (1),ERR(201 )),(E4 (1),ERR( 301)),(E5 (1),ERR( 401)),
     1(E6 (1),ERR( 501)),(E7 (1),ERR( 601)),(E8 (1),ERR( 701)),
     1(E9 (1),ERR( 801)),(E10(1),ERR( 901)),(E11(1),ERR(1001)),
     1(E12(1),ERR(1101)),(E13(1),ERR(1201)),(E14(1),ERR(1301)),
     1(E15(1),ERR(1401)),(E16(1),ERR(1501)),(E17(1),ERR(1601)),
     1(E18(1),ERR(1701))
      EQUIVALENCE (E1A(1),ERR(55)),(E2A(1),ERR(155)),
     1(E3A (1),ERR( 255)),(E4A (1),ERR( 355)),(E5A (1),ERR( 455)),
     1(E6A (1),ERR( 555)),(E7A (1),ERR( 655)),(E8A (1),ERR( 755)),
     1(E9A (1),ERR( 855)),(E10A(1),ERR( 955)),(E11A(1),ERR(1055)),
     1(E12A(1),ERR(1155)),(E13A(1),ERR(1255)),(E14A(1),ERR(1355)),
     1(E15A(1),ERR(1455)),(E16A(1),ERR(1555)),(E17A(1),ERR(1655)),
     1(E18A(1),ERR(1755))
      DATA E1/
     1  13.0,  13.0,  13.0,    .1, 500.0,   -.1,   -.2,   -.2, 800.0,
     2   -.2,   -.3,  50.0,   3.6,  16.0,  50.0,    .7,   -.8,   1.0,
     3   2.0, 500.0, 600.0, 500.0,   5.0,    .8,    .5,   -.6,    .7,
     4   6.0, 500.0, 100.0,   1.3,    .9,   -.4,   -.3,   1.3,   4.0,
     5 500.0, 500.0,  40.0,   5.0,   1.8,   1.1,   0.0,   -.2,   -.3,
     6    .9,  16.0, 500.0, 500.0, 500.0,   5.0,    .9,   -.1,   -.4/
      DATA E1A/
     1   2.2,  15.0,  30.0, 500.0, 500.0, 500.0,  10.0,    .3,   1.0,
     2   -.2,   -.9,   -.3,   2.5,   8.0, 500.0, 500.0,  14.0,    .5,
     3    .9,   -.7,    .7,   7.0,  30.0, 170.0, 500.0, 500.0,  50.0,
     4   5.0,   1.1,   -.4,  -1.0,   -.5,   2.8,  10.0, 500.0,  70.0,
     5  40.0,   9.0,    .7,  -1.5,   1.5,   9.0,  30.0, 700.0, 500.0,
     6 210.0/
      DATA E2/
     1  16.0,   3.0,   2.7,  -1.0,  -1.2,  -1.0,   1.4,   2.3, 500.0,
     2  80.0,   7.0,   1.4,   1.1,   -.9,   1.1,   5.0,  40.0, 500.0,
     3 500.0, 500.0,  10.0,   3.0,   1.9,   -.8,  -1.0,  -1.1,   1.4,
     4   7.0, 500.0, 100.0,   8.0,   8.0,   2.8,   -.9,    .8,   2.4,
     5 200.0,  75.0, 500.0, 500.0,  50.0,   3.0,  11.0,   -.7,  -1.4,
     6  -1.6,    .5,  -1.5,  30.0,  30.0, 500.0, 500.0,  12.0,   2.9/
      DATA E2A/
     1   1.9,   -.4,   1.0,   -.4,   4.0,  18.0, 500.0, 500.0, 500.0,
     2 500.0,   3.0,   1.8,  -1.1,    .8,   -.9,   5.0,   -.7,   1.3,
     3  40.0,  70.0, 500.0,  60.0,  70.0, 500.0, 500.0,  21.0,   1.7,
     4   8.0,   -.8,   -.9,  -1.1,   1.7,  10.0,  40.0,  11.0,  16.0,
     5   9.0, 500.0, 500.0,  25.0,  16.0,   5.0,   -.9,   1.0,  -2.2,
     6  -2.2/
      DATA E3/
     1  -2.4,   2.4,  -4.0,   4.0,  -5.0,   6.0,   9.0,   7.0,   5.0,
     2   3.2,   2.8,   6.0,  -2.1,   2.2,   2.4,   6.0,   5.0,  16.0,
     3 500.0,   6.0,  15.0,   6.0,   3.2,  -1.7,  -1.6,  -1.5,  -1.5,
     4  -2.6,   5.0,  10.0, 500.0, 500.0,   2.8,   2.2,   3.7,   1.8,
     5  -2.9,  -1.6,   1.9,  25.0, 100.0, 500.0, 500.0,  28.0,  18.0,
     6  10.0,  -1.9,   1.8,  -2.2,  -2.2,  -2.3,   6.0,  30.0, 500.0/
      DATA E2A/
     1 150.0,   3.2,   5.0,   4.0,   2.4,   4.0,  -2.6,   2.6,  50.0,
     2 110.0, 500.0, 500.0,  17.0,  13.0,  15.0,  -2.7,   2.7,  -2.5,
     3  -2.5,  -2.6,   3.7,  30.0,  70.0, 500.0, 500.0,   5.0,   3.3,
     4   3.0,   2.6,   3.5,  -2.9,   3.0,  18.0,  40.0,  19.0, 500.0,
     5  25.0, 500.0,  80.0,  11.0,   7.0,  -3.1,   3.0,  -3.0,  -3.1,
     6  -3.2/
      DATA E4/
     1   3.3,  -3.8,   5.0,  30.0, 300.0,   4.0,  11.0,   5.0,   3.8,
     2   5.0,  -3.3,   3.4,  -3.6,   3.7,   8.0,  60.0,  70.0, 500.0,
     3  18.0, 200.0,  10.0,   4.0,  -3.4,   3.5,  -3.6,   3.6,  -3.5,
     4   3.7,  -3.2,  15.0,   7.0, 500.0,  30.0,  15.0,   5.0,   4.0,
     5   5.0,  -2.9,   3.0,  -2.6,   2.8,  40.0,  50.0, 200.0, 500.0,
     6  14.0,  50.0,  13.0,   3.8,  -1.7,   2.4,  -1.7,  -1.7,  -1.6/
      DATA E4A/
     1  12.0,   1.9,  40.0, 100.0, 210.0,  50.0,  20.0,   7.0,   7.0,
     2  15.0,   3.3,  -2.4,   2.4,   9.0, 100.0,  50.0, 200.0, 200.0,
     3 500.0, 500.0,  18.0,  -5.0,   2.6,  -2.3,  -2.2,  -2.2,   6.0,
     4  -2.6,   5.0,  -6.0,  32.0,  70.0, 500.0, 500.0,  20.0, 500.0,
     5   3.6,   4.0,  -3.3,   3.1,  -5.0,   7.0,   7.0,  50.0, 100.0,
     6 400.0/
      DATA E5/
     1 500.0, 500.0, 500.0, 500.0,  30.0,  -5.0,   9.0,  -6.0, 100.0,
     2  -5.0,  -4.0,  -3.2,   3.6,  -3.9,   9.0, 100.0,  33.0,  90.0,
     3 500.0,  50.0, 500.0, 100.0,  27.0,  32.0,   4.0,  -3.2,   3.1,
     4  -2.6,  15.0,  13.0,  90.0, 150.0, 500.0, 500.0, 500.0, 500.0,
     5  30.0,  -3.6,   6.0,  -2.4,  -2.4,  -2.4,   4.0,   3.8,  12.0,
     6  70.0,  70.0, 230.0, 500.0, 500.0,  30.0,  12.0,  10.0,   7.0/
      DATA E5A/
     1   5.0,  -3.2,   3.3,   6.0,  20.0,  20.0, 200.0,  20.0, 500.0,
     2 500.0, 500.0, 500.0,  21.0, 200.0,   4.0,  -3.2,  -3.1,  -2.9,
     3   3.7,  -3.2,   4.0,  -4.0,  16.0,  20.0, 500.0, 500.0, 500.0,
     4 500.0, 500.0, 100.0,   6.0,   7.0,   8.0,  -3.2,   3.1,   2.3,
     5   5.0,  16.0, 100.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 320.0/
      DATA E6/
     1   7.0,  29.0,  -3.0,   4.0,  -2.5,  -2.2,  -2.2,  -2.1,  -2.2,
     2   6.0,  -3.2,  19.0, 500.0, 500.0, 500.0, 500.0, 140.0,  14.0,
     3   6.0,  11.0,  50.0,   9.0, 200.0,   4.0,  60.0,  25.0, 500.0,
     4 100.0, 500.0, 200.0, 500.0, 500.0,  11.0,  11.0,  -5.0, 100.0,
     5  -4.0,  -3.3,  -3.3,  -2.7,  -2.9,   6.0,  -5.0,   7.0,  11.0,
     6 300.0, 610.0, 500.0,  11.0, 100.0,  11.0,  20.0,  20.0,  18.0/
      DATA E6A/
     1   7.0,  -4.0,   4.0,   6.0,  11.0,  40.0, 600.0, 500.0, 100.0,
     2 500.0, 500.0,  28.0, 500.0,  23.0,  -9.0,  27.0, -10.0,  -5.0,
     3  -5.0,   4.0,  -8.0,   4.0, -13.0,  50.0,  50.0, 100.0, 500.0,
     4 400.0,  22.0,  60.0,  32.0,  21.0,  12.0,  -4.0,   4.0,  -3.8,
     5   3.8,   4.0,  50.0,  20.0, 500.0, 100.0, 500.0, 420.0, 500.0,
     6 500.0/
      DATA E7/
     1 500.0, 100.0,  -3.9,   6.0,  -3.7,   5.0,  -3.1,  -3.0,  -2.8,
     2  -2.7,  -2.6,  10.0,  -3.0,  14.0,  20.0, 300.0, 500.0, 500.0,
     3 500.0, 500.0,  30.0, 150.0,  80.0,   8.0,  50.0,  29.0,   9.0,
     4  -9.0,   7.0,  -8.0,   8.0,  10.0, 300.0,  38.0, 600.0,  40.0,
     5 800.0,  50.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 500.0,  17.0,  16.0,  -8.0,  12.0,  -6.0,  -6.0,  -3.3,  -2.2/
      DATA E7A/
     1  -2.2,  -2.2,  -2.2,  -3.1,  -3.2,   6.0,  -4.0,   6.0,  11.0,
     2 500.0, 210.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     3  50.0,  32.0,  50.0,  21.0,  40.0,  40.0,   6.0,  20.0,   7.0,
     4   2.2,   2.4,  -2.6,   2.7,   4.0, 150.0,   7.0, 150.0,  30.0,
     5 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 500.0/
      DATA E8/
     1 500.0, 500.0, 200.0, 110.0,  50.0, 500.0,  20.0, -13.0, 500.0,
     2  -3.3,  -2.9,  -2.8,  -2.9,  -2.9,   5.0,  -3.2,   8.0,  -3.7,
     3   6.0,  21.0, 110.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 110.0, 500.0, 400.0, 500.0, 500.0,  40.0, 100.0,  10.0,   3.1,
     5   6.0,  -3.5,   3.7,   6.0,  10.0,   3.2,  15.0,  50.0,  60.0,
     6  22.0, 100.0, 500.0, 500.0, 500.0, 500.0, 500.0, 420.0, 500.0/
      DATA E8A/
     1 500.0, 500.0, 100.0,-140.0,  40.0,  -7.0,   5.0,  -1.8,  -5.0,
     2  -1.8,  -3.1,  -3.1,   8.0,  -5.0,  11.0,  -5.0,  21.0, 500.0,
     3 220.0, 500.0, 500.0, 500.0,  40.0, 500.0,  21.0,  25.0, 500.0,
     4  10.0,   7.0,  23.0,  -8.0,   7.0,   8.0,   8.0,   7.0, 500.0,
     5 100.0, 100.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 -10.0/
      DATA E9/
     1  18.0,  -9.0,   8.0,  -7.0,  -7.0,  -7.0,  -7.0,  -7.0,   7.0,
     2  15.0, 100.0, 100.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     3  40.0,  50.0, 500.0,  26.0, 120.0,  70.0, 500.0, -12.0, -12.0,
     4  12.0,  32.0,  13.0,   0.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     5 500.0, 500.0, 500.0, -31.0, 500.0, -15.0,  19.0, -11.0,  11.0,
     6 -11.0,  12.0,  11.0, 100.0, 120.0, 500.0, 500.0, 500.0, 500.0/
      DATA E9A/
     1 500.0, 500.0,  18.0,  28.0,  12.0, -11.0,  11.0,  11.0,  11.0,
     2  15.0, 100.0, 200.0, 500.0, 200.0, 500.0, 500.0, 500.0, 500.0,
     3 500.0,  40.0,  18.0, -11.0, -11.0, -11.0, -11.0, -11.0,  11.0,
     4 -11.0,  15.0, -11.0,  14.0,  32.0, 500.0, 400.0,  40.0, 100.0,
     5  15.0,  40.0,  13.0,  25.0,  11.0,  15.0,  11.0,  80.0,  15.0,
     6 200.0/
      DATA E10/
     1 100.0, 500.0, 500.0, 120.0,  31.0, -11.0,  11.0,  20.0, -11.0,
     2 -11.0, -11.0, -11.0,  11.0, -11.0,  11.0, -12.0,  12.0,  17.0,
     3 200.0,  32.0,  19.0,  22.0,  14.0,  32.0, 500.0,  21.0, -11.0,
     4  11.0, -11.0,  13.0,  11.0,  14.0,  19.0, 120.0,  50.0, 500.0,
     5 500.0, 500.0, 500.0,  29.0,  12.0,  12.0,  21.0,  15.0, -12.0,
     6  11.0, -12.0, -11.0, -11.0, -11.0, -11.0,  12.0, -12.0,  15.0/
      DATA E10A/
     1 120.0, 500.0, 500.0, 300.0,  19.0,  22.0,  14.0,  32.0, 500.0,
     2 500.0,  20.0, 500.0,  12.0,  13.0, -11.0,  11.0, -12.0,  70.0,
     3  50.0, 100.0, 500.0, 500.0, 500.0,  29.0,  15.0,  15.0,  29.0,
     4  19.0, -16.0,  14.0, -13.0,  11.0, -11.0,  11.0, -11.0, -11.0,
     5 -11.0,  11.0,  12.0, 500.0, 500.0, 500.0, 300.0,  20.0,  23.0,
     6 500.0/
      DATA E11/
     1 500.0, 500.0,  14.0, 500.0,  32.0,  40.0,  32.0,  11.0,  11.0,
     2 -10.0,  10.0,  23.0, 100.0, 100.0, 300.0, 500.0, 500.0, 500.0,
     3 500.0, 500.0,  40.0, 500.0, 500.0, 500.0, 500.0, 500.0,  18.0,
     4 -16.0,  12.0, -13.0,  11.0, -10.0, -10.0, -10.0,  10.0, -11.0,
     5  11.0,  16.0, 300.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 500.0, 500.0, 500.0, 500.0, 100.0, 100.0,  23.0,  24.0,  32.0/
      DATA E11A/
     1  16.0,  28.0,  60.0, -11.0,  11.0,  11.0,  15.0,  32.0,  40.0,
     2  50.0,  70.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     3 500.0, 500.0, 500.0, 500.0, 500.0,  38.0,  26.0,  20.0, -16.0,
     4  16.0, -11.0, -11.0, -11.0, -11.0, -11.0,  11.0, -12.0,  14.0,
     5 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 500.0/
      DATA E12/
     1 500.0, 500.0, 500.0,  70.0,  80.0,  34.0,  23.0, 500.0, 500.0,
     2  32.0,  13.0,  11.0,  11.0,  11.0,  50.0,  40.0, 100.0, 500.0,
     3 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 500.0, 500.0, 200.0, 500.0, 500.0, 500.0, 500.0,  31.0,  14.0,
     5  12.0,  11.0,  11.0,  11.0,  11.0,  12.0, 200.0,  30.0, 500.0,
     6 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0/
      DATA E12A/
     1 500.0, 500.0, 500.0, 200.0,  12.0, 100.0,  19.0, -25.0, -12.0,
     2  12.0,  16.0,  32.0, 100.0,  60.0, 500.0, 500.0, 500.0, 500.0,
     3 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 100.0, 500.0,-200.0,  16.0, -12.0, -12.0, -12.0,  13.0, -13.0,
     5  13.0,  13.0, 200.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 500.0/
      DATA E13/
     1 500.0, 500.0, 500.0, 500.0, 210.0, 500.0, 200.0, 500.0,  24.0,
     2  15.0, 500.0, -13.0,  13.0, -13.0,  13.0,  24.0, 200.0, 500.0,
     3 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, -22.0,  13.0, -13.0,
     5 -13.0, -13.0, -13.0, -13.0,  13.0, -14.0,  21.0,  20.0, 500.0,
     6 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0/
      DATA E13A/
     1 500.0, 500.0, 500.0, 500.0, 190.0, 500.0,  24.0, 500.0,  16.0,
     2 500.0, 150.0, -14.0,  14.0, -20.0,  20.0,  28.0,  60.0, 200.0,
     3 300.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,  19.0, 500.0,
     5 -24.0,  20.0, -14.0,  20.0, -19.0, -13.0, -13.0,  11.0, -21.0,
     6  26.0/
      DATA E14/
     1 500.0, 110.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     2 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,  26.0,  50.0,  17.0,
     3 500.0,  16.0,   6.0,   9.0,   6.0,   6.0,   6.0,  50.0, 100.0,
     4 200.0, 500.0, 300.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     5 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,  80.0,  70.0,
     6 500.0, 500.0,  26.0,  50.0,  10.0,  21.0,   6.0,   6.0,   6.0/
      DATA E14A/
     1   6.0,   6.0,   6.0,   6.0,   8.0,  21.0, 500.0, 500.0, 500.0,
     2 500.0, 500.0, 500.0, 500.0, 310.0, 210.0, 500.0, 500.0, 500.0,
     3 210.0, 500.0, 500.0,  80.0, 220.0,  10.0,  16.0,  18.0,   6.0,
     4   6.0,   5.0,   5.0,   6.0,   6.0,  15.0,  13.0, 500.0, 500.0,
     5 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     6 500.0/
      DATA E15/
     1 500.0, 500.0,  90.0, 500.0,  35.0,  11.0,  10.0,   6.0,   6.0,
     2   5.0,   5.0,   5.0,   5.0,   5.0,   3.8,   6.0, 500.0,   3.3,
     3 500.0, 500.0, 500.0, 500.0, 500.0, 310.0, 210.0, 500.0, 500.0,
     4 500.0, 500.0, 500.0, 500.0, 500.0,  50.0, 500.0,   9.0,  12.0,
     5   8.0,   5.0,   5.0,   5.0,   6.0,   6.0,  11.0,  12.0, 100.0,
     6 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0/
      DATA E15A/
     1 500.0, 500.0,  90.0, 500.0,  35.0,  11.0,  11.0,   6.0,   7.0,
     2   5.0,   5.0,   5.0,   7.0,   5.0,   3.7,   6.0, 500.0,   3.3,
     3 500.0, 500.0, 310.0, 210.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 500.0, 500.0,  50.0, 500.0,   9.0,  12.0,  11.0,   6.0,  13.0,
     5   6.0,   7.0,   6.0,  12.0,  13.0,  80.0, 500.0, 500.0, 500.0,
     6 500.0/
      DATA E16/
     1 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,  35.0,  12.0,  11.0,
     2   7.0,  11.0,  11.0,  10.0,  11.0,   8.0,   5.0,   3.7,   6.0,
     3 500.0,   3.3, 310.0, 210.0, 500.0, 500.0, 500.0, 500.0, 500.0,
     4 500.0, 500.0,  50.0, 500.0,  11.0,  13.0,  13.0,  14.0,  14.0,
     5   6.0,   9.0,   8.0,  12.0,  21.0,   3.7, 500.0, 500.0, 339.0,
     6 100.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,  90.0/
      DATA E16A/
     1 500.0,  35.0,  13.0,  12.0,  11.0,  13.0,  14.0,  14.0,  15.0,
     2   9.0,   9.0,   3.7,   6.0,   3.6,   3.3,   20.0,  5.0, 500.0,
     3 500.0, 500.0, 500.0, 500.0, 500.0, 500.0, 500.0,  50.0, 500.0,
     4  15.0,  16.0,  16.0,  17.0,  18.0,   7.0,  11.0,   8.0,  12.0,
     5   3.8,   3.1,   5.0, 150.0, 500.0, 100.0, 500.0, 500.0, 500.0,
     6  90.0/
      DATA E17/
     1 500.0,  36.0,  16.0,  24.0,  23.0,  14.0,  16.0,  17.0,  18.0,
     2  11.0,   6.0,   3.7,   6.0,   3.4,   2.9,   3.0,   2.3,   2.4,
     3   4.0, 500.0,  35.0,  19.0,  20.0,  21.0,  12.0,  10.0,   9.0,
     4  13.0,   3.7,   3.1,  12.0,   2.4,   5.0, 100.0, 200.0,  50.0,
     5 300.0,  34.0, 500.0,  21.0,  11.0,   6.0,  50.0,   6.0,   3.3,
     6   2.4,   2.4,   2.3,   2.5,   2.2,   2.2,   5.0,  29.0,  24.0/
      DATA E17A/
     1  13.0, 500.0, 500.0,   9.0,   2.6,  10.0,   2.3,   2.3,   3.0,
     2  60.0, 100.0, 500.0,  23.0,  23.0,   8.0,  60.0,   6.0,   6.0,
     3   2.4,   2.4,   2.3,   2.3,   2.3,   3.5,   5.0,  30.0,  50.0,
     4 500.0, 500.0, 500.0, 500.0,  32.0,   5.0,  20.0,   2.3,   2.7,
     5   3.2,   3.1,   3.6,  50.0, 500.0, 500.0, 500.0, 500.0,  39.0,
     6 500.0/
      DATA E18/
     1   6.0,   6.0,   2.4,   2.6,   2.3,   2.9,   3.4,   5.0,   6.0,
     2   8.0,  12.0, 500.0, 500.0, 500.0, 500.0, 500.0,   6.0,  21.0,
     3   2.9, 500.0,   6.0, 500.0,   3.5,   5.0, 500.0, 500.0, 500.0,
     4 500.0,  33.0, 500.0,   6.0,   6.0,   3.1, 500.0,  31.0,   3.0,
     5   3.5,   5.0,   6.0,  10.0,  12.0, 500.0, 500.0, 500.0, 500.0,
     6  31.0, 500.0,   7.0, 500.0,   8.0, 500.0,   3.5,   6.0, 500.0/
      DATA E18A/
     1 500.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,
     2   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,
     3   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,
     4   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,
     5   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,
     6   0.0/
      ERRMAS=ERR(J)
      RETURN
      END
************************************************************************
*                 SUBROUTINE MASSIV                                    *
************************************************************************
      SUBROUTINE MASSIV(IM9)                                            
      COMMON/MASOUT/WDIS(990),KPREN(990),KPREP(990),KEQD(990),KEQT(990) 
     *,KEQHE(990),KEQAL(990),KSUMN(990),KSUMP(990),KREACT(990),
     * KPREA(990),KN
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/EVAMAS/NEVAN,NEVAP,NEVAD,NEVAT,NEVAHE,NEVAAL               
      COMMON/CFUMAS/CF /INF/INFBIG,INFS0                                       
      COMMON/INFSEP/KSEP(100,4),INFSEP,JSEPM                        
      IM9=0
      IF(INFBIG.EQ.0)GOTO 200
      I=1                                                               
   10 IF(KPREN(I).EQ.NPREN)GOTO 18                                      
   11 IF(I-KN)12,100,100                                                
   12 I=I+1                                                             
      GOTO 10                                                           
   18 IF(KSUMN(I).EQ.(NPREN+NEVAN))GOTO 20                              
      GOTO 11                                                           
   20 IF(KPREP(I).EQ.NPREP)GOTO 27                                      
      GOTO 11                                                           
   27 IF(KPREA(I).EQ.NPREA)GOTO 28                                      
      GOTO 11                                                           
   28 IF(KSUMP(I).EQ.(NPREP+NEVAP))GOTO 30                              
      GOTO 11                                                           
   30 IF(KEQAL(I).EQ.(NEVAAL+NPREA))GOTO 40                                     
      GOTO 11                                                           
   40 IF(KEQD(I).EQ.NEVAD)GOTO 50                                       
      GOTO 11                                                           
   50 IF(KEQT(I).EQ.NEVAT)GOTO 60                                       
      GOTO 11                                                           
   60 IF(KEQHE(I).EQ.NEVAHE)GOTO 70                                     
      GOTO 11                                                           
   70 KREACT(I)=KREACT(I)+1                                             
      WDIS(I)=WDIS(I)+CF                                                
      IF(INFSEP.NE.0)CALL CHESEP
      RETURN                                             
C                                                                       
  100 KN=KN+1                                                           
      IF(KN.GT.990)GOTO 101                                            
      KPREN(KN)=NPREN                                                   
      KPREP(KN)=NPREP                                                   
      KPREA(KN)=NPREA                                                   
      KEQD(KN)=NEVAD                                                    
      KEQT(KN)=NEVAT                                                    
      KEQHE(KN)=NEVAHE                                                  
      KEQAL(KN)=NEVAAL + NPREA
      KSUMN(KN)=NEVAN+NPREN                                             
      KSUMP(KN)=NEVAP+NPREP                                             
      KREACT(KN)=1                                                      
      WDIS(KN)=CF                                                       
      IF(INFSEP.NE.0)CALL CHESEP
      RETURN                                                           
C                                                                       
200   KN=1
      KPREN(KN)=NPREN+KPREN(KN)                                         
      KPREP(KN)=NPREP+KPREP(KN)                                         
      KPREA(KN)=NPREA+KPREA(KN)                                         
      KEQD(KN)=NEVAD+KEQD(KN)                                           
      KEQT(KN)=NEVAT+KEQT(KN)                                           
      KEQHE(KN)=NEVAHE+KEQHE(KN)                                        
      KEQAL(KN)=NEVAAL+KEQAL(KN)   +  NPREA
      KSUMN(KN)=NEVAN+NPREN+KSUMN(KN)                                   
      KSUMP(KN)=NEVAP+NPREP+KSUMP(KN)                                   
      KREACT(KN)=1+KREACT(KN)                                           
      WDIS(KN)=CF+WDIS(KN)                                              
      IF(INFSEP.NE.0)CALL CHESEP
      RETURN                                                           
C                                                                       
  101 PRINT 102,KN                                                    
  102 FORMAT(1X,' SUBROUTINE MASSIV. KN =',i5,'  EXCEEDS LIMIT')
      KN=KN-1
                     IM9=1
      RETURN
      END                                                             
************************************************************************
*                 SUBROUTINE MEMDEC                                    *
************************************************************************
       SUBROUTINE MEMDEC(I)                                     
       COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
       COMMON/PARTL7/WP1,PX1,PY1,PZ1,P1,T1,E1,X1,Y1,Z1,R1,JIN1,M1
       GOTO(1,2),I
1        WP1  =WP                                                         
         PX1  =PX                                                         
         PY1  =PY                                                      
         PZ1  =PZ                                                      
         P1   =P                                                       
         T1   =T                                                       
         E1   =E                                                       
         X1   =X                                                       
         Y1   =Y                                                       
         Z1   =Z                                                      
         R1   =R                                                      
         JIN1 =JIN                                                    
         M1   =M                                                      
      RETURN                                                            
2        IF(M1.ne.3) goto 3
         WP   =WP1                                                   
         PX   =PX1                                                   
         PY   =PY1                                                   
         PZ   =PZ1                                                   
         P    =P1                                                    
         T    =T1                                                    
         E    =E1                                                    
         X    =X1                                                    
         Y    =Y1                                                    
         Z    =Z1                                                   
         R    =R1                                                   
         JIN  =JIN1                                                 
         M    =M1                                                   
         M1   =0
      RETURN                                                            
    3 Write(6,4)M1
      Write(8,4)M1
    4 Format(1x,'ERROR IN MEMDEC    M1=',i3)
      Stop
      END                                                               
************************************************************************
*               SUBROUTINE MEMEQU                                      *
************************************************************************
      SUBROUTINE MEMEQU(E,MP)
C Evaporation
C Store characteristics of particles emitted from nucleus
      COMMON/EMEM/EMEM0(21),EMEM(21),RMEM(21,3),RMEM0(21,3),HMEM
      COMMON/EOUT/SPE(19,5,3),PI(19),EOUT1(5,3),EOUT2(5,3),MSPE
      COMMON/IX190/IX191,IX192,IX193                                    
      COMMON/DATINI/RA,T0,W0 /MAIIPR/IPR                                             
      COMMON/SPEFUL/ANGLIM(9,2,3),ANGSUM(21,9,3),ANGCEN(9,3),DCEN,MANG
      COMMON/TR1TR2/VX,VY,VZ /URAND1/IYG                                                 
C Transition to LCS
      WP=WM(MP)
      PP=SQRT( E *(E +2.*WP) )
      CC=RANDOMG(0)                                                   
            QCOS=1.-2.*CC                                               
            QSIN=SQRT(ABS(1.-QCOS*QCOS))                                
            CC=RANDOMG(0)                                               
            FI=6.2831852*CC                                             
      PWX=PP*QSIN*COS(FI)                                               
      PWY=PP*QSIN*SIN(FI)                                               
      PWZ=PP*QCOS                                                       
        PWX=PWX+WP*VX                                                   
        PWY=PWY+WP*VY                                                   
        PWZ=PWZ+WP*VZ                                                   
      QCOS=PWZ/SQRT(PWX*PWX+PWY*PWY+PWZ*PWZ)                            
C                                                                       
      TW=E
      DO 1 NU=1,21                                                      
      IF(TW.LE.EMEM(NU))GOTO 2                                          
1     CONTINUE                                                          
           IX191=IX191+1                                                
           WRITE(IPR,87)TW                                              
   87 FORMAT(1X,' CONTROL MEMEQ  ( ENERGY )','  TW=',E14.5)            
           IF(IX191.GT.10000)STOP                                          
      RETURN
C                                                                       
2     RMEM(NU,MP)=RMEM(NU,MP)+1.                                              
C                                                                       
      DO 7 ICEN=1,MANG
      IF(QCOS.LE.ANGLIM(ICEN,1,MP).AND.QCOS.GE.ANGLIM(ICEN,2,MP))             
     * ANGSUM(NU,ICEN,MP) = ANGSUM(NU,ICEN,MP) + 1.
7     CONTINUE
C
C Total angular distribution for given TW interval
      DO 1000 L=1,MSPE
      IF(TW.GE.EOUT1(L,MP).AND.TW.LE.EOUT2(L,MP))GOTO 10
      GOTO 1000
10      DO 93 NANG=1,18                                                 
        IF(QCOS.GE.PI(NANG+1))GOTO 97                                   
   93 CONTINUE                                                          
        IX192=IX192+1                                                   
      WRITE(IPR,96)QCOS                                                 
   96 FORMAT(1X,' CONTROL MEMEQ  (ANGULAR) ','QCOS=',E14.5)            
        IF(IX192.GT.10000)STOP                                             
      RETURN                                                            
   97 SPE(NANG,L,MP)=SPE(NANG,L,MP)+1.                                            
1000  CONTINUE
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE MEMIN                                     *
************************************************************************
      SUBROUTINE MEMIN                                                  
      COMMON/NDIM/N /SCIMEM/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/MEMORY/U(11,20),MU(2,20) /MAIIPR/IPR                                                 
      N=N+1                                                             
       IF(N.GT.20)GOTO 10                                               
      U(1,N)=WP                                                         
      U(2,N)=PX                                                         
      U(3,N)=PY                                                         
      U(4,N)=PZ                                                         
      U(5,N)=P                                                          
      U(6,N)=T                                                          
      U(7,N)=E                                                          
      U(8,N)=X                                                          
      U(9,N)=Y                                                          
      U(10,N)=Z                                                         
      U(11,N)=R                                                         
      MU(1,N)=JIN                                                       
      MU(2,N)=M                                                         
      RETURN                                                            
   10 PRINT 20,N                                                        
      WRITE(IPR,20)N                                                    
   20 FORMAT(1X,' SUBR MEMIN. ARRAYS LIMIT EXCEEDED. N=',I4)                  
      STOP                                                              
      END                                                               
************************************************************************
*                 SUBROUTINE MEMOUT                                    *
************************************************************************
      SUBROUTINE MEMOUT                                                 
      COMMON/NDIM/N /MEMORY/U(11,20),MU(2,20)                                   
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      WP=U(1,N)                                                         
      PX=U(2,N)                                                         
      PY=U(3,N)                                                         
      PZ=U(4,N)                                                         
      P=U(5,N)                                                          
      T=U(6,N)                                                          
      E=U(7,N)                                                          
      X=U(8,N)                                                          
      Y=U(9,N)                                                          
      Z=U(10,N)                                                         
      R=U(11,N)                                                         
      JIN=MU(1,N)                                                       
      M=MU(2,N)                                                         
      N=N-1                                                             
      RETURN                                                            
      END                                                               
************************************************************************
*               SUBROUTINE MEMPRE                                      *
************************************************************************
      SUBROUTINE MEMPRE(M,P1,P2,P3,T)
C Pre-equilibrium (cascade)
C Store characteristics of particles emitted from nucleus
      COMMON/EMEM/EMEM0(21),EMEM(21),RMEM(21,3),RMEM0(21,3),HMEM
      COMMON/EOUT/SPE(19,5,3),PI(19),EOUT1(5,3),EOUT2(5,3),MSPE
      COMMON/IX190/IX191,IX192,IX193 /DATINI/RA,T0,W0                                            
      COMMON/MAIIPR/IPR  /INFDIS/INFDIS,INFOUP(3)
      COMMON/SPEFUL/ANGLIM(9,2,3),ANGSUM(21,9,3),ANGCEN(9,3),DCEN,MANG
       MP=M
       IF(INFOUP(MP).NE.1)RETURN
       PWX=P1
       PWY=P2
       PWZ=P3
       TW=T
           QCOS=PWZ/SQRT(PWX*PWX+PWY*PWY+PWZ*PWZ)                       
      DO 1 NU=1,21                                                      
      IF(TW.LE.EMEM0(NU))GOTO 2                                         
    1 CONTINUE                                                          
           IX191=IX191+1                                                
C          IF(IX191.GT.1000)STOP                                          
           WRITE(IPR,87)TW                                              
   87 FORMAT(1X,'CONTROL MEMPRE ( ENERGY )','  TW=',E14.5)            
      RETURN
    2 RMEM0(NU,MP)=RMEM0(NU,MP)+1.                                            
C                                                                       
      DO 7 ICEN=1,MANG
      IF(QCOS.LE.ANGLIM(ICEN,1,MP).AND.QCOS.GE.ANGLIM(ICEN,2,MP))             
     * ANGSUM(NU,ICEN,MP) = ANGSUM(NU,ICEN,MP) + 1.
7     CONTINUE
C
C Total angular distribution for interval TW                            
      DO 1000 L=1,MSPE
      IF(TW.GE.EOUT1(L,MP) .AND. TW.LE.EOUT2(L,MP)) GOTO 10
      GOTO 1000
10      DO 93 NANG=1,18                                                 
        IF(QCOS.GE.PI(NANG+1))GOTO 97                                   
   93 CONTINUE                                                          
        IX192=IX192+1                                                   
C       IF(IX192.GT.10)STOP                                             
      WRITE(IPR,96)QCOS                                                 
   96 FORMAT(1X,'CONTROL MEMPRE (ANGULAR) ','QCOS=',E14.5)            
      RETURN                                                            
   97 SPE(NANG,L,MP)=SPE(NANG,L,MP)+1.                                            
1000  CONTINUE
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE MODEL                                     *
************************************************************************
      SUBROUTINE MODEL(IXX)                                             
      COMMON/NPROL/NPROL                                                
      COMMON/JACT/JACT                                                  
      CALL ZERO2                                                        
      CALL INIPAR                                                       
    1 CALL INTPOP(IKS,INT9)                                             
                   IF(INT9.NE.0) GOTO 10
      IF(IKS)4,2,3                                                      
    2 CALL MEMOUT                                                       
      GOTO 1                                                            
    3 CALL ACTIN(IKS)                                                   
      IF(IKS)4,2,1                                                      
    4 IF(JACT)6,5,6                                                     
    5 NPROL=NPROL+1                                                     
                         IXX=2
                         RETURN
    6 CALL TREAT1                                                       
      CALL EVAPAR                                                       
      CALL TREAT2                                                       
      CALL CFUN                                                         
      CALL MASSIV(IM9)                                                  
               IF(IM9.NE.0) GOTO 20
                         IXX=2
                         RETURN
10    IXX=1
      RETURN
20          IXX=3
            RETURN
      END                                                               
************************************************************************
*                 SUBROUTINE NADRAW                                    *
************************************************************************
      SUBROUTINE NADRAW(T,QCOS,FI)                                        
      COMMON/URAND1/IYG                                                 
      CC=RANDOMG(0)                                                     
      FI=6.2831852*CC                                                   
      CC=RANDOMG(0)                                                     
      DSDOM=-0.238*ALOG(T)+1.91
   10      CC=RANDOMG(0)
           CC1=RANDOMG(0)
      TETA=CC*180.
      CALL OSTROU(T,TETA,DSDO)                                      
      DSDO=DSDO*SIN(TETA*3.1415926/180.)  
      IF( DSDO - DSDOM*CC1 )10,20,20                            
   20 QCOS=COS(TETA*3.1415926/180.)                                                            
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE NPDRAW                                    *
************************************************************************
      SUBROUTINE NPDRAW(QCOS,FI)                                        
      COMMON/FIGA1B/T1(16),BA1(16),BB1(16),BB2(9),BB3(8)                
      COMMON/ACTA1B/TREST /A1BNPD/S(4),PAR1                                           
      COMMON/URAND1/IYG                                                 
      CALL A1B1B2                                                       
      CC=RANDOMG(0)                                                     
      DO 10 I=1,4                                                       
      IF(CC.LE.S(I))GOTO 20                                             
   10 CONTINUE                                                          
      PRINT 12,CC,(S(I),I=1,4)                                          
      WRITE(1,12)CC,(S(I),I=1,4)                                        
      WRITE(8,12)CC,(S(I),I=1,4)                                        
      WRITE(12,12)CC,(S(I),I=1,4)                                       
   12 FORMAT(1X,'CONTROL NPDRAW'/1X,5G15.8)                   
      I=4                                                               
   20 CC=RANDOMG(0)                                                     
           FI=6.2831852*CC                                                   
           CC=RANDOMG(0)                                                     
      GOTO(30,40,50,60),I                                               
   30 QCOS=1.-CC                                                        
      RETURN                                                            
   40 QCOS=ABS(1.-CC)**0.25                                             
      RETURN                                                            
   50 QCOS=-CC                                                          
      RETURN                                                            
   60 QCOS=-(ABS(CC)**PAR1)                                             
      RETURN                                                            
      END                                                               
************************************************************************
*                  SUBROUTINE NRT_COEFF                                *
************************************************************************
          Subroutine NRT_COEFF(Z1,Z2,A1,A2,ANRT,BNRT,GNRT)
          PI=3.1415926
          A0=0.52918E-08    ! Bohr radius, cm
          EL=4.8E-10        ! electron charge
C Classical NRT, Nucl.Eng.Des., 1975 :
C         RK0=0.1337*(Z1**(1./6.))*SQRT(Z1/A1)                            
C Robinson
          RK0=0.0793*(Z1**0.6666666)*SQRT(Z2)*((A1+A2)**1.5)/         (
     #    (A1**1.5)*SQRT(A2)*((Z1**0.666666666+Z2**0.66666666)**0.75) )
          AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )/
     #          SQRT(Z1**0.6666666+Z2**0.6666666)
          E0=Z1*Z2*(EL**2)*(A1+A2)/(AA*A2)
            E0=E0/1.6E-06    !  erg ---> MeV
            E0=1000.*E0      !      ---> keV
            EE=1./E0
         ANRT=RK0*EE         
         BNRT=0.40244*RK0*(EE**0.75)                                          
         GNRT=3.4008*RK0*(EE**0.1666666666)                                   
         RETURN
         END
************************************************************************
*                 SUBROUTINE OPEN_OUTPUT_FILES                         *
************************************************************************
      SUBROUTINE OPEN_OUTPUT_FILES(NAMRD)
      CHARACTER NAMRD*8
      CHARACTER*12 NAM1,NAM7N,NAM7P,NAM7A,NAM8,NAM10,NAM12,NAM14
                 Nam1 =Namrd//'.sho'  
                 Nam7n=Namrd//'.nnn'  
                 Nam7p=Namrd//'.ppp'  
                 Nam7a=Namrd//'.aaa'  
                 Nam8 =Namrd//'.ful'  
                 Nam10=Namrd//'.mlt'  
                 Nam12=Namrd//'.lib'  
                 Nam14=Namrd//'.alp'  
      open(1,file=Nam1)
      open(71,file=Nam7n)
      open(72,file=Nam7p)
      open(73,file=Nam7a)
      open(8,file=Nam8)
      open(10,file=Nam10)
      open(12,file=Nam12)
      open(14,file=Nam14)
           open(33,file='d2sdedo.7r')  
      Return
      End
************************************************************************
*                 SUBROUTINE OPTIONS                                   *
************************************************************************
      SUBROUTINE OPTIONS(IPR,BONNE,IWRI,INFKAL)
      COMMON/K1996/K1996 /I1988/I1988 /I1990/I1990 
      COMMON/R1R2/E1E2(200),IR1R2 
      COMMON/IMOM/IMOM /ICHEN/ICHEN /URAND1/IYG
      COMMON/INF000/INFGAS
*      
* IPR is the number of unit for general output file                       
      IPR=8                                                        
*
      I1988=0                                                   
      I1990=0                                                   
              IR1R2=1                                                   
C                                                                       
C IMOM:limitation on orbital momenta (according to Bunakov et al)
C     : 0 - no, 1-yes
       IMOM=1
C ICHEN =0 is not used now
       ICHEN=1                                                   
       BONNE=0.01
       IWRI=1
C IYG for URAND pseudo RANDOMG number generator
              IYG=1995
C INFGAS: calcualtion of total production cross-section for
C         particles with 0 < Z < 4:  0-no, 1-yes
              INFGAS = 1
C
C INFKAL: calcualtion of angular distributions for pre-equilibrium
C         particles for recoil spectra calculation (primary particle
C         energy T0 < 60 MeV)     
C         = 0  - INC model
C         = 1  - old Kalbach, Mann approximation (not tested)  
              INFKAL = 0
       IF(IPR.NE.IWRI)GOTO 1788                                         
          PRINT 1789,IWRI                                               
          WRITE(IPR,1789)IWRI                                           
          STOP                                                          
1788   continue                                                       
*
* See Subr DISTPA
      K1996=0
*
      Return
 1789 FORMAT(1X,' Bad unit:  IWRI=IPR=',I5)                  
      End
************************************************************************
*                 FUNCTION ORBIT                                       *
************************************************************************
      FUNCTION ORBIT(PX,PY,PZ,X,Y,Z)                                    
      RI=Y*PZ-Z*PY                                                      
      RJ=Z*PX-X*PZ                                                      
      RK=X*PY-Y*PX                                                      
      ORBIT=SQRT(RI*RI+RJ*RJ+RK*RK)                                     
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE OSTROU                                    *
************************************************************************
*  Data are correct only for T < 300 MeV                                                                      
      SUBROUTINE OSTROU(T,TETA,DSDO)                                      
* TETA in degrees
       C = 1.44465E-06 * (TETA**3) + 1.07744E-04*(TETA**2) -
     c 8.87089E-02 * TETA + 6.74152
       IF(30.GT.TETA) RK = (0.12/30.)*TETA
       IF(30.LE.TETA .AND. TETA.LE.165. )
     c RK = -1.45194E-10*(TETA**5) + 6.68681E-08 *(TETA**4) -
     c 1.05389E-05*(TETA**3) + 6.10544E-04*(TETA**2) -
     c 3.87393E-03 *TETA - 7.76363E-02 
       IF(TETA.GT.165. )
     c RK = -1.45194E-10*(165.**5) + 6.68681E-08 *(165.**4) -
     c 1.05389E-05*(165.**3) + 6.10544E-04*(165.**2) -
     c 3.87393E-03 *165. - 7.76363E-02 
       SQRTT = SQRT(T)
       DSDO = C * EXP(-RK*SQRTT)
       RETURN                                                            
       END                                                               
************************************************************************
*                 SUBROUTINE OUTPUT                                    *
************************************************************************
      SUBROUTINE OUTPUT                                                 
      REAL*8 INFGEN                                                     
      COMMON/MASOUT/WDIS(990),KPREN(990),KPREP(990),KEQD(990),KEQT(990) 
     +,KEQHE(990),KEQAL(990),KSUMN(990),KSUMP(990),KREACT(990),
     + KPREA(990),KN /DATOUT/SGEOM,FOUT /DATINI/RA,T0,W0 /KHIST/KHIST                                                
      COMMON/NPROL/NPROL /DATPAU/BONCUT(3) /IMOM/IMOM /R001/R001 
      COMMON/R003/R003 /R005/R005 /NREJ/REFR,NREJ /R1R2/E1E2(200),IR1R2                       
      COMMON/CSABS/CSABS,FIALP2 /XPARAM/XPARAM,FIALPH /ICHEN/ICHEN                                 
      COMMON/TEMP2/BONNE /EVA/PARALP,PARPRO /I1988/I1988                
      COMMON/MAIIPR/IPR /INFDIS/INFDIS,INFOUP(3) /INF/INFBIG,INFS0                                         
      COMMON/MPARIN/MPARIN /AN/AN /IDOPCS/IDOPCS                                            
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB /INFGEN/INFGEN(9)                                         
      COMMON/IWRI/IWRI /AUXIL/ICOU1,ICOU2 /INF000/INFGAS 
      COMMON/INF001/INFKAL /INF002/INFDOS /I1990/I1990 /INF003/INFDEN 
      COMMON/INF004/KHIST0 /INFBON/IBOND /BOND1/QBON(200,200,6)                                   
      COMMON/INF005/INFDM /SUM90/ER90,KER90 /INFSEP/KSEP(100,4),INFSEP,
     +JSEPM /LIB91/WINLIB(100,250),INFLIB /FICAP/FICAP,MZONA
      COMMON/EDEFF/Ed
      REAL*8 ITYP(3),ICS(4),ITYP1(3)                                    
      DIMENSION DREACT(990),M1(990),M5(990),MREACT(990)         
      DIMENSION CSNON(4),CSDNON(4),CSN(4),CSP(4),CSA(4)                 
      DIMENSION CSD(4),CST(4),CSH(4)                                    
          DATA ITYP/' NEUTRON','  PROTON','   ALPHA'/                              
          DATA ITYP1/'NEUTRON ','PROTON  ','  ALPHA '/                             
          DATA ICS/' BARASH ','GEOMETRY',' OPTIC  ','CHAT-JEE'/         
C  KPREA(i) is sum of non-equilinrium alpha-particles
C  KEQAL(i) is sum of non-eq and evaporated alphas
       DO 111 I=1,KN                                                    
  111  M5(I)=1                                                          
               X=FLOAT(KHIST)                                           
               SGX=SGEOM/X                                              
               SELA=SGX*FLOAT(NPROL)                                    
        WRITE(IPR,499)(INFGEN(I),I=1,9)                                 
        WRITE(IPR,500)Z,AN,ITYP(MPARIN),T0                              
        IF(KHIST0.NE.KHIST)WRITE(IPR,503)KHIST0
        WRITE(IPR,501)KHIST,SGEOM,SELA                                  
        XPARA9=1./XPARAM
        IF(INFBIG.EQ.0)WRITE(IPR,131)XPARA9,ED*1000.
        IF(INFBIG.EQ.0)GOTO 200                                         
      WRITE(IPR,444)R001                                                
      WRITE(IPR,555)R003                                                
      WRITE(IPR,888)R005                                                
      WRITE(IPR,889)NREJ,REFR                                           
      RCOU3=(FLOAT(ICOU2)/FLOAT(ICOU1))*100.
      WRITE(IPR,8890)RCOU3                                              
      WRITE(IPR,439)PARALP,PARPRO                                       
      IF(IMOM.EQ.1)WRITE(IPR,333)                                       
      IF(ICHEN.EQ.2)WRITE(IPR,334)                                      
      WRITE(IPR,887)I1988                                               
      WRITE(IPR,8888)I1990                                              
       XPAR22=1./XPARAM                                                 
      WRITE(IPR,10)FOUT,BONCUT(1),BONCUT(2),BONCUT(3),XPAR22,BONNE,KN
      WRITE(IPR,101)FIALP2,FICAP,MZONA
  200       R=1.                                                        
            REASUM=0.                                                   
            DISSUM=0.                                                   
        DO 11 I=3,4                                                     
        CSNON(I)=0.                                                     
   11   CSDNON(I)=0.                                                    
                DO 12 I=1,KN                                            
                REASUM=REASUM+FLOAT(KREACT(I))                          
   12           DISSUM=DISSUM+WDIS(I)                                   
*           print *,'!!!!!!!!',nprol,reasum
            If(MPARIN.le.2) CALL BARASH(0.,MPARIN,AN,T0,CSNONB)
            If(MPARIN.eq.3) CSNONB=SIGION(2, 4., 2., AN, Z,T0)
                      CSNON(1)=0.001*CSNONB                             
                      CSNON(2)=SGX*REASUM                               
       IF(IDOPCS.EQ.1)CSNON(3)=CSABS                                    
         IF(T0.LE.50.)CSNON(4)=CSCHAT(T0,MPARIN)                        
         IF(T0.LT.14.)CSNON(1)=CSNON(4)
         RR=DISSUM/REASUM                                               
                      CSDNON(1)=CSNON(1)*RR                             
                      CSDNON(2)=CSNON(2)*RR                             
       IF(IDOPCS.EQ.1)CSDNON(3)=CSNON(3)*RR                             
         IF(T0.LE.50.)CSDNON(4)=CSNON(4)*RR                             
C
       IF(INFGAS.EQ.0)GOTO 844
C Particle production
            CSNSUM=0.
            CSPSUM=0.
            CSASUM=0.
                CSDSUM=0.
                CSTSUM=0.
                CSHSUM=0.
                   CSPRE=0.
                   CSPREN=0.
                   CSPREP=0.
                   CSPREA=0.
                   CSEQUN=0.
                   CSEQUP=0.
        DO 848 I=1,KN
        RRR=FLOAT(KREACT(I))
        IF(INFBIG.EQ.0)RRR=1.
        CSNSUM=CSNSUM+FLOAT(KSUMN(I))*RRR
        CSPSUM=CSPSUM+FLOAT(KSUMP(I))*RRR
        CSASUM=CSASUM+FLOAT(KEQAL(I))*RRR
                  CSPRE=CSPRE+(FLOAT(KPREN(I))+FLOAT(KPREP(I)))*RRR
                  CSPREN=CSPREN+FLOAT(KPREN(I))*RRR
                  CSPREP=CSPREP+FLOAT(KPREP(I))*RRR
                  CSPREA=CSPREA+FLOAT(KPREA(I))*RRR
                  CSEQUN=CSEQUN+FLOAT(KSUMN(I)-KPREN(I))*RRR
                  CSEQUP=CSEQUP+FLOAT(KSUMP(I)-KPREP(I))*RRR
               CSDSUM=CSDSUM+FLOAT(KEQD(I))*RRR
               CSTSUM=CSTSUM+FLOAT(KEQT(I))*RRR
848            CSHSUM=CSHSUM+FLOAT(KEQHE(I))*RRR
C
C Non-equilibrium alpha-particle and triton production cross-section
C by F.Denisov, Mekhedov
C Multiplicity of cascade (non-equilibrium) nucleons RR0
C Note ! Denisov, Mekhedov contributuion is not added to the total 
C alpha-production (see CSAFD=0.0 below) Turn it on in case of necessity.
C
C Multiplicity of cascade (non-equilibrium) nucleons RR0
      RR0=CSPRE/REASUM
C   ----- alpha-particles -------
C RM0,CL0 are parameters
         RM0=0.06
C        CL0=0.12
C Fe56
         CL0=0.12*0.1*22.65
      VAL=0.21*Z+2.5                                                    
      EPSD=QBON(1,1,6)+VAL
      RMD=RM0*EPSD
C Number of alpha-clusters in nucleus
      CLD=CL0*(AN/4.)
C Knock-out probability for alpha-cluster
      WMD=(RR0/AN)**RMD
      CSAFD=CSNON(1)*CLD*WMD
* No contribution from Denisov, Mekhedov to total a-production
      CSAFD=0.0
C   ----- tritons -------
C RM0,CL0 are parameters
         RM0T=0.06
C Fe56
         CL0T=0.12*0.2*5.96*0.35
      VT=0.1*Z+0.8                                                      
      EPSDT=QBON(1,1,4)+VT
      RMDT=RM0T*EPSDT
C Number of t-clusters in nucleus
      CLDT=CL0T*(AN/3.)
C Knock-out probability for triton-cluster
      WMDT=(RR0/AN)**RMDT
      CSTFD=CSNON(1)*CLDT*WMDT
C   ----- He-3 -------
C RM0,CL0 are parameters
         RM0H=0.06
C Fe56
         CL0H=0.12*0.2*2.625*1.687
      VH=0.21*Z                                                      
      EPSDH=QBON(1,1,5)+VH
      RMDH=RM0H*EPSDH
C Number of He3-clusters in nucleus
      CLDH=CL0H*(AN/3.)
C Knock-out probability for He3-cluster
      WMDH=(RR0/AN)**RMDH
      CSHFD=CSNON(1)*CLDH*WMDH
C
C
           RR1=CSNSUM/REASUM
           RR2=CSPSUM/REASUM
           RR3=CSASUM/REASUM
           RR33=CSPREA/REASUM
               RR4=CSDSUM/REASUM
               RR5=CSTSUM/REASUM
               RR6=CSHSUM/REASUM
        DO 850 I=1,4
        CSN(I)=CSNON(I)*RR1
        CSP(I)=CSNON(I)*RR2
        CSA(I)=CSNON(I)*RR3
               CSD(I)=CSNON(I)*RR4
               CST(I)=CSNON(I)*RR5
850            CSH(I)=CSNON(I)*RR6
C
      IF(INFDM.EQ.0)GOTO 35
           CSPREA = CSNON(1)*RR33
         SUMD=CSA(1)+CSAFD
         SUMDT=CST(1)+CSTFD
         SUMDH=CSH(1)+CSHFD
         WRITE(10,101)FIALP2,FICAP,MZONA
         WRITE(10,851)RR0,RM0,CL0,CLD,CSAFD,CSA(1),SUMD,EPSD,QBON(1,1,6)
     +  ,VAL,CSPREA,CSA(1),SUMD,RR0,RM0T,CL0T,CLDT,CSTFD,CST(1),SUMDT,
     +   EPSDT,QBON(1,1,4),VT,RR0,RM0H,CL0H,CLDH,CSHFD,CSH(1),SUMDH,
     +   EPSDH,QBON(1,1,5),VH
C Auxiliary printing
        YY1=CSPREA*1000.
        YY2=CSA(1)*1000.
        YY3=SUMD*1000.
        WRITE(14,852)T0,YY1,YY2,YY3,Z,AN
C
         DO 34 I=1,4
         CST(I)=CST(I)+CSTFD
         CSH(I)=CSH(I)+CSHFD
   34    CSA(I)=CSA(I)+CSAFD
C
C Write average excitation energy of residuals and particle multiplicity
   35    ER90=ER90/FLOAT(KER90)
         RR900=RR1+RR2
         RR901=CSPREN/REASUM
         RR902=CSPREP/REASUM
         RR903=RR901+RR902
         RR904=CSEQUN/REASUM
         RR905=CSEQUP/REASUM
         RR906=RR904+RR905
         WRITE(10,19900)Z,AN,T0,ER90
         WRITE(10,19901)RR1,RR2,RR900,RR901,RR902,RR903,
     +   RR904,RR905,RR906,RR33,RR3
         WRITE(10,19902)
C
C Calculation of relative multiplicity for non-equiibrium particles
           IOUT90=1
           IF(IOUT90.EQ.1.AND.INFBIG.NE.0)CALL OUTTMP
C
C Calculation of cross-section for selected reactions
           IF(INFSEP.NE.0) CALL OUTSEP(CSNON,REASUM)
C
C Formation of library
           IF(INFLIB.NE.0) CALL LIBOUT(CSNON,REASUM)
C
       IF(IWRI.NE.0.AND.INFDOS.EQ.1)WRITE(IWRI,1110)                    
       IF(IWRI.NE.0)WRITE(IWRI,1120)INFDEN,IMOM,IBOND,XPARA9,INFDM      
       IF(IWRI.NE.0.AND.INFKAL.EQ.1)WRITE(IWRI,1100)                    
       IF(IWRI.NE.0)WRITE(IWRI,3100)T0,ITYP1(MPARIN),                   
     +     (CSNON(I),I=1,4),Z,AN,RR,(CSDNON(I),I=1,4),                  
     +   (CSN(I),I=1,4),(CSP(I),I=1,4),(CSA(I),I=1,4),
     +   (CSD(I),I=1,4),(CST(I),I=1,4),(CSH(I),I=1,4)
       IF(INFDOS.EQ.1)WRITE(IPR,1110)
       WRITE(IPR,1120)INFDEN,IMOM,IBOND,XPARA9,INFDM
       IF(INFKAL.EQ.1)WRITE(IPR,1200)
       WRITE(IPR,5100)R,(CSNON(I),I=1,4),RR,(CSDNON(I),I=1,4),          
     +   (CSN(I),I=1,4),(CSP(I),I=1,4),(CSA(I),I=1,4),
     +   (CSD(I),I=1,4),(CST(I),I=1,4),(CSH(I),I=1,4)
       GOTO 855
844    IF(IWRI.NE.0.AND.INFDOS.EQ.1)WRITE(IWRI,1110)                    
       IF(IWRI.NE.0)WRITE(IWRI,1120)INFDEN,IMOM,IBOND,XPARA9,INFDM      
       IF(IWRI.NE.0.AND.INFKAL.EQ.1)WRITE(IWRI,1100)                    
       IF(IWRI.NE.0)WRITE(IWRI,310)T0,                                  
     +   R,(CSNON(I),I=1,4),Z,AN,RR,(CSDNON(I),I=1,4)                   
       IF(INFDOS.EQ.1)WRITE(IPR,1110)
       WRITE(IPR,1120)INFDEN,IMOM,IBOND,XPARA9,INFDM
       IF(INFKAL.EQ.1)WRITE(IPR,1200)
       WRITE(IPR,510)R,(CSNON(I),I=1,4),RR,(CSDNON(I),I=1,4)            
C                                                                       
  855   IF(INFBIG.LT.2.AND.INFDIS.NE.1)RETURN                          
C                                                                       
       IF(T0.LT.14..AND.INFS0.EQ.1)INFS0=4                              
       IF(T0.GT.50..AND.INFS0.EQ.4)INFS0=1                              
       IF(INFS0.LT.1.AND.INFS0.GT.4)INFS0=1                             
       SGX0=CSNON(INFS0)/REASUM                                         
C                                                                       
         IF(INFBIG.NE.3) GOTO 105                                       
C                                                                       
       WRITE(IPR,20)ICS(INFS0)                                          
       DO 3 I=1,KN                                                       
        SREACT=SGX0*FLOAT(KREACT(I))                                    
        SDISP=SGX0*WDIS(I)                                              
    3  WRITE(IPR,30)KPREN(I),KPREP(I),KSUMN(I),KSUMP(I),KEQAL(I),      
     + KEQD(I),KEQT(I),KEQHE(I),SREACT,SDISP                           
       GOTO 107                                                        
C                                                                       
  105    IF(INFBIG.NE.2) GOTO 120                                       
C                                                                       
  107  M8=0                                                             
       DO 70 I=1,KN                                                     
         KEY=0                                                          
         IF(M5(I).NE.1)GOTO 70                                          
       DO 60 J=1,KN                                                     
         IF(J.EQ.I)GOTO 60                                              
       IF(M5(J).NE.1)GOTO 60                                            
         IF(KSUMN(I).NE.KSUMN(J))GOTO 60                                
         IF(KSUMP(I).NE.KSUMP(J))GOTO 60                                
         IF(KEQAL(I).NE.KEQAL(J))GOTO 60                                
         IF(KEQD(I).NE.KEQD(J))GOTO 60                                  
         IF(KEQT(I).NE.KEQT(J))GOTO 60                                  
         IF(KEQHE(I).NE.KEQHE(J))GOTO 60                                
       IF(KEY.NE.0)GOTO 56                                              
        KEY=1                                                           
        M8=M8+1                                                         
        M1(M8)=I                                                        
      MREACT(M8)=KREACT(I)                                              
      DREACT(M8)=WDIS(I)                                                
   56 MREACT(M8)=MREACT(M8)+KREACT(J)                                   
      DREACT(M8)=DREACT(M8)+WDIS(J)                                     
        M5(J)=-1                                                        
   60   M5(I)=-1                                                        
C                                                                       
   70 IF(M8.EQ.0)GOTO 120                                               
      WRITE(IPR,23)ICS(INFS0)                                           
      DO 81 M9=1,M8                                                     
        M10=M1(M9)                                                      
        SREACT=SGX0*FLOAT(MREACT(M9))                                   
        SDISP=SGX0*DREACT(M9)                                           
   81   WRITE(IPR,32)KSUMN(M10),KSUMP(M10),KEQAL(M10),                  
     +  KEQD(M10),KEQT(M10),KEQHE(M10),SREACT,SDISP                     
C                                                                       
  120    IF(INFDIS.NE.1) RETURN                                         
C Particle spectra printing
      WRITE(IPR,777) 
      IF(INFOUP(1).EQ.1)  CALL PRISPE(SGX0,1)
      IF(INFOUP(2).EQ.1)  CALL PRISPE(SGX0,2)
      IF(INFOUP(3).EQ.1)  CALL PRISPE(SGX0,3)
C Recoil spectrum printing
      CALL PRIREC(SGX0)
      RETURN                                                            
C    
C
C                                                                   
   10 FORMAT(1X,'Divisions of free path ',F5.1/1X,'Cut off energy ',
     +'(neutrons)=',F7.2/1X,'Cut off energy (protons)=',F7.2/                           
     +1X,'Cut off energy (alphas)=',F7.2/1X,'Level density parameter',
     +'  A /',E12.5/1X,'BONNE=',F8.4/1X,' Number of reaction types ',I4)
   20 FORMAT(1X,' Excitation functions for all reactions  ( CSnon - ',
     +A8,' ) :'/   
     +1X,' N(PRE) P(PRE) N(TOT) P(TOT)  ALFA   DEUT   TRIT   HE3 ',
     +'  CEEHE   CE.CM.'/1X,78('-'))                      
   23 FORMAT(/1X,'Lumped cross-sections ( CSnon - ',A8,' ) :'/     
     +1X,70('-')/1X,' N(TOT) P(TOT)  ALFA   DEUT   ',                   
     +'TRIT   HE3   CR.SECT   DISPL.CR.S.'/1X,70('-'))                      
   30 FORMAT(1X,8(I4,3X),E10.4,1X,E10.4)                                
   32 FORMAT(1X,6(I4,3X),E10.4,1X,E10.4)                                
   40 FORMAT(1X,'Elastic cross-section=',E10.4,' Elastic displacement',   
     +' cross-section is not calculated'/1X,'Reaction cross-section ',
     +'( by SGEOM )= ',E10.4/1X,'Total displacement cross-section ',
     +'for reactions ( by SGEOM )= ',1X,E10.4)                                                         
   41 FORMAT(1X,'Reaction cross-section ( OPTIC )=',1X,E10.4/        
     +1X,'Total displacement cross-section for reactions ( OPTIC )=',      
     +1X,E10.4)                                                         
  101 FORMAT(/1X,'Relative number of alpha-clusters ',F8.4/1x, 
     +'Probability of pick-up of t or He-3     ',F8.4/1x,'Alpha-parti',
     +'cles exist beginning from ',i2,' zone')
  131 FORMAT(1X,'Level density parameter = A/',F4.1,3x,'Ed =',f5.1,
     +' eV')
  310 FORMAT(1X,F8.2,5X,F3.1,3X,4(2X,E10.4)/1X,2F4.0,1X,E10.4,4(2X,
     +E10.4)/' ',70('-'))            
  333 FORMAT(1X,20X,'Limitation on orbital momenta is applied')   
  334 FORMAT(1X,20X,'   Correction for relative velocity')    
  439 FORMAT(1X,'NORMALIZATION OF DOSTROVSKY CROSS-SECTIONS (EVAPAR) ',        
     +'FOR ALPHAS AND PROTONS :'/1X,' PARALP=',F7.2,' PARPRO=',F7.2)          
  444 FORMAT(1X,' LIMITATION RULE WAS APPLIED ',E12.5,' TIMES')      
  499 FORMAT(1X,9A8)                                                    
  500 FORMAT(1X,5X,'Nucleus',2F6.1/1X,'Incident particle:',A8,2X,
     +'with energy =',F6.1,' MeV')
  501 FORMAT(1X,'Events ',I8/1X,'Geometry cross-section=',F7.3,' b',
     +1X,'Elastic cross-section=',F7.3,' b')   
  503 FORMAT(1X,'KHIST',I6,' can not be treated: arrays of C-blocks ',
     +'MASOUT are overfilled')            
  510 FORMAT(' ',70('-')/1X,'CR.SECT.',3X,'[BARNS]',5X,'BARASH   ',
     +'  GEOMETRY  ',' OPTIC(SCR) ',' CHATTERJEE'/1X,' CSNON  ',5X,F3.1
     +,3X,4(2X,E10.4)/1X,' CSDNON ',1X,E10.4,4(2X,E10.4)/' ',70('-'))       
  555 FORMAT(1X,' REFLECTION TOOK PLACE ',E12.5,' TIMES')             
  667 FORMAT(1X,10(E10.3))                                              
  777 FORMAT(//' GRAPHS '///' Energy distributions :  Energy(i-1) ',
     +'to E(i) -- Function(i)'/' Angular distributions:  Angle(i) ',
     +'to Angle(i+1) -- Function(i)')
  851 FORMAT(/1X,' Alpha-particles :'/1X,'RR0=',F6.1,' M0=',F5.3,' N0=',
     +F5.3,' CLD=',F5.1,' CSD=',F5.3,' CSA=',F5.3,' SUM=',F5.3/1X,
     +' EPSD =',F7.1,' QBON(1,1,6)=',F7.1,' VAL=',F7.1/1X,F9.5,
     +' Production cross-sect for non-eq alphas [b] ',
     +'(CSnon-Barashenkov)'/1X,F9.5,' Total product cross-secti',
     +'on for alphas without Denisov-Mekhedov correction (CSnon-B)'
     +/1X,F9.5,' Total product cross-section for a-particles ',
     +' + D-M correction (CSnon-B)'//1X,'   Tritons    :'/1X,'RR0=',
     +F6.1,' M0=',F5.3,' N0=',F5.3,' CLD=',F5.1,' CSD=',F5.3,' CST=',
     +F5.3,' SUM=',F5.3/1X,' EPSD =',F7.1,' QBON(1,1,4)=',F7.1,' VT ='
     +,F7.1//1X,'   He-3       :'/1X,'RR0=',F6.1,' M0=',F5.3,' N0=',
     +F5.3,' CLD=',F5.1,' CSD=',F5.3,' CSH=',F5.3,' SUM=',F5.3/1X,
     +' EPSD =',F7.1,' QBON(1,1,5)=',F7.1,' VH =',F7.1)
  852 FORMAT(1x,f8.2,3G12.5,2F6.1,'   T0, Alpha(mbarn):Pre, Pre+',
     +'Eq, Pre+Eq+Denisov')
  887 FORMAT(1X,' DIMENSION FOR AT WAS EXCEEDED ',I8,' TIMES')  
  888 FORMAT(1X,' PAULI PRINCIPLE WAS APPLIED ',E12.5,' TIMES')             
  889 FORMAT(1X,' REJECTED EVENTS ',I7,',MAXIMAL NUMBER OF',       
     +' REFLECTIONS',F7.1)                                               
 1100 FORMAT(1X,' Angular distributions have been calculated by ',
     * 'Kalbach, Mann formulas')
 1110 FORMAT(1X,' Coulomb potential for inverse reactions:  VP=0.1*',
     +'Z+0.8, VA=2.*VP')
 1120 FORMAT(1X,'INFDEN=',I3,' IMOM=',I3,' IBOND=',I3,' XPARDE =',F5.1,
     + ' INFDM=',I3)
 1200 FORMAT(1X,70('#')/1X,' Angular distributions have been calcul',
     + 'ated by Kalbach, Mann formulas'/1X,70('#'))
 3100 FORMAT(1X,F8.2,1X,A8,2X,4(2X,E10.4)/1X,2F4.0,1X,E10.4,4(2X,E10.4)
     +/1X,' NEUTRON PRODUCTION',4(2X,E10.4)/1X,'  PROTON PRODUCTION',
     +4(2X,E10.4)/1X,'   ALPHA PRODUCTION',4(2X,E10.4)
     +/1X,'     H-2 PRODUCTION',4(2X,E10.4)/1X,'     H-3 PRODUCTION',
     +4(2X,E10.4)/1X,'    HE-3 PRODUCTION',4(2X,E10.4)/' ',70('-'))
 5100 FORMAT(' ',70('-')/1X,'CR.SECT.',3X,'[BARNS]',5X,'BARASH   ',
     +'  GEOMETRY  ',' OPTIC(SCR) ',' CHATTERJEE'/1X,' CSNON  ',5X,
     +F3.1,3X,4(2X,E10.4)/1X,' CSDNON ',1X,E10.4,4(2X,E10.4)                    
     +/1X,' NEUTRON PRODUCTION',4(2X,E10.4)/1X,'  PROTON PRODUCTION',
     +4(2X,E10.4)/1X,'   ALPHA PRODUCTION',4(2X,E10.4)/1X,'     H-',
     +'2 PRODUCTION',4(2X,E10.4)/1X,'     H-3 PRODUCTION',4(2X,E10.4)
     +/1X,'    HE-3 PRODUCTION',4(2X,E10.4)/' ',70('-'))
 8890 FORMAT(1X,' PROBABILITY TO OVERLOAD ENERGY ( > 500 )',F6.0,' %')
 8888 FORMAT(1X,' CURRENT CHARGE WAS LOWER THAN ',
     +'PERMISSIBLE ',I8,' TIMES')  
C T(X) is the sum for nucleons in X-process
19900 FORMAT(1X,65('-')/' Task'/1X,'Z= ',F6.1,' A= ',F6.1,' T0= ',
     +F6.1//' Average energy of excitation after cascade stage =',
     +f9.3,' MeV'/) 
19901  FORMAT(1X,'Particle multiplicity:'/1X,
     + ' N(SUM) P(SUM) T(SUM) N(PRE) P(PRE) T(PRE) ',
     + 'N(EQU) P(EQU) T(EQU) A(PRE) A(SUM without D-M)'
     +  /1X,11F7.3)
19902 FORMAT(/34('='),'end',34('='))
      END                                                               
************************************************************************
*                 SUBROUTINE OUTSEP                                    *
************************************************************************
      SUBROUTINE OUTSEP(CSNON,RRR)                                      
      REAL*8 ICS(4)                                                     
      COMMON/MAIIPR/IPR /IWRI/IWRI /INFSEP/KSEP(100,4),INFSEP,JSEPM                            
      COMMON/MPARIN/MPARIN /DATINI/RAAAAA,T0,W0 
      COMMON/SEPSEP/RSEP2(100,2),JSEPM2 /INF/INFBIG,INFS0                                           
      DIMENSION CSNON(4)
      DATA ICS/' BARASH ','GEOMETRY',' OPTIC  ','CHAT-JEE'/             
      DATA RN,RP,RA/1HN,1HP,1HA/
      REASUM=RRR
C Define CSnon
            ICSN=INFS0
        WRITE(IPR,900)ICS(ICSN)
        IF(IWRI.NE.0)WRITE(IWRI,900)ICS(ICSN)
        RI=RN
        IF(MPARIN.EQ.2)RI=RP
        IF(MPARIN.EQ.3)RI=RA
C Cross-section in mb
      DO 100 J=1,JSEPM
      CS=1000.*FLOAT(KSEP(J,4))*CSNON(ICSN)/REASUM
      IF(INFSEP.EQ.1)
     CWRITE(IPR,1000)RI,KSEP(J,1),KSEP(J,2),KSEP(J,3),CS
      IF(IWRI.NE.0.AND.INFSEP.EQ.1)
     CWRITE(IWRI,1000)RI,KSEP(J,1),KSEP(J,2),KSEP(J,3),CS
      IF(INFSEP.EQ.2)
     CWRITE(IPR,2000)RI,KSEP(J,1),KSEP(J,2),KSEP(J,3),CS,RSEP2(J,1),
     C               RSEP2(J,2)
      IF(IWRI.NE.0.AND.INFSEP.EQ.2)
     CWRITE(IWRI,2000)RI,KSEP(J,1),KSEP(J,2),KSEP(J,3),CS,RSEP2(J,1),
     C               RSEP2(J,2)
 100  CONTINUE
 900  FORMAT(1X,'Cross-section for selected reactions (CSnon:',A8,')')
1000  FORMAT(1X,'( ',A1,',',I2,'n',I2,'p',I2,'a )',G12.5,' mb')
2000  FORMAT(1X,'( ',A1,',',I2,'n',I2,'p',I2,'a )',G12.5,' mb',
     C '   Residual  ',F6.1,F7.1)
      RETURN
      END
************************************************************************
*                 SUBROUTINE OUTTMP                                    *
************************************************************************
      SUBROUTINE OUTTMP
C Relative multiplicity of pre-equlibrium (cascade) particles 
      REAL*8 R1(2)
      COMMON/MASOUT/WDIS(990),KPREN(990),KPREP(990),KEQD(990),KEQT(990) 
     *,KEQHE(990),KEQAL(990),KSUMN(990),KSUMP(990),KREACT(990),
     * KPREA(990),KN /MAIIPR/IPR  /IWRI/IWRI                                                  
      DIMENSION TOT(4)
      DATA R1/'NEUTRONS',' PROTONS'/
      IF(IWRI.NE.0)WRITE(IWRI,1000)
      WRITE(IPR,1000)
                DO 18 I0=1,4
18              TOT(I0)=0.
      DO 400 J1=1,2
50       DO 100 I=1,KN
            RRR=FLOAT(KREACT(I))
         GOTO(81,82),J1
81          SUMX=FLOAT(KSUMN(I))
            PREX=FLOAT(KPREN(I))
            GOTO 90
82          SUMX=FLOAT(KSUMP(I))
            PREX=FLOAT(KPREP(I))
90    TOT(1)=TOT(1)+SUMX*RRR
         IF(PREX.EQ.0)GOTO 100
      TOT(2)=TOT(2)+RRR*PREX
      IF(PREX.GE.2.)TOT(3)=TOT(3)+RRR*(PREX-1.)
      IF(PREX.GE.3.)TOT(4)=TOT(4)+RRR*(PREX-2.)
100      CONTINUE
       PRETOT=100.*TOT(2)/TOT(1)
       PREGE2=100.*TOT(3)/TOT(1)
       PREGE3=100.*TOT(4)/TOT(1)
       IF(IWRI.NE.0)WRITE(IWRI,2000)R1(J1),PRETOT,PREGE2,PREGE3
400    WRITE(IPR,2000)R1(J1),PRETOT,PREGE2,PREGE3
1000   FORMAT(1X,'Multiplicity of precompound particles of this type ',
     * 'to'/1X,16X,'all partiles of this type in %'/1X,8X,
     * 7X,'TOTAL',14X,'>2',14X,'>3')
2000   FORMAT(1X,A8,3G16.2)
       RETURN
       END
************************************************************************
*                 SUBROUTINE PAULI                                     *
************************************************************************
      SUBROUTINE PAULI(TB1,TP1,IKS)                                     
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/SCIMEM/WPM,PXM,PYM,PZM,PM,TM,EM,XM,YM,ZM,RM,JINM,MM        
      COMMON/NDIM/NPAR  /MEMORY/U(11,20),MU(2,20)                                   
      COMMON/ACTSCI/PIN1,PIN2,PIN3,WPX,RK3,RK4,GAMMA,SK2,VC2,VCX,       
     *VCY,VCZ,MPX /DATPAU/BONCUT(3) /TFERMI/TF(34,4)
      COMMON/JACT/JACT /R005/R005 /TYPACT/L,L7
      DIMENSION TT(2)                                                   
      IF(TB1-TF(JIN,M))10,20,20                                           
   10 IKS=1                                                             
      IF(L7.EQ.1) CALL MEMDEC(2)
      IF(IGEN.EQ.1)RETURN                                               
      R005=R005+1.                                                      
      RETURN                                                            
   20 IF(TP1-TF(JIN,MPX))10,30,30                                           
   30 TT(1)=TF(JIN,M)+BONCUT(M)                                           
      TT(2)=TF(JIN,MPX)+BONCUT(MPX)                                         
C
C
      IF(TB1.GT.TT(1))GOTO 50                                           
C TB1 < TT(1)
            IF(M.EQ.2)              CALL PROZR(TB1,TT(1),JIN,KEY,M)
            IF(M.EQ.2.AND.KEY.EQ.1)   GOTO 50
      IF(TP1.GT.TT(2))GOTO 60                                           
C TP1 < TT(2)
            IF(MPX.EQ.2)            CALL PROZR(TP1,TT(2),JIN,KEY,MPX)
            IF(MPX.EQ.2.AND.KEY.EQ.1) GOTO 60
           IGEN=2                                                       
           CALL CHECK1(1.,TB1,WP,IGEN,M)                                
           IF(IGEN.EQ.1)GOTO 10                                         
           IGEN=2                                                       
           CALL CHECK1(-1.,TP1,WPX,IGEN,MPX)                            
           IF(IGEN.EQ.1)GOTO 10                                         
33    IF(NPAR.GT.0)GOTO 40                                              
      IKS=-1                                                            
      JACT=1                                                            
      RETURN                                                            
   40 IKS=0                                                             
      RETURN                                                            
   50 IF(TP1.GT.TT(2))GOTO 70                                           
C TP1 < TT(2)
            IF(MPX.EQ.2)              CALL PROZR(TP1,TT(2),JIN,KEY,MPX)
            IF(MPX.EQ.2.AND.KEY.EQ.1) GOTO 70
           IGEN=2                                                       
           CALL CHECK1(-1.,TP1,WPX,IGEN,MPX)                            
           IF(IGEN.EQ.1)GOTO 10                                         
      IGEN=2                                                            
      CALL SCILSK(0,1.,TB1,WP,IGEN,M)                                   
      IF(IGEN.EQ.1)GOTO 10                                              
      IKS=3                                                             
      JACT=1                                                            
      RETURN                                                            
   60      IGEN=2                                                       
           CALL CHECK1(1.,TB1,WP,IGEN,M)                                
           IF(IGEN.EQ.1)GOTO 10                                         
      IGEN=2                                                            
      CALL SCILSK(0,-1.,TP1,WPX,IGEN,MPX)                               
      IF(IGEN.EQ.1)GOTO 10                                              
      IKS=3                                                             
      JACT=1                                                            
      RETURN                                                            
   70      IGEN=2                                                       
           CALL CHECK1(-1.,TP1,WPX,IGEN,MPX)                            
           IF(IGEN.EQ.1)GOTO 10                                         
      IGEN=2                                                            
      CALL SCILSK(0,1.,TB1,WP,IGEN,M)                                   
      IF(IGEN.EQ.1)GOTO 10                                              
      IGEN=2                                                            
      CALL SCILSK(1,-1.,TP1,WPX,IGEN,MPX)                               
      IF(IGEN.EQ.1)GOTO 10                                              
      CALL MEMIN                                                        
      IKS=3                                                             
      JACT=1                                                            
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE PICKUP                                    *
************************************************************************
      SUBROUTINE PICKUP(IKS)
C Energy conservation
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/PARTNR/PPX,PPY,PPZ,PP,MX                                   
      COMMON/NDIM/NPAR                                                  
      COMMON/DATPAU/BONCUT(3)                                           
      COMMON/TFERMI/TF(34,4)
      COMMON/JACT/JACT                                                  
      COMMON/R005/R005                                                  
      DIMENSION TT(2)                                                   
C
      T2 = (PP**2)/(2.*WM(MX))
C
C Alpha-particle characteristics
      WP1 = WM(3)
      M1 = 3
C Auxiliary values
         PX11 = PX + PPX
         PY11 = PY + PPY
         PZ11 = PZ + PPZ
         P11 =  SQRT(PX11**2+PY11**2+PZ11**2)
      T1  = T + T2 
      P1  = SQRT(T1**2+2.*WP1*T1)                                              
      PX1 = PX11*(P1/P11)
      PY1 = PY11*(P1/P11)
      PZ1 = PZ11*(P1/P11)
      E1=T1+WP1                                                            
C
      TB1 = T1
      IF(TB1-TF(JIN,M1))10,20,20                                           
   10 IKS=1                                                             
      RETURN                                                            
   20 TT(1)=TF(JIN,M1)+BONCUT(M1)                                           
      IF(TB1.GT.TT(1))GOTO 50                                           
C TB1 < TT(1)
      IF(NPAR.GT.0)GOTO 40                                              
      IKS=-1                                                            
      JACT=1                                                            
      RETURN                                                            
   40 IKS=0                                                             
      RETURN                                                            
   50 CONTINUE
C Prohibition on angular momentum
           IGEN=2                                                       
      RORM=ORBIT(PX1,PY1,PZ1,X,Y,Z)                                     
      CALL QUES(RORM,T1,WP1,JIN,M1,IGEN)                                 
           IF(IGEN.EQ.1)GOTO 10                                         
C Creation of alpha-particle
      WP = WP1 
      PX = PX1 
      PY = PY1 
      PZ = PZ1 
      P  = P1
      T  = T1
      E  = E1                                                            
      M  = M1
      IKS=3                                                             
      JACT=1                                                            
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE PPDRAW                                    *
************************************************************************
      SUBROUTINE PPDRAW(QCOS,FI)                                        
      COMMON/URAND1/IYG                                                 
      CC=RANDOMG(0)                                                     
      QCOS=1.-2.*CC                                                     
      CC=RANDOMG(0)                                                     
      FI=6.2831852*CC                                                   
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE PRECAM                                    *
************************************************************************
      SUBROUTINE PRECAM                                                 
C Binding energy according to Cameron (Barashenkov, Tonnev, 1972,
C pp.418-419)                                                
       COMMON/AN/AN /BOND1/QBON(200,200,6)                                     
       COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                        
       COMMON/MPARIN/MPARIN /INFBON/IBOND                                              
       COMMON/DATCAM/CAMN(130),CAMP(130),MAXN,MAXP                      
       COMMON/MAIIPR/IPR /MAX/MAXNEU,MAXPRO                                         
       REAL*8 RMAS(6),RAT,IP90(6)                                                 
       DIMENSION ATO(200,200),RMASM(6),NN(6),NP(6)                    
       DATA RMAS/ 0.008 665 27, 0.007 825 22, 0.014 102 22,              
     c 0.016 049 71, 0.016 029 68, 0.002 603 3/                          
       DATA RAT/931.5016/                                                
C RMAS is mass defect in at. units             
C                                                                       
C RMAS:  1     2     3     4     5     6                                
C--------N-----P-----D-----T---HE-3----A--  particle
C  J     1     2     3     4     5     6                                
C------------------------------------------                             
C  NN    1     0     1     2     1     2                                
C  NP    0     1     1     1     2     2                                
C------------------------------------------                             
      DATA NN/ 1, 0, 1, 2, 1, 2/,NP/ 0, 3*1, 2*2/                       
      DATA IP90/8H NEUTRON,8H  PROTON,8HDEUTERON,8H  TRITON,8H    HE-3, 
     c8H   ALPHA/
C                                                                       
C MAXN/MAXP is the dimension of CAMN/CAMP array (see corresp BLOCK DATA),       
C which is equal to maximal permissible number of neutrons/prootons in
C target nucleus
C                                                                       
C MAXNEU and MAXPRO are dimensions of QBON array
      MAXN=130                                                          
      MAXP=130                                                          
C L11N/L11P is minimal number of neutrons/protons in nucleus, for which       
C corrections to Cameron formula are available
        L11N=1                                                         
        L11P=1                                                         
        IF(MAXN.LT.200.AND.MAXP.LT.200)GOTO 7                           
        WRITE(IPR,700)MAXN,MAXP                                         
        STOP                                                            
7         IZNUCL=Z                                                       
          INNUCL=AN-Z                                                    
      IF(MPARIN.EQ.1)INNUCL=INNUCL+1                                    
      IF(MPARIN.EQ.2)IZNUCL=IZNUCL+1                                    
           IF(MPARIN.EQ.3)INNUCL=INNUCL+2
           IF(MPARIN.EQ.3)IZNUCL=IZNUCL+2
         IF(INNUCL.LE.MAXN)GOTO 10                                      
         WRITE(IPR,800)INNUCL,MAXN                                      
      STOP                                                              
10       IF(IZNUCL.LE.MAXP)GOTO 20                                        
         WRITE(IPR,900)IZNUCL,MAXP                                      
         STOP                                                              
C  INNUCL-L11N is the number of neutrons emitted, +1 : array dimension
C  ATO is more than this amount on 1,i.e. ATO(1,1) means 0 emitted
20      DO 80 I=L11N,INNUCL                                             
        RN=FLOAT(I)                                                     
            DO 70 J=L11P,IZNUCL                                         
            RZ=FLOAT(J)                                                 
            INN1=INNUCL-I+1                                             
            IZN1=IZNUCL-J+1                                             
            IF(INN1.LE.200.AND.IZN1.LE.200)GOTO 65                      
            WRITE(IPR,1000)INN1,IZN1                                    
              STOP                                                      
65          ATO(INN1,IZN1)=CAMERO(RN,RZ)+CAMN(I)+CAMP(J)                
70          CONTINUE                                                    
80       CONTINUE                                                       
            LMAXN=(INNUCL-L11N+1)-2                                     
            LMAXP=(IZNUCL-L11P+1)-2                                     
       MAXNEU=LMAXN                                                     
       MAXPRO=LMAXP                                                     
          IF(LMAXN.GT.5.AND.LMAXP.GT.5)GOTO 90                          
          WRITE(IPR,1100)LMAXN,LMAXP                                    
              STOP                                                      
90        DO 92 I=1,6                                                   
92        RMASM(I)=RAT*RMAS(I)                                          
            DO 200 IN=1,LMAXN                                           
            DO 100 IZ=1,LMAXP                                           
               AT1=ATO(IN,IZ)                                           
            DO 95 NUCL=1,6                                              
               AT2=ATO(IN+NN(NUCL),IZ+NP(NUCL))                         
95             QBON(IN,IZ,NUCL)=AT2+RMASM(NUCL)-AT1                     
100         CONTINUE                                                    
200         CONTINUE                                                    
            IF(IBOND.GT.0)RETURN                                        
C TEST
            IF(IBOND.EQ.-3)RETURN                                       
          WRITE(1,499)
          WRITE(6,499)
          WRITE(8,499)
            INM=MIN0(12,MAXNEU)
            IZM=MIN0(12,MAXPRO)
          DO 300 NUCL=1,6                                               
            WRITE(1,500)IP90(NUCL)
            WRITE(6,500)IP90(NUCL)
            WRITE(8,500)IP90(NUCL)
          DO 300 IZ=1,IZM                                               
            WRITE(1,600)IZ,(QBON(IN,IZ,NUCL),IN=1,INM)                  
            WRITE(6,600)IZ,(QBON(IN,IZ,NUCL),IN=1,INM)                  
300         WRITE(8,600)IZ,(QBON(IN,IZ,NUCL),IN=1,INM)                  
            STOP                                                        
499   FORMAT(1X,'TEST FOR BINDING ENERGIES'/
     c       1X,'CAMERON FORMULAS FOR ALL NUCLIDES'/1X,72(1H-))
500   FORMAT(/1X,A8/1X,'IZ   IN-----> NEUTRON NUMBER DECREASED')
600   FORMAT(1X,I2,12F6.1)
700   FORMAT(1X,'ERROR IN PRECAM: DIMENSION OF QBON, ATO, CAMN/CAMP',
     c' ARE NOT CONSISTENT. CHANGE QBON AND ATO DIMENSIONS IN ALL CODE')
800   FORMAT(1X,'ERROR IN PRECAM: PERMISSIBLE AMOUNT IS EXCEEDED FOR:'/ 
     c1X,5X,I5,' > ',I5/                                                
     c1X,'NEUTRONS IN TARGET NUCLEUS. ADD NEW CAMN AND CAMP DATA (SEE'/
     c1X,'CORRESPONDING BLOCK DATA) AND CHANGE DIMENSION OF THESE '/
     c1X,'ARRAYS IN ALL CODE AND MAXN AND MAXP VALUES IN PRECAM (!)')            
900   FORMAT(1X,'ERROR IN PRECAM: PERMISSIBLE AMOUNT IS EXCEEDED FOR:'/ 
     c1X,5X,I5,' > ',I5/                                                
     c1X,'PROTONS IN TARGET NUCLEUS. ADD NEW CAMN AND CAMP DATA (SEE'/ 
     c1X,'CORRESPONDING BLOCK DATA) AND CHANGE DIMENSION OF THESE '/ 
     c1X,'ARRAYS IN ALL CODE AND MAXN AND MAXP VALUES IN PRECAM  (!)')            
1000  FORMAT(1X,'ERROR IN PRECAM: DIMENSION OF ARRAY EXCEEDED    '/1X,  
     c' ATO  INNUCL-I+1=',I5,' > 200    IZNUCL-J+1=',I5,' > 200')      
1100  FORMAT(/1X,'****** SUBROUTINE PRECAM *******'/1X,' TOO SMALL',  
     c' NUMBER OF CASCADES WILL BE SIMULATED  ',I5,' AND ',I5//
     c' CALL AUTHORS OF DISCA  (AND LOOK IN THEIR EYES).'//)
      END                                                       
************************************************************************
*                 SUBROUTINE PRELYM                                    *
************************************************************************
      SUBROUTINE PRELYM                                                 
C CALCULATION OF BINDING ENERGIES USING MASS TABLE AND MSL-FORMULA
C FOR NEUTRONS, PROTONS, DEUTERONS AND ALPHA-PARTICLES FOR RESIDUAL
C NUCLEI FORMED AFTER ESCAPE OF NOT MORE THAN 9 PROTONS AND 22 NEUTRONS.
C FOR OTHER NUCLEI THE CALCUALTION IS PERFORMD USING CAMERON FORMULA
C (SEE SUBR.PRECAM)
      COMMON/AN/AN /BOND1/QBON(200,200,6)                                     
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                        
      COMMON/MPARIN/MPARIN /MAIIPR/IPR                                                
      COMMON/MAX/MAXNEU,MAXPRO /INFBON/IBOND                                              
      COMMON/LYM1/BE(11,24,4),SYMB(11,24),PAIR(11,24),SYMBP(11,24)      
      COMMON/SF/M3,KPLT /LYM2/ILYM                                                  
      COMMON/LYM3/PAIRP(11,24),PAIRE(11,24),ILYM2                       
      REAL*8 IP90(6)                                                    
      DATA IP90/8H NEUTRON,8H  PROTON,8HDEUTERON,8H  TRITON,8H    HE-3, 
     c8H   ALPHA/
             NZ=MIN0(9,MAXPRO)
             NA=MIN0(22,MAXNEU)
         AT=AN
         ZT=Z
           AP=1.
           ZP=0.
             IF(MPARIN.EQ.2)ZP=1.
             IF(MPARIN.EQ.3)THEN 
                            ZP=2.
                            AP=4.
                            ENDIF
       ZEE=ZP+ZT
       AMASS=AP+AT
            MC=10
            MP=3
            QVAL=0.
       ILYM=0
       ILYM2=0
       KPLT=0
       M3=4
       CALL LYMASS(ZEE,AMASS,NZ,NA,MC,MP,AP,AT,ZP,ZT,QVAL)              
C  BE(11,24,K)   K=1-N, 2-P, 3-A, 4-D                                   
       DO 200 NUCL=1,6                                                  
           IF(NUCL.EQ.1.OR.NUCL.EQ.2)KPART=NUCL                         
           IF(NUCL.EQ.3)KPART=4                                         
           IF(NUCL.EQ.4.OR.NUCL.EQ.5)GOTO 200                           
           IF(NUCL.EQ.6)KPART=3                                         
       DO 100 IZ=1,NZ                                                   
       DO 100 IN=1,NA                                                   
100        QBON(IN,IZ,NUCL)=BE(IZ,IN,KPART)
200    CONTINUE                                                         
       IF(IBOND.GT.0)RETURN                                             
C TEST
          WRITE(1,499)NZ,NA
          WRITE(6,499)NZ,NA
          WRITE(8,499)NZ,NA
            INM=MIN0(12,MAXNEU)
            IZM=MIN0(12,MAXPRO)
          DO 300 NUCL=1,6                                               
            WRITE(1,500)IP90(NUCL)
            WRITE(6,500)IP90(NUCL)
            WRITE(8,500)IP90(NUCL)
          DO 300 IZ=1,IZM                                               
            WRITE(1,600)IZ,(QBON(IN,IZ,NUCL),IN=1,INM)                  
            WRITE(6,600)IZ,(QBON(IN,IZ,NUCL),IN=1,INM)                  
300         WRITE(8,600)IZ,(QBON(IN,IZ,NUCL),IN=1,INM)                  
            STOP                                                        
499   FORMAT(1X,'TEST FOR BINDING ENERGIES'/
     c1X,'M.BLANN CALCULATION FOR NZ=',I4,' NA=',I4
     c/1X,'OTHER NUCLIDES ARE OBTAINED BY CAMERON FORMULAS'
     c/1X,72(1H-))
500   FORMAT(/1X,A8/1X,'IZ   IN-----> NEUTRON NUMBER DECREASED')
600   FORMAT(1X,I2,12F6.1)
      END                                                          
************************************************************************
*                 SUBROUTINE PRIREC                                    *
************************************************************************
      SUBROUTINE PRIREC(SGX0)
* Printing of reacoil spectra in separate file
      COMMON/EMEM91/EMEMT(21),RMEMT(21),HMEMT                           
      COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                         
      COMMON/AN/AN /DATINI/RA,T0,W0 /MAIIPR/IPR                                                 
      DIMENSION EKE(21)
C --> mb
      SGX1=SGX0*1000.
               SUM = 0.0
               EKE(1) = EMEMT(1)
               DO 122 NU=2,21
122            EKE(NU)=(  EMEMT(NU-1) + EMEMT(NU)  ) / 2.
      RMEMT(1)=RMEMT(1)*SGX1/HMEMT      
      DO 121 NU=2,21                                                    
      RMEMT(NU)=RMEMT(NU)*SGX1/(EMEMT(NU)-EMEMT(NU-1)) 
121            SUM=SUM+RMEMT(NU)
               SUM=SUM*HMEMT
      WRITE(IPR,22200)                                                  
22200 FORMAT(/1X,'RECOIL SPECTRUM (LINEAR SCALE) ')
      CALL GRAPH(EKE,RMEMT,21,0)                                 
      Write(33,2000)T0,SUM,Z,AN
2000  Format(f6.1,e12.5,t40,
     c  'NEUTRON ENERGY AND SUM OF RECOIL SPECTRUM FOR TARGET ',2f6.1)
* Attention ! Last energy is not treated
                      MMAX = 21
         Write(33,2010)MMAX
2010     Format(i7,t40,'NUMBER OF KE INTERVALS FOR SPECTRUM')
         Write(33,2011)(EKE(I),I=1,MMAX)
2011     Format(10f7.3)
         Write(33,2012)(RMEMT(I),I=1,MMAX)
2012     Format(1pe10.3,7e10.3)
       RETURN
       END
************************************************************************
*                 SUBROUTINE PRISPE                                    *
************************************************************************
      SUBROUTINE PRISPE(SGX0,MP)
      COMMON/DATINI/RA,T0,W0                                             
      COMMON/EMEM/EMEM0(21),EMEM(21),RMEM(21,3),RMEM0(21,3),HMEM
      COMMON/EOUT/SPE(19,5,3),PI(19),EOUT1(5,3),EOUT2(5,3),MSPE
      COMMON/MAIIPR/IPR /MPARIN/MPARIN /AN/AN                                                      
      COMMON/SPEFUL/ANGLIM(9,2,3),ANGSUM(21,9,3),ANGCEN(9,3),DCEN,MANG
      REAL*8 ITYP(3)                                                    
      DIMENSION ANGTMP(21), GR1(19), XSTE(150),YSTE(150),PRITMP(150,23)
C dimension of EOUT1,2(I,) = EMEAN
      DIMENSION RTMP(21),EMEAN(5)
C IU is unit for printing (see open in main routine)
      IU = 70 + MP
C PRITMP is array for histogram presentation
          DATA ITYP/' NEUTRON','  PROTON','   ALPHA'/
                  DO 1 I=1,150
                  XSTE(I)=0.0
                  YSTE(I)=0.0
                  DO 1 J=1,23
1                 PRITMP(I,J)=0.0
      IF(MP.NE.3) WRITE(IPR,221)ITYP(MP)                                        
      IF(MP.EQ.3) WRITE(IPR,222)                                        
C---------------------------------------------------------------------- 
C Energy distribution
       SS1=0.
       SSS=0.
C --> mb
        SGX1=SGX0*1000.
      DO 121 NU=1,21                                                    
        SSS=SSS+RMEM0(NU,MP)                                               
        RMEM0(NU,MP)=RMEM0(NU,MP)*SGX1/HMEM                                   
        RMEM(NU,MP)=RMEM(NU,MP)*SGX1/HMEM                                     
        SS1=SS1+RMEM0(NU,MP)+RMEM(NU,MP)
121     CONTINUE
      WRITE(IPR,220)                                                    
220   FORMAT(/1X,'NON-EQUILIBRIUM SPECTRUM DS/DE ------------->')
             DO 700 NU=1,21
700          RTMP(NU) = RMEM0(NU,MP)
             CALL GRAPH(EMEM0,RTMP,21,2)                                 
             DO 1700 NU=1,21
             If(RTMP(NU).eq.0.0) RTMP(NU) = 1.E-13
1700         Continue
        SSS=SGX1*SSS
        WRITE(IPR,670)SSS
670     FORMAT(1X,'CMMA ',G12.5)
C NSTE is the number of points obtained < 150
        CALL STEP93(EMEM0,RTMP,21,XSTE,YSTE,150,NSTE,1)
        DO 2 I=1,NSTE
        PRITMP(I,1) = XSTE(I)
2       PRITMP(I,2) = YSTE(I)
             DO 701 NU=1,21
701          RTMP(NU) = RMEM(NU,MP)
      WRITE(IPR,2210)                                                   
2210  FORMAT(/1X,'EQUILIBRIUM SPECTRUM DS/DE ------------->')
      CALL GRAPH(EMEM,RTMP,21,2)                                         
             DO 1701 NU=1,21
             If(RTMP(NU).eq.0.0) RTMP(NU) = 1.E-13
1701         Continue
        CALL STEP93(EMEM ,RTMP ,21,XSTE,YSTE,150,NSTE,1)
        DO 3 I=1,NSTE
3       PRITMP(I,3) = YSTE(I)
        DO 987 NU=1,21
987     RMEM0(NU,MP)=RMEM0(NU,MP)+RMEM(NU,MP)
             DO 702 NU=1,21
702          RTMP(NU) = RMEM0(NU,MP)
C
C Total spectrum
      IF(MP.NE.3) WRITE(IPR,22100)ITYP(MP)                                      
22100 FORMAT(/1X,'TOTAL SPECTRUM - "',A8,' PRODUCTION"')
      IF(MP.EQ.3) WRITE(IPR,22101)                                      
22101 FORMAT(/1X,'TOTAL SPECTRUM - ALPHA PRODUCTION"')
            CALL GRAPH(EMEM0,RTMP,21,2)                                 
             DO 1702 NU=1,21
             If(RTMP(NU).eq.0.0) RTMP(NU) = 1.E-13
1702         Continue
        CALL STEP93(EMEM0,RTMP,21,XSTE,YSTE,150,NSTE,1)
        DO 4 I=1,NSTE
4       PRITMP(I,4) = YSTE(I)
C
C---------------------------------------------------------------------- 
C Inclusive spectra :                                                
      DO 1000 ICEN=1,MANG
      WRITE(IPR,888)ITYP(MP),ANGCEN(ICEN,MP),DCEN                                   
           PI180=3.1415926/180.                                         
      PPP0=DCEN
      QAN1 = ANGCEN(ICEN,MP)-DCEN
      IF(QAN1.LT.0.0) PPP0= ANGCEN(ICEN,MP)
      QAN1 = ANGCEN(ICEN,MP)+DCEN
      IF(QAN1.GT.180.0) PPP0= 180.0-ANGCEN(ICEN,MP)
      PPP0=PPP0+DCEN
           PPP= PPP0*(3.1415/180.)*2.*3.1415
           ANG=PI180*ANGCEN(ICEN,MP)
      DO 322 NU=1,21
322   ANGTMP(NU)=0.0
      DO 323 NU=1,21                                                    
        ANGTMP(NU)     =ANGSUM(NU,ICEN,MP)*SGX1/HMEM                       
323     ANGTMP(NU)     =ANGTMP(NU)     /(PPP*SIN(ANG) )                 
      CALL GRAPH(EMEM0,ANGTMP,21,2)                                    
             DO 1323 NU=1,21
             If(ANGTMP(NU).eq.0.0) ANGTMP(NU) = 1.E-13
1323         Continue
        CALL STEP93(EMEM0,ANGTMP,21,XSTE,YSTE,150,NSTE,1)
        DO 5 I=1,NSTE
5       PRITMP(I,4+ICEN) = YSTE(I)
1000    CONTINUE
C
      DO 2000 L=1,MSPE
C---------------------------------------------------------------------- 
C Total angular distribution
      WRITE(IPR,777)EOUT1(L,MP),EOUT2(L,MP)
      EOUEOU=1./(EOUT2(L,MP)-EOUT1(L,MP))
      GR1(1)=0.                                                        
      DO 97 NANG=2,19                                                   
   97 GR1(NANG)=GR1(NANG-1)+10.                                        
      PI180=3.1415926/18.                                               
        PPP=(3.1415/18.)*2.*3.1415
      SPE(19,L,MP)=0.                                                        
      ANG=0.                                                            
      DO 99 NANG=1,18                                                   
      ANG=ANG+PI180 
      ANG2=ANG - 5.*3.1415926/180.
   99   SPE(NANG,L,MP)=SGX1*SPE(NANG,L,MP)*EOUEOU/(PPP*SIN(ANG2))
           DO 703 NANG=1,19
703        RTMP(NANG) = SPE(NANG,L,MP)
           CALL GRAPH(GR1,RTMP,19,2)                                      
               DO 1703 NU=1,21
               If(RTMP(NU).eq.0.0) RTMP(NU) = 1.E-13
1703           Continue
        CALL STEP93(GR1  ,RTMP  ,19,XSTE,YSTE,150,NSTE1,2)
        DO 6 I=1,NSTE1
        IF(L.EQ.1) PRITMP(I,13+L) = XSTE(I)
6       PRITMP(I,14+L) = YSTE(I)
2000  CONTINUE 
C---------------------------------------------------------------------- 
        DO 49 I=1,5
49      EMEAN(I) = 0.5*(EOUT1(I,MP)+EOUT2(I,MP))
C
C PRITMP printing
      WRITE(IU,7001)T0
7001  Format(1X,'" T0=',f7.1,' "')
      WRITE(IU,7000)(ANGCEN(I,MP),I=1,9),(EMEAN(II),II=1,5)
7000  FORMAT(1X,5X,'"E"',6X,'"NEQ"',5X,'"EQ"',6X,'"TOT"'1X,
     # 9(2X,'"',F5.1,'"'), 2X,'" TETA "',  5(2X,'"',F6.1,'"'))
      DO 50 I=1,NSTE
      IF(I.GT.20)WRITE(IU,5000)(PRITMP(I,NN),NN=1,19)
5000  FORMAT(1X,1PE10.2,18E10.2)
      IF(I.EQ.1)WRITE(IU,5001)(PRITMP(I,NN),NN=1,19),ITYP(MP)
5001  FORMAT(1X,1PE10.2,18E10.2,'   EMITTED PARTICLE: ',A8)
      IF(I.EQ.2)WRITE(IU,5002)(PRITMP(I,NN),NN=1,19)
5002  FORMAT(1X,1PE10.2,18E10.2,'  "A": ENERGY FOR COLUMNS "B"-"M" ')
      IF(I.EQ.3)WRITE(IU,5003)(PRITMP(I,NN),NN=1,19)
5003  FORMAT(1X,1PE10.2,18E10.2,'  "B":DS/DE(PRE), "C":(EQ), "D":(TOT)')
      IF(I.EQ.4)WRITE(IU,5004)(PRITMP(I,NN),NN=1,19)
5004  FORMAT(1X,1PE10.2,18E10.2,'  "E"-"M": D2S/DExDO')
      IF(I.EQ.5)WRITE(IU,5005)(PRITMP(I,NN),NN=1,19),ANGCEN(1,MP)
5005  FORMAT(1X,1PE10.2,18E10.2,'  "E":',0PF6.1)
      IF(I.EQ.6)WRITE(IU,5006)(PRITMP(I,NN),NN=1,19),ANGCEN(2,MP)
5006  FORMAT(1X,1PE10.2,18E10.2,'  "F":',0PF6.1)
      IF(I.EQ.7)WRITE(IU,5007)(PRITMP(I,NN),NN=1,19),ANGCEN(3,MP)
5007  FORMAT(1X,1PE10.2,18E10.2,'  "G":',0PF6.1)
      IF(I.EQ.8)WRITE(IU,5008)(PRITMP(I,NN),NN=1,19),ANGCEN(4,MP)
5008  FORMAT(1X,1PE10.2,18E10.2,'  "H":',0PF6.1)
      IF(I.EQ.9)WRITE(IU,5009)(PRITMP(I,NN),NN=1,19),ANGCEN(5,MP)
5009  FORMAT(1X,1PE10.2,18E10.2,'  "I":',0PF6.1)
      IF(I.EQ.10)WRITE(IU,5010)(PRITMP(I,NN),NN=1,19),ANGCEN(6,MP)
5010  FORMAT(1X,1PE10.2,18E10.2,'  "J":',0PF6.1)
      IF(I.EQ.11)WRITE(IU,5011)(PRITMP(I,NN),NN=1,19),ANGCEN(7,MP)
5011  FORMAT(1X,1PE10.2,18E10.2,'  "K":',0PF6.1)
      IF(I.EQ.12)WRITE(IU,5012)(PRITMP(I,NN),NN=1,19),ANGCEN(8,MP)
5012  FORMAT(1X,1PE10.2,18E10.2,'  "L":',0PF6.1)
      IF(I.EQ.13)WRITE(IU,5013)(PRITMP(I,NN),NN=1,19),ANGCEN(9,MP)
5013  FORMAT(1X,1PE10.2,18E10.2,'  "M":',0PF6.1)
      IF(I.EQ.14)WRITE(IU,5014)(PRITMP(I,NN),NN=1,19)
5014  FORMAT(1X,1PE10.2,18E10.2,'  "N"-"S": D2S/DExDO FOR E1-E2')
      IF(I.EQ.15)WRITE(IU,5015)(PRITMP(I,NN),NN=1,19)
5015  FORMAT(1X,1PE10.2,18E10.2,'  "N":  ANGLES FOR COLUMNS "O"-"S" ')
      IF(I.EQ.16)WRITE(IU,5016)(PRITMP(I,NN),NN=1,19),EOUT1(1,MP),
     +                         EOUT2(1,MP)
5016  FORMAT(1X,1PE10.2,18E10.2,'  "O":',0PF7.1,'-',F7.1,' EV')
      IF(I.EQ.17)WRITE(IU,5017)(PRITMP(I,NN),NN=1,19),EOUT1(2,MP),
     +                         EOUT2(2,MP)
5017  FORMAT(1X,1PE10.2,18E10.2,'  "P":',0PF7.1,'-',F7.1,' MEV')
      IF(I.EQ.18)WRITE(IU,5018)(PRITMP(I,NN),NN=1,19),EOUT1(3,MP),
     +                         EOUT2(3,MP)
5018  FORMAT(1X,1PE10.2,18E10.2,'  "Q":',0PF7.1,'-',F7.1,' MEV')
      IF(I.EQ.19)WRITE(IU,5019)(PRITMP(I,NN),NN=1,19),EOUT1(4,MP),
     +                         EOUT2(4,MP)
5019  FORMAT(1X,1PE10.2,18E10.2,'  "R":',0PF7.1,'-',F7.1,' MEV')
      IF(I.EQ.20)WRITE(IU,5020)(PRITMP(I,NN),NN=1,19),EOUT1(5,MP),
     +                         EOUT2(5,MP)
5020  FORMAT(1X,1PE10.2,18E10.2,'  "S":',0PF7.1,'-',F7.1,' MEV')
50    CONTINUE
C
C**********************************************************************
  221 FORMAT(/72('=')/1X,10X,'EMISSION SPECTRA FOR  ',A8,
     +'S   (MB/MEV...)')        
  222 FORMAT(/72('=')/1X,10X,'EMISSION SPECTRA FOR ALPHA-PARTICLE',
     +'S (MB/MEV...)')        
  777 FORMAT(/1X,10X,'TOTAL ANGULAR DISTRIBUTION FOR ENERGY RANGE:'/1X,         
     +2X,'EOUT1=',F6.1,2X,'EOUT2=',F6.1)                                
  888 FORMAT(/1X,A8,':  ','INCLUSIVE SPECTRUM FOR ANGLE ',
     +F6.1,'  +/- ',F6.1) 
      RETURN
      END
************************************************************************
*               SUBROUTINE PROZR                                       *
************************************************************************
      SUBROUTINE PROZR(TP,TT,JIN,KEY,M)
C Sub-barrier proton penetration
      COMMON/DAINT/PF(33,4),RO1(33),RZON(33),FIG                 
      COMMON/TFERMI/TF(34,4) /RNUCL/RNUCL /K/KF                                                
      COMMON/URAND1/IYG                                                 
      KEY=0
      T=TP-TF(JIN,M)+TF(KF+1,M)                                               
      IF(T.LE.0.)RETURN
      B=TT-TF(JIN,M)+TF(KF+1,M)                                               
      STB=SQRT(T/B)
         GAMMA = ( ACOS(STB)/STB ) - SQRT(1.-T/B)
         G = -2.*RNUCL/(4.5/SQRT(B))
      D=EXP(G*GAMMA)
      O=RANDOMG(0)                                                      
      IF(O.LE.D) KEY=1
      RETURN
      END
************************************************************************
*                 SUBROUTINE QBOND                                     *
************************************************************************
       SUBROUTINE QBOND(EXCIT,WIDTH,TAUX,KEY)             
       DOUBLE PRECISION UCLA,RELX
       COMMON/BOND1/QBON(200,200,6)                                     
       COMMON/EVAMAS/NEVAN,NEVAP,NEVAD,NEVAT,NEVAHE,NEVAAL              
       COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
       COMMON/INIQBO/Z,CKA,CKB,RPA,RPB,RALA,RALB                        
       COMMON/I1988/I1988 /QBOCFU/NSUMN,NSUMP                                      
       COMMON/MAX/MAXNEU,MAXPRO /AN/AN                                    
       COMMON/LAB4/UCLA(6,2000) /INCR/ED
       DIMENSION RELX(6),WIDTH(6),TAUX(6)
       KEY=0
       NSUMN=1+NPREN+NEVAN+NEVAD+2*NEVAT+NEVAHE+2*(NEVAAL+NPREA)                 
       NSUMP=1+NPREP+NEVAP+NEVAD+NEVAT+2*NEVAHE+2*(NEVAAL+NPREA)                 
       IF(NSUMN.GT.MAXNEU.OR.NSUMP.GT.MAXPRO)GOTO 100                    
C
C 1-N, 2-P, 3-D, 4-T, 5-HE3, 6-A
C  QN =QBON( , ,1)   QP=QBON( , ,2)   QD=QBON( , ,3)                                          
C  QT =QBON( , ,4)   QHE=QBON( , ,5)  QAL=QBON( , ,6)                                         
C
        DO 1 K = 1,6
        RELX(K) = 0.0
        TAUX(K) = EXCIT - QBON(NSUMN,NSUMP,K)
        IX   =INT(TAUX(K)/ED+1.)
C to avoid overloading
        IF(IX.gt.2000) IX = 2000
        IF(IX.lt.1) goto 1
        RELX(K) = UCLA(K,IX) 
    1   CONTINUE 
        DO 2 K=2,6
    2   RELX(K) = RELX(K-1)+RELX(K)
        IF(RELX(6).eq.0.D+00) RETURN 
        KEY = 1
C normalize on 1
        DO 3 K=1,6
C "+1.E-04" is to avoid cycling
    3   WIDTH(K) = (RELX(K)/RELX(6)) + 1.D-04
        RETURN
  100   I1988=I1988+1                                                   
        RETURN
        END                                                               
************************************************************************
*                 SUBROUTINE QUES                                      *
************************************************************************
      SUBROUTINE QUES(RORM,T,W,JIN,M,IGEN)                              
      COMMON/TFERMI/TF(34,4) /RNUCL/RNUCL  COMMON/R001/R001                                                  
      COMMON/MASTR1/WN(21,21) /DATINI/RA,T0,W0                          
      COMMON/DAINT/PF(33,4),RO1(33),RZON(33),FIG                 
      COMMON/DATTR1/QNN,QPP /MPARIN/MPARIN/K/KF
C                            no check ?
                  IF(M.EQ.3) goto 3    
C Asymptotic energy must be lower than EMAX
                  TA=T+TF(KF+1,M)-TF(JIN,M)                                   
      IF(M.EQ.1.AND.MPARIN.EQ.1) EMAX = T0                              
      IF(M.EQ.1.AND.MPARIN.EQ.2) EMAX = T0 + QPP - QNN                  
      IF(M.EQ.2.AND.MPARIN.EQ.1) EMAX = T0 + QNN - QPP                  
      IF(M.EQ.2.AND.MPARIN.EQ.2) EMAX = T0                              
         IF(TA.LE.EMAX) GOTO 3
         IGEN=1
         RETURN
3     TX=T-TF(JIN,M)+TF(JIN+1,M)                                            
         IF(TX.LT.0.0    ) RETURN
      PX=SQRT(TX*(TX+2.*W))                                             
         IF(RORM.GT.(PX*RZON(JIN)) )IGEN=1                              
      IF(IGEN.EQ.1)R001=R001+1.                                         
      RETURN                                                            
      END                                                               
************************************************************************
*                 FUNCTION RANDOMG                                      *
************************************************************************
       FUNCTION RANDOMG(NO ARGUMENTS)
*
* random number generator
*
**** GNU Fortran pseudo random generator:
****
****
          RANDOMG=RAND(0)
**
**
** WATCOM Fortram pseudo random number generator
** generator is initialized in Subroutine OPTIONS
**
cccc  Common/urand1/iyg
cccc  RANDOM=URAND(iyg)
**
      Return
      End
************************************************************************
*               SUBROUTINE REGR1                                       *
************************************************************************
       SUBROUTINE REGR1(X1,X2,Y1,Y2,A,B)                                
       RR=X2-X1                                                         
       A=(Y2-Y1)/RR                                                     
       B=(Y1*X2-X1*Y2)/RR                                               
       RETURN                                                           
       END                                                              
************************************************************************
*                 SUBROUTINE SCILSK                                    *
************************************************************************
      SUBROUTINE SCILSK(I,G,T1,W1,IGEN,M1)                              
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/ACTSCI/PIN1,PIN2,PIN3,WPX,RK3,RK4,GAMMA,SK2,VC2,VCX,       
     +VCY,VCZ,MPX                                                       
      COMMON/SCIMEM/WPM,PXM,PYM,PZM,PM,TM,EM,XM,YM,ZM,RM,JINM,MM        
      COMMON/IMOM/IMOM                                                  
      IF(G)1,1,2                                                        
    1 RK=RK4-(GAMMA-1.)*SK2/VC2                                         
      GOTO 3                                                            
    2 RK=RK3+(GAMMA-1.)*SK2/VC2                                         
    3 IF(I)4,4,50                                                       
    4 PX5=G*PIN1+RK*VCX                                                 
      PY5=G*PIN2+RK*VCY                                                 
      PZ5=G*PIN3+RK*VCZ                                                 
      P5=SQRT(PX5*PX5+PY5*PY5+PZ5*PZ5)                                  
      T5=T1                                                             
      IF(IMOM.EQ.0)GOTO 21                                              
      RORM=ORBIT(PX5,PY5,PZ5,X,Y,Z)                                     
      CALL QUES(RORM,T5,W1,JIN,M1,IGEN)                                 
      IF(IGEN.EQ.1)RETURN                                               
   21 PX=PX5                                                            
      PY=PY5                                                            
      PZ=PZ5                                                            
      P=P5                                                              
      T=T5                                                              
      WP=W1                                                             
      E=T+W1                                                            
      M=M1                                                              
      RETURN                                                            
   50 PX5=-PIN1+RK*VCX                                                  
      PY5=-PIN2+RK*VCY                                                  
      PZ5=-PIN3+RK*VCZ                                                  
      P5=SQRT(PX5*PX5+PY5*PY5+PZ5*PZ5)                                  
      T5=T1                                                             
      IF(IMOM.EQ.0)GOTO 121                                             
      RORM=ORBIT(PX5,PY5,PZ5,X,Y,Z)                                     
      CALL QUES(RORM,T5,W1,JIN,MPX,IGEN)                                
      IF(IGEN.EQ.1)RETURN                                               
  121 PXM=PX5                                                           
      PYM=PY5                                                           
      PZM=PZ5                                                           
      PM=P5                                                             
      TM=T5                                                             
      WPM=W1                                                            
      EM=T1+W1                                                          
      XM=X                                                              
      YM=Y                                                              
      ZM=Z                                                              
      RM=R                                                              
      JINM=JIN                                                          
      MM=MPX                                                            
      RETURN                                                            
      END                                                               
************************************************************************
*                  SUBROUTINE SIGICH                                   *
************************************************************************
      SUBROUTINE SIGICH(ZEFF,AEFF)
      COMMON/LAB3/SIG(6,2000)/DATREN/RL0N,RL1N,RM0N,RM1N,RN0N,RN1N,RN2N
      COMMON/DATREP/P0P,P1P,P2P,RL0P,RL1P,RM0P,RM1P,RN0P,RN1P,RN2P
      COMMON/DATREA/P0A,P1A,P2A,RL0A,RL1A,RM0A,RM1A,RN0A,RN1A,RN2A
      COMMON/INCR/ED
* IPAR =0 Chatterjee compilation, =1 Blann inverse cross-section
* IPARR=0 minimum printing
         IPAR=0
         IPARR=0
C 1-N, 2-P, 3-D, 4-T, 5-HE3, 6-A
  2      IF(IPAR.EQ.1)WRITE(8,290)
      DO 6 I=1,2000
      DO 6 K=1,6
  6   SIG(K,I)=0.
C NEUTRON
          AN=AEFF-1.
          AN13=AN**0.333333333
          AN23=AN13*AN13
          RL11N=(RL0N/AN13+RL1N)
          RM11N=RM0N*AN13+RM1N*AN23
          RN11N=(RN0N*AN23*AN23+RN1N*AN23+RN2N)
C PROTON
          AP=AEFF-1.
          ZP=ZEFF-1.
          ECOP=1.44*ZP/(1.5*(AP**0.3333333333))
          EC2=ECOP*ECOP
          AM=AP**RM1P
          P11P=P0P+P1P/ECOP+P2P/EC2
          RL11P=RL0P*AP+RL1P
          RM11P=RM0P*AM
          RN11P=AM*(RN0P+RN1P*ECOP+RN2P*EC2)
C ALPHA
          AA=AEFF-4.
          ZA=ZEFF-2.
          ECOA=2.88*ZA/(1.5*(AA**0.3333333333)+1.2)
          EC2=ECOA*ECOA
          AM=AA**RM1A
          P11A=P0A+P1A/ECOA+P2A/EC2
          RL11A=RL0A*AA+RL1A
          RM11A=RM0A*AM
          RN11A=AM*(RN0A+RN1A*ECOA+RN2A*EC2)
      RP=1.21*((AEFF-1.)**.3333+1.)
      RD=1.21*((AEFF-2.)**.3333+1.260)
      RA=1.21*((AEFF-4.)**.3333+1.587)
           CONRP=31.42*RP*RP
           CONRA=31.42*RA*RA
           CONRD=31.42*RD*RD
      VD=(ZEFF-1.)*1.32/(RD+1.6)
C
      IF(IPAR.EQ.0)    CALL COULCH(VP,VA,IPAR,AEFF,ZEFF,
     +P11P,RL11P,RM11P,RN11P,ECOP,P11A,RL11A,RM11A,RN11A,ECOA)
      IF(IPAR.EQ.1)VP=(ZEFF-1.)*1.15/(RP+1.6)
      IF(IPAR.EQ.1)VA=(ZEFF-2.)*2.64/(RA+1.6)
         RMP=1.-1./AEFF
         RMD=3.-6./AEFF
         RMT=3.-9./AEFF
         RMH=3.-9./AEFF
         RMA=2.-8./AEFF
C EPEHOPMPOBKA CEEH  HETPOHOB P HEP < 1 MB
      RCH=1.
      IF(IPAR.EQ.0) RCH = ( RL11N+RM11N+RN11N ) /
     +                    ( 31.42*(RP+3.4/SQRT(1.+.5))**2 )
      DO 10 IK=1,2000
      EI=FLOAT(IK)*ED-ED/2.
         E1=EI
         IF(E1.GT.50.)E1=50.
C N
      IF(IPAR.EQ.1)SIG(1,IK)=31.42*(RP+3.4/SQRT(EI+.5))**2
      IF(IPAR.EQ.0.AND.EI.GE.1.)SIG(1,IK)=RL11N*E1+RM11N+RN11N/E1
      IF(IPAR.EQ.0.AND.EI.LT.1.)SIG(1,IK)=
     +                          RCH * ( 31.42*(RP+3.4/SQRT(EI+.5))**2 )
        IF(SIG(1,IK).LT.0.)IPAR=1
        IF(SIG(1,IK).LT.0.)GOTO 2
C D
      IF(VD.GE.EI) GO TO 11
      SIG(3,IK) = CONRD*(1.-VD/EI)
C P
   11 IF(VP.GE.EI)GO TO 10
      IF(IPAR.EQ.1)SIG(2,IK)=CONRP*(1.-VP/EI)
      EKSI=AMAX1(E1,ECOP)
      IF(IPAR.EQ.0)SIG(2,IK)=
     +P11P*((E1-EKSI)**2)+RL11P*E1+RM11P+RN11P*(2.-E1/EKSI)/EKSI
        IF(SIG(2,IK).LT.0.)IPAR=1
        IF(SIG(2,IK).LT.0.)GOTO 2
C A
      IF(VA.GE.EI) GO TO 10
      IF(IPAR.EQ.1)SIG(6,IK)=CONRA*(1.-VA/EI)
      EKSI=AMAX1(E1,ECOA)
      IF(IPAR.EQ.0)SIG(6,IK)=
     +P11A*((E1-EKSI)**2)+RL11A*E1+RM11A+RN11A*(2.-E1/EKSI)/EKSI
        IF(SIG(6,IK).LT.0.)IPAR=1
        IF(SIG(6,IK).LT.0.)GOTO 2
10    CONTINUE
C D=T, HE3 = A 
      DO 20 IK=1,2000
      SIG(4,IK)=SIG(3,IK)
   20 SIG(5,IK)=SIG(6,IK)
      IF(IPARR.eq.0) goto 151
      DO 150 K=1,6
      GO TO (201,202,203,204,205,206),K
  201 WRITE(7,211) RCH
  211 FORMAT(/,38X,'CHAT-BLANN NEUTRON INVERSE CROSS SECTIONS'
     +,'  ( ',G12.5,' )'/)
      GO TO 135
  202 WRITE(7,222)
  222 FORMAT(//38X,'CHATTERJEE PROTON INVERSE CROSS SECTIONS'/)
      GO TO 135
  203 WRITE(7,233)
  233 FORMAT(//37X,'SHARP CUTOFF DEUTERON INVERSE CROSS SECTIONS'/)
      GO TO 135
  204 WRITE(7,244)
  244 FORMAT(//37X,'SHARP CUTOFF TRITON=D INVERSE CROSS SECTIONS'/)
      GO TO 135
  205 WRITE(7,255)
  255 FORMAT(//37X,'CHATTERJEE HE3=ALPHA INVERSE CROSS SECTIONS'/)
      GO TO 135
  206 WRITE(7,266)
  266 FORMAT(//39X,'CHATTERJEE ALPHA INVERSE CROSS SECTIONS'/)
  135 WRITE(7,145) (SIG(K,JE),JE=1,2000)
  145 FORMAT ( 1H ,10F7.0)
  150 CONTINUE
  151 DO 200 K=1,2000
      EI=(FLOAT(K)*ED-ED/2.)*ED
      SIG(1,K)=SIG(1,K)*EI*RMP
      SIG(2,K)=SIG(2,K)*EI*RMP
      SIG(3,K)=SIG(3,K)*EI*RMD
      SIG(4,K)=SIG(4,K)*EI*RMT
      SIG(5,K)=SIG(5,K)*EI*RMH
 200  SIG(6,K)=SIG(6,K)*EI*RMA
      RETURN
  290 FORMAT(1X,'FOR Z TREATED BLANN SHARP CUTOFF APPROX. IS USED')
      END
************************************************************************
*                  FUNCTION SIGION                                     *
************************************************************************
      FUNCTION SIGION(ISS,A1,Z1,A2,Z2,T)
C Written by Barashenkov, Polanski
C     FOR CALCULATION OF NUCLEUS-NUCLEUS TOTAL(ISS=1) 
C     AND INELASTIC(ISS=2) CROSS SECTIONS 
C     A1,Z1 - PROJECTILE MASS AND CHARGE NUMBERS (A1>1) 
C     A2,Z2 - THE SAME FOR TARGET NUCLEUS(3<A2<240)
C     T - LAB. KINETIC ENERGY OF PROGECTALE (1 MEV/NUCLEON< T <1 TEV/NUCLEON)
      COMMON/CX/CX(38)
      COMMON /FH/AMP,AMT,AP,AT,B0,R0
      IS=3-ISS
      IF(IS.LE.0) RETURN
      IF(A1.LT.1.0.OR.A1.GT.240.0.OR.A2.LT.3.0.OR.A2.GT.240.) GO TO 101 
      IF(ABS(Z1).LT.1.0) GO TO 101
      IF(T.LT.1.0) GO TO 101
      SIGION=0.
      TP=T/A1
      AP=A1**0.333333
      AT=A2**0.333333
      AMP=A1*930.63
      AMT=A2*930.63
C     PARAMETER FOR CALCULATION OF NUCLEAR RADIUS
      R0=1.4
      IF(ABS(A1-4.) .LT. 0.1) R0=1.3
      B0=1.44*Z1*Z2
      I=1
       IF(IS.EQ.2) I=20
C     SELECTION OF PROJECTILE
C     HEAVY ION
      IF(A1.GT.4.1) N=I
C     ALFA,HELION,TRITON
      IF(A1.GT.2.1 .AND. A1.LT.4.1) N=I+6
C     DEUTERON
      IF(A1.LT.2.1) N=I+12
C     HIGH-ENERGY CROSS-SECTION
C     SELECTION OF PROJECTILE ENERGY
      IF(TP.LT.CX(N+1)) K=2
      IF(TP.LT.CX(N+4)) K=5
C     CROSS-SECTION PARAMETERS
      C=CX(I)
      IF(TP.LT.CX(N+1)) C=CX(N+K)+CX(N+K+1)*LOG10(TP)
      CP=CX(N+5)+CX(N+6)
      IF(TP.LT.10.) GO TO 1
C     HIGH-ENERGY CROSS-SECTION
      SIGION=FHS(IS,T,C)
      RETURN
C     CALCULATION OF LOW-ENERGY CROSS-SECTION
C     NORMALIZATION OF HIGH-ENERGY CROSS-SECTION
 1     SH10=FHS(IS,10.*A1,CP)
      R0=1.45
      IF(ABS(A1-4.).LT. 0.1) R0=1.4
C     RENORMALIZED COULOMB BARRIER
      B=B0/R0/(AP+AT)
C     LOW-ENERGY CROSS-SECTION
      SIGION=SH10*FC(T,B)/FC(10.*A1,B)
      IF(SIGION) 101,100,100
  101 WRITE(6,1001)
 1001 FORMAT(' ERROR IN INPUT OF PARAMETERS OF FUNCTION SIGION')
  100 CONTINUE
      RETURN
      END
************************************************************************
*                 SUBROUTINE STEP93                                    *
************************************************************************
C Histograms             
          SUBROUTINE STEP93(E,CS,ND1,ERES,CSRES,ND2,JMAX,LL)
C If LL = 1 - energy distributions 
C    LL = 2 - angular distributions
C ND2 must be < 150
          DIMENSION E(ND1),CS(ND1),ERES(ND2),CSRES(ND2)
          N = ND1
            N1 = N - 1
            ERES(1) = E(1)
            CSRES(1) = CS(1)
                                   J=2
          DO 300 I=1,N1
          GOTO(1,2),LL
1         ERES(J) = E(I)
          CSRES(J) = CS(I+1)
              ERES(J+1) = E(I+1)
              CSRES(J+1) = CS(I+1)
          GOTO 3
2         ERES(J) = E(I+1)
          CSRES(J) = CS(I)
              ERES(J+1) = E(I+1)
              CSRES(J+1) = CS(I+1)
3         J = J+2
          IF(J.GT.150)then 
                      PRINT 10000
                      WRITE(8,10000)
                      RETURN
                      endif
300       CONTINUE
          GOTO(11,22),LL
11        ERES(J) = E(N)
          CSRES(J) = 1.0E-13
          JMAX=J
          RETURN
22        JMAX=J-2
          RETURN
10000     FORMAT(1X,' STEP93:  Dimension of arrays exceeded.  ','
     c    No histograms ')
          END
************************************************************************
*                 SUBROUTINE TRANS                                     *
************************************************************************
      SUBROUTINE TRANS(J1,J2,ITR9)                                      
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      COMMON/R003/R003 /R008/R008 /NREJ/REFR,NREJ                                             
                       ITR9=0
      T7=T                                                              
      CALL CROZON(J1,J2,WP,P1,T7,M)
      QCOS=(PX*X+PY*Y+PZ*Z)/(P*R)                                       
      QSIN=SQRT(ABS(1.-QCOS*QCOS))                                      
      QSIN1=QSIN*P/P1                                                   
      IF(QSIN1-1.)20,10,10                                              
C Reflection                                                            
   10 RK1=-2.*P*QCOS/R                                                  
      R003=R003+1.                                                      
      R008=R008+1.                                                      
      IF(R008.GT.REFR) THEN  
                       ITR9=1                                  
                       RETURN                                  
                       ENDIF  
      GOTO 30                                                           
   20 J1=J2                                                             
      T=T7                                                              
                     RK1=0.
      If(QCOS.ne.0.0)RK1=((P1*QCOS/ABS(QCOS))*SQRT(ABS(1.-QSIN1**2))-
     *P*QCOS)/R                                                         
      P=P1                                                              
   30     PX=PX+X*RK1                                                   
          PY=PY+Y*RK1                                                   
          PZ=PZ+Z*RK1                                                   
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE TREAT1                                    *
************************************************************************
      SUBROUTINE TREAT1                                                 
      COMMON/MASTR1/WN(21,21) /DATINI/RA,T0,W0                                            
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/TR1EVA/EXCIT,WMAI /TR1TR2/VAICX,VAICY,VAICZ                                   
      COMMON/QSUM/QSUM /URAND1/IYG                                                 
      COMMON/QNNN/QNNN /MAIIPR/IPR /INF001/INFKAL
      N1 = NPREN + 2*NPREA + 1
      N2 = NPREP + 2*NPREA + 1
         IF(N1.GT.21.OR.N2.GT.21)GOTO 100                         
      WMAI=WN(N1,N2)                                          
      PZ0=SQRT(T0*(T0+2.*W0))                                           
C
      IF(INFKAL.EQ.1)CALL AUXANG
      EXCIT=QNNN-QSUM+                                                  
     *T0-TW-(PWX*PWX+PWY*PWY+(PWZ-PZ0)**2)/(2.*WMAI)                    
      VAICX=-PWX/WMAI                                                   
      VAICY=-PWY/WMAI                                                   
      VAICZ=(PZ0-PWZ)/WMAI                                              
      RETURN                                                            
100   WRITE(IPR,101)N1,N2                                        
101   FORMAT(1X,'ERROR IN SUBROUTINE TREAT1: '/1X,' N1  OR',        
     +'  N2 EXCEED MAXIMUM '/1X,' N1=',I5,' N2=',I5)         
       STOP                                                             
       END                                                              
************************************************************************
*                 SUBROUTINE TREAT2                                    *
************************************************************************
      SUBROUTINE TREAT2                                                 
      COMMON/TR1TR2/V1,V2,V3 /EVATR2/W,VX,VY,VZ /MAIIPR/IPR                                                 
      COMMON/TR2CFU/RECOIL /INFDIS/INFDIS,INFOUP(3)
      COMMON/EMEM91/EMEMT(21),RMEMT(21),HMEMT                           
      COMMON/LIB91/WINLIB(100,250),INFLIB                               
C
      IF(INFLIB.EQ.1) CALL LIBGEN
      RECOIL=W*0.5*((V1+VX)**2+(V2+VY)**2+(V3+VZ)**2)                   
      IF(INFDIS.EQ.0)RETURN
C Recoil spectrum
      DO 10 NU=1,21                                                     
      IF(RECOIL.LE.EMEMT(NU))GOTO 50                                    
   10 CONTINUE                                                          
           WRITE(IPR,20)RECOIL                                          
   20      FORMAT(1X,' CONTROL SUBR TREAT2.   RECOIL=',G12.5)                
           RETURN                                                         
   50 RMEMT(NU)=RMEMT(NU)+1.                                            
      RETURN
      END                                                               
************************************************************************
*                 FUNCTION VELOC                                       *
************************************************************************
      FUNCTION VELOC(WPAR,W0,E)                                         
      VELOC=SQRT(2.*WPAR*E/(W0*(W0+WPAR)))                              
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE WERO                                      *
************************************************************************
      SUBROUTINE WERO(PFM,PP,MX)
      COMMON/BOND1/QBON(200,200,6)                                      
      COMMON/URAND1/IYG                                                 
      GOTO(1,1,3,4),MX
C
C NEUTRON, PROTON
    1 IPOWER = 2
      PFMAX = PFM**IPOWER
C
   10    CC=RANDOMG(0)
         CC1=RANDOMG(0)
      GGG=PFM*CC                                                        
      IF( (GGG**IPOWER) - PFMAX*CC1 )10,20,20                            
   20 PP=GGG                                                            
      RETURN                                                            
C
C ALPHA-PARTICLE
    3 IPOWER = 8
      PFMAX = PFM**IPOWER
  100    CC=RANDOMG(0)
         CC1=RANDOMG(0)
      GGG=PFM*CC                                                        
      IF( (GGG**IPOWER) - PFMAX*CC1 )100,200,200                            
  200 PP=GGG                                                            
      RETURN                                                            
C
C TRITON, HE-3
4     IPOWER = 6
      PFMAX = PFM**IPOWER
 1000    CC=RANDOMG(0)
         CC1=RANDOMG(0)
      GGG=PFM*CC                                                        
      IF( (GGG**IPOWER) - PFMAX*CC1 )1000,2000,2000
 2000 PP=GGG                                                            
      RETURN                                                            
      END
************************************************************************
*                 FUNCTION WM                                          *
************************************************************************
      FUNCTION WM(M)                                                    
C  1 - N
C  2 - P
C  3 - A
C  4 - T, HE3
C  5 - D
      WM=938.2796                                                       
      GOTO(1,2,3,4,5),M
1     WM=939.5731                                             
      RETURN
2     WM=938.2796 
      RETURN
3     WM=3726.
      RETURN
4     WM=2794.5
      RETURN
5     WM=1863.
      RETURN
      END                                                               
************************************************************************
*                   SUBROUTINE ZERLIB                                  *
************************************************************************
      SUBROUTINE ZERLIB                                                 
      COMMON/LIB91/WINLIB(100,250),INFLIB                               
      DO 1 I=1,100
      DO 1 J=1,250
1     WINLIB(I,J)=0.
      RETURN
      END
************************************************************************
*                   SUBROUTINE ZERO1                                   *
************************************************************************
      SUBROUTINE ZERO1                                                  
      COMMON/MASOUT/WDIS(990),K1(990),K2(990),K3(990),K4(990),          
     +K5(990),K6(990),K7(990),K8(990),K9(990),K10(990),KN
      COMMON/NPROL/NPROL /R001/R001 /R003/R003                                                  
      COMMON/R005/R005 /IX190/IX191,IX192,IX193                                    
      COMMON/NREJ/REFR,NREJ /AUXIL/ICOU1,ICOU2
      COMMON/SUM90/ER90,KER90
      COMMON/INFSEP/KSEP(100,4),INFSEP,JSEPM                            
      DO 10 I=1,990                                                     
      WDIS(I)=0.                                                        
      K1(I)=0                                                           
      K2(I)=0                                                           
      K3(I)=0                                                           
      K4(I)=0                                                           
      K5(I)=0                                                           
      K6(I)=0                                                           
      K7(I)=0                                                           
      K8(I)=0                                                           
      K9(I)=0                                                           
   10 K10(I)=0                                                           
      KN=0                                                              
      NPROL=0                                                           
      R001=0.                                                           
      R003=0.                                                           
      R005=0.                                                           
      IX191=0                                                           
      IX192=0                                                           
      IX193=0                                                           
      NREJ=0                                                            
      ICOU1=0
      ICOU2=0
      ER90=0.
      KER90=0
      DO 100 I=1,100                                                  
100   KSEP(I,4)=0
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE ZERO2                                     *
************************************************************************
      SUBROUTINE ZERO2                                                  
      COMMON/INTTR1/PWX,PWY,PWZ,TW,NPREN,NPREP,NPREA
      COMMON/EVATR2/WEIG,VX,VY,VZ /EVAMAS/N1,N2,N3,N4,N5,N6             
      COMMON/JACT/JACT /NDIM/NPAR /MEMORY/U(11,20),MU(2,20) /R008/R008  
      COMMON/IZET/IZET /QSUM/QSUM /QBOCFU/NSN,NSP                                          
      PWX=0.                                                            
      PWY=0.                                                            
      PWZ=0.                                                            
      TW=0.                                                             
      VX=0.                                                             
      VY=0.                                                             
      VZ=0.                                                             
         NPREN=0                                                        
         NPREP=0                                                        
         NPREA=0                                                        
             NSN=0                                                      
             NSP=0                                                      
      N1=0                                                              
      N2=0                                                              
      N3=0                                                              
      N4=0                                                              
      N5=0                                                              
      N6=0                                                              
      JACT=0                                                            
      DO 2 I=1,11                                                       
      DO 1 J=1,20                                                       
    1 U(I,J)=0.                                                         
    2 CONTINUE                                                          
      DO 3 I=1,20                                                       
      MU(1,I)=0                                                         
    3 MU(2,I)=0                                                         
      NPAR=0                                                            
      R008=0.                                                           
      IZET=0                                                            
      QSUM=0.                                                           
      RETURN                                                            
      END                                                               
************************************************************************
*                 SUBROUTINE ZONWAY                                    *
************************************************************************
      SUBROUTINE ZONWAY(RZJ1,RZJ0,J1,J3,J2,SLINE)                       
      COMMON/PARTIC/WP,PX,PY,PZ,P,T,E,X,Y,Z,R,JIN,M                     
      IF(R-1.E-06)2,2,8                                                 
    2 SLINE=RZJ1                                                        
      RETURN                                                            
    8 QCOS=(PX*X+PY*Y+PZ*Z)/(R*P)                                       
      IF(QCOS)10,20,20                                                  
   10 D1=-1.                                                            
      J2=J3                                                             
      RRJ=RZJ0                                                          
      GOTO 30                                                           
   20 D1=1.                                                             
      J2=J1                                                             
      RRJ=RZJ1                                                          
   30 DD=(RRJ**2)-(1.-(QCOS**2))*(R**2)                                 
      IF(DD)50,50,70                                                    
   50 CONTINUE                                                          
      OOO=RRJ-RZJ1                                                      
      IF(OOO)20,60,20                                                   
   60 CONTINUE                                                          
      SLINE=0.                                                          
      RETURN                                                            
   70 CONTINUE                                                          
      SLINE=-R*QCOS+D1*SQRT(DD)                                         
      RETURN                                                            
      END                                                               
